// *** THIS FILE IS GENERATED - DO NOT EDIT ***
// See error_location_helper_generator.py for modifications

/***************************************************************************
 *
 * Copyright (c) 2023 The Khronos Group Inc.
 * Copyright (c) 2023 Valve Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ****************************************************************************/

// NOLINTBEGIN

#include "error_location_helper.h"
#include "containers/custom_containers.h"
#include <assert.h>

// clang-format off
namespace vvl {

const char* String(Func func) {
    static const std::string_view table[] = {
    {"INVALID_EMPTY", 15}, // Func::Empty
    {"vkAcquireDrmDisplayEXT", 23},
    {"vkAcquireFullScreenExclusiveModeEXT", 36},
    {"vkAcquireNextImage2KHR", 23},
    {"vkAcquireNextImageKHR", 22},
    {"vkAcquirePerformanceConfigurationINTEL", 39},
    {"vkAcquireProfilingLockKHR", 26},
    {"vkAcquireWinrtDisplayNV", 24},
    {"vkAcquireXlibDisplayEXT", 24},
    {"vkAllocateCommandBuffers", 25},
    {"vkAllocateDescriptorSets", 25},
    {"vkAllocateMemory", 17},
    {"vkBeginCommandBuffer", 21},
    {"vkBindAccelerationStructureMemoryNV", 36},
    {"vkBindBufferMemory", 19},
    {"vkBindBufferMemory2", 20},
    {"vkBindBufferMemory2KHR", 23},
    {"vkBindImageMemory", 18},
    {"vkBindImageMemory2", 19},
    {"vkBindImageMemory2KHR", 22},
    {"vkBindOpticalFlowSessionImageNV", 32},
    {"vkBindVideoSessionMemoryKHR", 28},
    {"vkBuildAccelerationStructuresKHR", 33},
    {"vkBuildMicromapsEXT", 20},
    {"vkCmdBeginConditionalRenderingEXT", 34},
    {"vkCmdBeginDebugUtilsLabelEXT", 29},
    {"vkCmdBeginQuery", 16},
    {"vkCmdBeginQueryIndexedEXT", 26},
    {"vkCmdBeginRenderPass", 21},
    {"vkCmdBeginRenderPass2", 22},
    {"vkCmdBeginRenderPass2KHR", 25},
    {"vkCmdBeginRendering", 20},
    {"vkCmdBeginRenderingKHR", 23},
    {"vkCmdBeginTransformFeedbackEXT", 31},
    {"vkCmdBeginVideoCodingKHR", 25},
    {"vkCmdBindDescriptorBufferEmbeddedSamplers2EXT", 46},
    {"vkCmdBindDescriptorBufferEmbeddedSamplersEXT", 45},
    {"vkCmdBindDescriptorBuffersEXT", 30},
    {"vkCmdBindDescriptorSets", 24},
    {"vkCmdBindDescriptorSets2KHR", 28},
    {"vkCmdBindIndexBuffer", 21},
    {"vkCmdBindIndexBuffer2KHR", 25},
    {"vkCmdBindInvocationMaskHUAWEI", 30},
    {"vkCmdBindPipeline", 18},
    {"vkCmdBindPipelineShaderGroupNV", 31},
    {"vkCmdBindShadersEXT", 20},
    {"vkCmdBindShadingRateImageNV", 28},
    {"vkCmdBindTransformFeedbackBuffersEXT", 37},
    {"vkCmdBindVertexBuffers", 23},
    {"vkCmdBindVertexBuffers2", 24},
    {"vkCmdBindVertexBuffers2EXT", 27},
    {"vkCmdBlitImage", 15},
    {"vkCmdBlitImage2", 16},
    {"vkCmdBlitImage2KHR", 19},
    {"vkCmdBuildAccelerationStructureNV", 34},
    {"vkCmdBuildAccelerationStructuresIndirectKHR", 44},
    {"vkCmdBuildAccelerationStructuresKHR", 36},
    {"vkCmdBuildMicromapsEXT", 23},
    {"vkCmdClearAttachments", 22},
    {"vkCmdClearColorImage", 21},
    {"vkCmdClearDepthStencilImage", 28},
    {"vkCmdControlVideoCodingKHR", 27},
    {"vkCmdCopyAccelerationStructureKHR", 34},
    {"vkCmdCopyAccelerationStructureNV", 33},
    {"vkCmdCopyAccelerationStructureToMemoryKHR", 42},
    {"vkCmdCopyBuffer", 16},
    {"vkCmdCopyBuffer2", 17},
    {"vkCmdCopyBuffer2KHR", 20},
    {"vkCmdCopyBufferToImage", 23},
    {"vkCmdCopyBufferToImage2", 24},
    {"vkCmdCopyBufferToImage2KHR", 27},
    {"vkCmdCopyImage", 15},
    {"vkCmdCopyImage2", 16},
    {"vkCmdCopyImage2KHR", 19},
    {"vkCmdCopyImageToBuffer", 23},
    {"vkCmdCopyImageToBuffer2", 24},
    {"vkCmdCopyImageToBuffer2KHR", 27},
    {"vkCmdCopyMemoryIndirectNV", 26},
    {"vkCmdCopyMemoryToAccelerationStructureKHR", 42},
    {"vkCmdCopyMemoryToImageIndirectNV", 33},
    {"vkCmdCopyMemoryToMicromapEXT", 29},
    {"vkCmdCopyMicromapEXT", 21},
    {"vkCmdCopyMicromapToMemoryEXT", 29},
    {"vkCmdCopyQueryPoolResults", 26},
    {"vkCmdCuLaunchKernelNVX", 23},
    {"vkCmdCudaLaunchKernelNV", 24},
    {"vkCmdDebugMarkerBeginEXT", 25},
    {"vkCmdDebugMarkerEndEXT", 23},
    {"vkCmdDebugMarkerInsertEXT", 26},
    {"vkCmdDecodeVideoKHR", 20},
    {"vkCmdDecompressMemoryIndirectCountNV", 37},
    {"vkCmdDecompressMemoryNV", 24},
    {"vkCmdDispatch", 14},
    {"vkCmdDispatchBase", 18},
    {"vkCmdDispatchBaseKHR", 21},
    {"vkCmdDispatchGraphAMDX", 23},
    {"vkCmdDispatchGraphIndirectAMDX", 31},
    {"vkCmdDispatchGraphIndirectCountAMDX", 36},
    {"vkCmdDispatchIndirect", 22},
    {"vkCmdDraw", 10},
    {"vkCmdDrawClusterHUAWEI", 23},
    {"vkCmdDrawClusterIndirectHUAWEI", 31},
    {"vkCmdDrawIndexed", 17},
    {"vkCmdDrawIndexedIndirect", 25},
    {"vkCmdDrawIndexedIndirectCount", 30},
    {"vkCmdDrawIndexedIndirectCountAMD", 33},
    {"vkCmdDrawIndexedIndirectCountKHR", 33},
    {"vkCmdDrawIndirect", 18},
    {"vkCmdDrawIndirectByteCountEXT", 30},
    {"vkCmdDrawIndirectCount", 23},
    {"vkCmdDrawIndirectCountAMD", 26},
    {"vkCmdDrawIndirectCountKHR", 26},
    {"vkCmdDrawMeshTasksEXT", 22},
    {"vkCmdDrawMeshTasksIndirectCountEXT", 35},
    {"vkCmdDrawMeshTasksIndirectCountNV", 34},
    {"vkCmdDrawMeshTasksIndirectEXT", 30},
    {"vkCmdDrawMeshTasksIndirectNV", 29},
    {"vkCmdDrawMeshTasksNV", 21},
    {"vkCmdDrawMultiEXT", 18},
    {"vkCmdDrawMultiIndexedEXT", 25},
    {"vkCmdEncodeVideoKHR", 20},
    {"vkCmdEndConditionalRenderingEXT", 32},
    {"vkCmdEndDebugUtilsLabelEXT", 27},
    {"vkCmdEndQuery", 14},
    {"vkCmdEndQueryIndexedEXT", 24},
    {"vkCmdEndRenderPass", 19},
    {"vkCmdEndRenderPass2", 20},
    {"vkCmdEndRenderPass2KHR", 23},
    {"vkCmdEndRendering", 18},
    {"vkCmdEndRenderingKHR", 21},
    {"vkCmdEndTransformFeedbackEXT", 29},
    {"vkCmdEndVideoCodingKHR", 23},
    {"vkCmdExecuteCommands", 21},
    {"vkCmdExecuteGeneratedCommandsNV", 32},
    {"vkCmdFillBuffer", 16},
    {"vkCmdInitializeGraphScratchMemoryAMDX", 38},
    {"vkCmdInsertDebugUtilsLabelEXT", 30},
    {"vkCmdNextSubpass", 17},
    {"vkCmdNextSubpass2", 18},
    {"vkCmdNextSubpass2KHR", 21},
    {"vkCmdOpticalFlowExecuteNV", 26},
    {"vkCmdPipelineBarrier", 21},
    {"vkCmdPipelineBarrier2", 22},
    {"vkCmdPipelineBarrier2KHR", 25},
    {"vkCmdPreprocessGeneratedCommandsNV", 35},
    {"vkCmdPushConstants", 19},
    {"vkCmdPushConstants2KHR", 23},
    {"vkCmdPushDescriptorSet2KHR", 27},
    {"vkCmdPushDescriptorSetKHR", 26},
    {"vkCmdPushDescriptorSetWithTemplate2KHR", 39},
    {"vkCmdPushDescriptorSetWithTemplateKHR", 38},
    {"vkCmdResetEvent", 16},
    {"vkCmdResetEvent2", 17},
    {"vkCmdResetEvent2KHR", 20},
    {"vkCmdResetQueryPool", 20},
    {"vkCmdResolveImage", 18},
    {"vkCmdResolveImage2", 19},
    {"vkCmdResolveImage2KHR", 22},
    {"vkCmdSetAlphaToCoverageEnableEXT", 33},
    {"vkCmdSetAlphaToOneEnableEXT", 28},
    {"vkCmdSetAttachmentFeedbackLoopEnableEXT", 40},
    {"vkCmdSetBlendConstants", 23},
    {"vkCmdSetCheckpointNV", 21},
    {"vkCmdSetCoarseSampleOrderNV", 28},
    {"vkCmdSetColorBlendAdvancedEXT", 30},
    {"vkCmdSetColorBlendEnableEXT", 28},
    {"vkCmdSetColorBlendEquationEXT", 30},
    {"vkCmdSetColorWriteEnableEXT", 28},
    {"vkCmdSetColorWriteMaskEXT", 26},
    {"vkCmdSetConservativeRasterizationModeEXT", 41},
    {"vkCmdSetCoverageModulationModeNV", 33},
    {"vkCmdSetCoverageModulationTableEnableNV", 40},
    {"vkCmdSetCoverageModulationTableNV", 34},
    {"vkCmdSetCoverageReductionModeNV", 32},
    {"vkCmdSetCoverageToColorEnableNV", 32},
    {"vkCmdSetCoverageToColorLocationNV", 34},
    {"vkCmdSetCullMode", 17},
    {"vkCmdSetCullModeEXT", 20},
    {"vkCmdSetDepthBias", 18},
    {"vkCmdSetDepthBias2EXT", 22},
    {"vkCmdSetDepthBiasEnable", 24},
    {"vkCmdSetDepthBiasEnableEXT", 27},
    {"vkCmdSetDepthBounds", 20},
    {"vkCmdSetDepthBoundsTestEnable", 30},
    {"vkCmdSetDepthBoundsTestEnableEXT", 33},
    {"vkCmdSetDepthClampEnableEXT", 28},
    {"vkCmdSetDepthClipEnableEXT", 27},
    {"vkCmdSetDepthClipNegativeOneToOneEXT", 37},
    {"vkCmdSetDepthCompareOp", 23},
    {"vkCmdSetDepthCompareOpEXT", 26},
    {"vkCmdSetDepthTestEnable", 24},
    {"vkCmdSetDepthTestEnableEXT", 27},
    {"vkCmdSetDepthWriteEnable", 25},
    {"vkCmdSetDepthWriteEnableEXT", 28},
    {"vkCmdSetDescriptorBufferOffsets2EXT", 36},
    {"vkCmdSetDescriptorBufferOffsetsEXT", 35},
    {"vkCmdSetDeviceMask", 19},
    {"vkCmdSetDeviceMaskKHR", 22},
    {"vkCmdSetDiscardRectangleEXT", 28},
    {"vkCmdSetDiscardRectangleEnableEXT", 34},
    {"vkCmdSetDiscardRectangleModeEXT", 32},
    {"vkCmdSetEvent", 14},
    {"vkCmdSetEvent2", 15},
    {"vkCmdSetEvent2KHR", 18},
    {"vkCmdSetExclusiveScissorEnableNV", 33},
    {"vkCmdSetExclusiveScissorNV", 27},
    {"vkCmdSetExtraPrimitiveOverestimationSizeEXT", 44},
    {"vkCmdSetFragmentShadingRateEnumNV", 34},
    {"vkCmdSetFragmentShadingRateKHR", 31},
    {"vkCmdSetFrontFace", 18},
    {"vkCmdSetFrontFaceEXT", 21},
    {"vkCmdSetLineRasterizationModeEXT", 33},
    {"vkCmdSetLineStippleEXT", 23},
    {"vkCmdSetLineStippleEnableEXT", 29},
    {"vkCmdSetLineWidth", 18},
    {"vkCmdSetLogicOpEXT", 19},
    {"vkCmdSetLogicOpEnableEXT", 25},
    {"vkCmdSetPatchControlPointsEXT", 30},
    {"vkCmdSetPerformanceMarkerINTEL", 31},
    {"vkCmdSetPerformanceOverrideINTEL", 33},
    {"vkCmdSetPerformanceStreamMarkerINTEL", 37},
    {"vkCmdSetPolygonModeEXT", 23},
    {"vkCmdSetPrimitiveRestartEnable", 31},
    {"vkCmdSetPrimitiveRestartEnableEXT", 34},
    {"vkCmdSetPrimitiveTopology", 26},
    {"vkCmdSetPrimitiveTopologyEXT", 29},
    {"vkCmdSetProvokingVertexModeEXT", 31},
    {"vkCmdSetRasterizationSamplesEXT", 32},
    {"vkCmdSetRasterizationStreamEXT", 31},
    {"vkCmdSetRasterizerDiscardEnable", 32},
    {"vkCmdSetRasterizerDiscardEnableEXT", 35},
    {"vkCmdSetRayTracingPipelineStackSizeKHR", 39},
    {"vkCmdSetRepresentativeFragmentTestEnableNV", 43},
    {"vkCmdSetSampleLocationsEXT", 27},
    {"vkCmdSetSampleLocationsEnableEXT", 33},
    {"vkCmdSetSampleMaskEXT", 22},
    {"vkCmdSetScissor", 16},
    {"vkCmdSetScissorWithCount", 25},
    {"vkCmdSetScissorWithCountEXT", 28},
    {"vkCmdSetShadingRateImageEnableNV", 33},
    {"vkCmdSetStencilCompareMask", 27},
    {"vkCmdSetStencilOp", 18},
    {"vkCmdSetStencilOpEXT", 21},
    {"vkCmdSetStencilReference", 25},
    {"vkCmdSetStencilTestEnable", 26},
    {"vkCmdSetStencilTestEnableEXT", 29},
    {"vkCmdSetStencilWriteMask", 25},
    {"vkCmdSetTessellationDomainOriginEXT", 36},
    {"vkCmdSetVertexInputEXT", 23},
    {"vkCmdSetViewport", 17},
    {"vkCmdSetViewportShadingRatePaletteNV", 37},
    {"vkCmdSetViewportSwizzleNV", 26},
    {"vkCmdSetViewportWScalingEnableNV", 33},
    {"vkCmdSetViewportWScalingNV", 27},
    {"vkCmdSetViewportWithCount", 26},
    {"vkCmdSetViewportWithCountEXT", 29},
    {"vkCmdSubpassShadingHUAWEI", 26},
    {"vkCmdTraceRaysIndirect2KHR", 27},
    {"vkCmdTraceRaysIndirectKHR", 26},
    {"vkCmdTraceRaysKHR", 18},
    {"vkCmdTraceRaysNV", 17},
    {"vkCmdUpdateBuffer", 18},
    {"vkCmdUpdatePipelineIndirectBufferNV", 36},
    {"vkCmdWaitEvents", 16},
    {"vkCmdWaitEvents2", 17},
    {"vkCmdWaitEvents2KHR", 20},
    {"vkCmdWriteAccelerationStructuresPropertiesKHR", 46},
    {"vkCmdWriteAccelerationStructuresPropertiesNV", 45},
    {"vkCmdWriteBufferMarker2AMD", 27},
    {"vkCmdWriteBufferMarkerAMD", 26},
    {"vkCmdWriteMicromapsPropertiesEXT", 33},
    {"vkCmdWriteTimestamp", 20},
    {"vkCmdWriteTimestamp2", 21},
    {"vkCmdWriteTimestamp2KHR", 24},
    {"vkCompileDeferredNV", 20},
    {"vkCopyAccelerationStructureKHR", 31},
    {"vkCopyAccelerationStructureToMemoryKHR", 39},
    {"vkCopyImageToImageEXT", 22},
    {"vkCopyImageToMemoryEXT", 23},
    {"vkCopyMemoryToAccelerationStructureKHR", 39},
    {"vkCopyMemoryToImageEXT", 23},
    {"vkCopyMemoryToMicromapEXT", 26},
    {"vkCopyMicromapEXT", 18},
    {"vkCopyMicromapToMemoryEXT", 26},
    {"vkCreateAccelerationStructureKHR", 33},
    {"vkCreateAccelerationStructureNV", 32},
    {"vkCreateAndroidSurfaceKHR", 26},
    {"vkCreateBuffer", 15},
    {"vkCreateBufferCollectionFUCHSIA", 32},
    {"vkCreateBufferView", 19},
    {"vkCreateCommandPool", 20},
    {"vkCreateComputePipelines", 25},
    {"vkCreateCuFunctionNVX", 22},
    {"vkCreateCuModuleNVX", 20},
    {"vkCreateCudaFunctionNV", 23},
    {"vkCreateCudaModuleNV", 21},
    {"vkCreateDebugReportCallbackEXT", 31},
    {"vkCreateDebugUtilsMessengerEXT", 31},
    {"vkCreateDeferredOperationKHR", 29},
    {"vkCreateDescriptorPool", 23},
    {"vkCreateDescriptorSetLayout", 28},
    {"vkCreateDescriptorUpdateTemplate", 33},
    {"vkCreateDescriptorUpdateTemplateKHR", 36},
    {"vkCreateDevice", 15},
    {"vkCreateDirectFBSurfaceEXT", 27},
    {"vkCreateDisplayModeKHR", 23},
    {"vkCreateDisplayPlaneSurfaceKHR", 31},
    {"vkCreateEvent", 14},
    {"vkCreateExecutionGraphPipelinesAMDX", 36},
    {"vkCreateFence", 14},
    {"vkCreateFramebuffer", 20},
    {"vkCreateGraphicsPipelines", 26},
    {"vkCreateHeadlessSurfaceEXT", 27},
    {"vkCreateIOSSurfaceMVK", 22},
    {"vkCreateImage", 14},
    {"vkCreateImagePipeSurfaceFUCHSIA", 32},
    {"vkCreateImageView", 18},
    {"vkCreateIndirectCommandsLayoutNV", 33},
    {"vkCreateInstance", 17},
    {"vkCreateMacOSSurfaceMVK", 24},
    {"vkCreateMetalSurfaceEXT", 24},
    {"vkCreateMicromapEXT", 20},
    {"vkCreateOpticalFlowSessionNV", 29},
    {"vkCreatePipelineCache", 22},
    {"vkCreatePipelineLayout", 23},
    {"vkCreatePrivateDataSlot", 24},
    {"vkCreatePrivateDataSlotEXT", 27},
    {"vkCreateQueryPool", 18},
    {"vkCreateRayTracingPipelinesKHR", 31},
    {"vkCreateRayTracingPipelinesNV", 30},
    {"vkCreateRenderPass", 19},
    {"vkCreateRenderPass2", 20},
    {"vkCreateRenderPass2KHR", 23},
    {"vkCreateSampler", 16},
    {"vkCreateSamplerYcbcrConversion", 31},
    {"vkCreateSamplerYcbcrConversionKHR", 34},
    {"vkCreateScreenSurfaceQNX", 25},
    {"vkCreateSemaphore", 18},
    {"vkCreateShaderModule", 21},
    {"vkCreateShadersEXT", 19},
    {"vkCreateSharedSwapchainsKHR", 28},
    {"vkCreateStreamDescriptorSurfaceGGP", 35},
    {"vkCreateSwapchainKHR", 21},
    {"vkCreateValidationCacheEXT", 27},
    {"vkCreateViSurfaceNN", 20},
    {"vkCreateVideoSessionKHR", 24},
    {"vkCreateVideoSessionParametersKHR", 34},
    {"vkCreateWaylandSurfaceKHR", 26},
    {"vkCreateWin32SurfaceKHR", 24},
    {"vkCreateXcbSurfaceKHR", 22},
    {"vkCreateXlibSurfaceKHR", 23},
    {"vkDebugMarkerSetObjectNameEXT", 30},
    {"vkDebugMarkerSetObjectTagEXT", 29},
    {"vkDebugReportMessageEXT", 24},
    {"vkDeferredOperationJoinKHR", 27},
    {"vkDestroyAccelerationStructureKHR", 34},
    {"vkDestroyAccelerationStructureNV", 33},
    {"vkDestroyBuffer", 16},
    {"vkDestroyBufferCollectionFUCHSIA", 33},
    {"vkDestroyBufferView", 20},
    {"vkDestroyCommandPool", 21},
    {"vkDestroyCuFunctionNVX", 23},
    {"vkDestroyCuModuleNVX", 21},
    {"vkDestroyCudaFunctionNV", 24},
    {"vkDestroyCudaModuleNV", 22},
    {"vkDestroyDebugReportCallbackEXT", 32},
    {"vkDestroyDebugUtilsMessengerEXT", 32},
    {"vkDestroyDeferredOperationKHR", 30},
    {"vkDestroyDescriptorPool", 24},
    {"vkDestroyDescriptorSetLayout", 29},
    {"vkDestroyDescriptorUpdateTemplate", 34},
    {"vkDestroyDescriptorUpdateTemplateKHR", 37},
    {"vkDestroyDevice", 16},
    {"vkDestroyEvent", 15},
    {"vkDestroyFence", 15},
    {"vkDestroyFramebuffer", 21},
    {"vkDestroyImage", 15},
    {"vkDestroyImageView", 19},
    {"vkDestroyIndirectCommandsLayoutNV", 34},
    {"vkDestroyInstance", 18},
    {"vkDestroyMicromapEXT", 21},
    {"vkDestroyOpticalFlowSessionNV", 30},
    {"vkDestroyPipeline", 18},
    {"vkDestroyPipelineCache", 23},
    {"vkDestroyPipelineLayout", 24},
    {"vkDestroyPrivateDataSlot", 25},
    {"vkDestroyPrivateDataSlotEXT", 28},
    {"vkDestroyQueryPool", 19},
    {"vkDestroyRenderPass", 20},
    {"vkDestroySampler", 17},
    {"vkDestroySamplerYcbcrConversion", 32},
    {"vkDestroySamplerYcbcrConversionKHR", 35},
    {"vkDestroySemaphore", 19},
    {"vkDestroyShaderEXT", 19},
    {"vkDestroyShaderModule", 22},
    {"vkDestroySurfaceKHR", 20},
    {"vkDestroySwapchainKHR", 22},
    {"vkDestroyValidationCacheEXT", 28},
    {"vkDestroyVideoSessionKHR", 25},
    {"vkDestroyVideoSessionParametersKHR", 35},
    {"vkDeviceWaitIdle", 17},
    {"vkDisplayPowerControlEXT", 25},
    {"vkEndCommandBuffer", 19},
    {"vkEnumerateDeviceExtensionProperties", 37},
    {"vkEnumerateDeviceLayerProperties", 33},
    {"vkEnumerateInstanceExtensionProperties", 39},
    {"vkEnumerateInstanceLayerProperties", 35},
    {"vkEnumerateInstanceVersion", 27},
    {"vkEnumeratePhysicalDeviceGroups", 32},
    {"vkEnumeratePhysicalDeviceGroupsKHR", 35},
    {"vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR", 64},
    {"vkEnumeratePhysicalDevices", 27},
    {"vkExportMetalObjectsEXT", 24},
    {"vkFlushMappedMemoryRanges", 26},
    {"vkFreeCommandBuffers", 21},
    {"vkFreeDescriptorSets", 21},
    {"vkFreeMemory", 13},
    {"vkGetAccelerationStructureBuildSizesKHR", 40},
    {"vkGetAccelerationStructureDeviceAddressKHR", 43},
    {"vkGetAccelerationStructureHandleNV", 35},
    {"vkGetAccelerationStructureMemoryRequirementsNV", 47},
    {"vkGetAccelerationStructureOpaqueCaptureDescriptorDataEXT", 57},
    {"vkGetAndroidHardwareBufferPropertiesANDROID", 44},
    {"vkGetBufferCollectionPropertiesFUCHSIA", 39},
    {"vkGetBufferDeviceAddress", 25},
    {"vkGetBufferDeviceAddressEXT", 28},
    {"vkGetBufferDeviceAddressKHR", 28},
    {"vkGetBufferMemoryRequirements", 30},
    {"vkGetBufferMemoryRequirements2", 31},
    {"vkGetBufferMemoryRequirements2KHR", 34},
    {"vkGetBufferOpaqueCaptureAddress", 32},
    {"vkGetBufferOpaqueCaptureAddressKHR", 35},
    {"vkGetBufferOpaqueCaptureDescriptorDataEXT", 42},
    {"vkGetCalibratedTimestampsEXT", 29},
    {"vkGetCalibratedTimestampsKHR", 29},
    {"vkGetCudaModuleCacheNV", 23},
    {"vkGetDeferredOperationMaxConcurrencyKHR", 40},
    {"vkGetDeferredOperationResultKHR", 32},
    {"vkGetDescriptorEXT", 19},
    {"vkGetDescriptorSetHostMappingVALVE", 35},
    {"vkGetDescriptorSetLayoutBindingOffsetEXT", 41},
    {"vkGetDescriptorSetLayoutHostMappingInfoVALVE", 45},
    {"vkGetDescriptorSetLayoutSizeEXT", 32},
    {"vkGetDescriptorSetLayoutSupport", 32},
    {"vkGetDescriptorSetLayoutSupportKHR", 35},
    {"vkGetDeviceAccelerationStructureCompatibilityKHR", 49},
    {"vkGetDeviceBufferMemoryRequirements", 36},
    {"vkGetDeviceBufferMemoryRequirementsKHR", 39},
    {"vkGetDeviceFaultInfoEXT", 24},
    {"vkGetDeviceGroupPeerMemoryFeatures", 35},
    {"vkGetDeviceGroupPeerMemoryFeaturesKHR", 38},
    {"vkGetDeviceGroupPresentCapabilitiesKHR", 39},
    {"vkGetDeviceGroupSurfacePresentModes2EXT", 40},
    {"vkGetDeviceGroupSurfacePresentModesKHR", 39},
    {"vkGetDeviceImageMemoryRequirements", 35},
    {"vkGetDeviceImageMemoryRequirementsKHR", 38},
    {"vkGetDeviceImageSparseMemoryRequirements", 41},
    {"vkGetDeviceImageSparseMemoryRequirementsKHR", 44},
    {"vkGetDeviceImageSubresourceLayoutKHR", 37},
    {"vkGetDeviceMemoryCommitment", 28},
    {"vkGetDeviceMemoryOpaqueCaptureAddress", 38},
    {"vkGetDeviceMemoryOpaqueCaptureAddressKHR", 41},
    {"vkGetDeviceMicromapCompatibilityEXT", 36},
    {"vkGetDeviceProcAddr", 20},
    {"vkGetDeviceQueue", 17},
    {"vkGetDeviceQueue2", 18},
    {"vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI", 48},
    {"vkGetDisplayModeProperties2KHR", 31},
    {"vkGetDisplayModePropertiesKHR", 30},
    {"vkGetDisplayPlaneCapabilities2KHR", 34},
    {"vkGetDisplayPlaneCapabilitiesKHR", 33},
    {"vkGetDisplayPlaneSupportedDisplaysKHR", 38},
    {"vkGetDrmDisplayEXT", 19},
    {"vkGetDynamicRenderingTilePropertiesQCOM", 40},
    {"vkGetEncodedVideoSessionParametersKHR", 38},
    {"vkGetEventStatus", 17},
    {"vkGetExecutionGraphPipelineNodeIndexAMDX", 41},
    {"vkGetExecutionGraphPipelineScratchSizeAMDX", 43},
    {"vkGetFenceFdKHR", 16},
    {"vkGetFenceStatus", 17},
    {"vkGetFenceWin32HandleKHR", 25},
    {"vkGetFramebufferTilePropertiesQCOM", 35},
    {"vkGetGeneratedCommandsMemoryRequirementsNV", 43},
    {"vkGetImageDrmFormatModifierPropertiesEXT", 41},
    {"vkGetImageMemoryRequirements", 29},
    {"vkGetImageMemoryRequirements2", 30},
    {"vkGetImageMemoryRequirements2KHR", 33},
    {"vkGetImageOpaqueCaptureDescriptorDataEXT", 41},
    {"vkGetImageSparseMemoryRequirements", 35},
    {"vkGetImageSparseMemoryRequirements2", 36},
    {"vkGetImageSparseMemoryRequirements2KHR", 39},
    {"vkGetImageSubresourceLayout", 28},
    {"vkGetImageSubresourceLayout2EXT", 32},
    {"vkGetImageSubresourceLayout2KHR", 32},
    {"vkGetImageViewAddressNVX", 25},
    {"vkGetImageViewHandleNVX", 24},
    {"vkGetImageViewOpaqueCaptureDescriptorDataEXT", 45},
    {"vkGetInstanceProcAddr", 22},
    {"vkGetLatencyTimingsNV", 22},
    {"vkGetMemoryAndroidHardwareBufferANDROID", 40},
    {"vkGetMemoryFdKHR", 17},
    {"vkGetMemoryFdPropertiesKHR", 27},
    {"vkGetMemoryHostPointerPropertiesEXT", 36},
    {"vkGetMemoryRemoteAddressNV", 27},
    {"vkGetMemoryWin32HandleKHR", 26},
    {"vkGetMemoryWin32HandleNV", 25},
    {"vkGetMemoryWin32HandlePropertiesKHR", 36},
    {"vkGetMemoryZirconHandleFUCHSIA", 31},
    {"vkGetMemoryZirconHandlePropertiesFUCHSIA", 41},
    {"vkGetMicromapBuildSizesEXT", 27},
    {"vkGetPastPresentationTimingGOOGLE", 34},
    {"vkGetPerformanceParameterINTEL", 31},
    {"vkGetPhysicalDeviceCalibrateableTimeDomainsEXT", 47},
    {"vkGetPhysicalDeviceCalibrateableTimeDomainsKHR", 47},
    {"vkGetPhysicalDeviceCooperativeMatrixPropertiesKHR", 50},
    {"vkGetPhysicalDeviceCooperativeMatrixPropertiesNV", 49},
    {"vkGetPhysicalDeviceDirectFBPresentationSupportEXT", 50},
    {"vkGetPhysicalDeviceDisplayPlaneProperties2KHR", 46},
    {"vkGetPhysicalDeviceDisplayPlanePropertiesKHR", 45},
    {"vkGetPhysicalDeviceDisplayProperties2KHR", 41},
    {"vkGetPhysicalDeviceDisplayPropertiesKHR", 40},
    {"vkGetPhysicalDeviceExternalBufferProperties", 44},
    {"vkGetPhysicalDeviceExternalBufferPropertiesKHR", 47},
    {"vkGetPhysicalDeviceExternalFenceProperties", 43},
    {"vkGetPhysicalDeviceExternalFencePropertiesKHR", 46},
    {"vkGetPhysicalDeviceExternalImageFormatPropertiesNV", 51},
    {"vkGetPhysicalDeviceExternalSemaphoreProperties", 47},
    {"vkGetPhysicalDeviceExternalSemaphorePropertiesKHR", 50},
    {"vkGetPhysicalDeviceFeatures", 28},
    {"vkGetPhysicalDeviceFeatures2", 29},
    {"vkGetPhysicalDeviceFeatures2KHR", 32},
    {"vkGetPhysicalDeviceFormatProperties", 36},
    {"vkGetPhysicalDeviceFormatProperties2", 37},
    {"vkGetPhysicalDeviceFormatProperties2KHR", 40},
    {"vkGetPhysicalDeviceFragmentShadingRatesKHR", 43},
    {"vkGetPhysicalDeviceImageFormatProperties", 41},
    {"vkGetPhysicalDeviceImageFormatProperties2", 42},
    {"vkGetPhysicalDeviceImageFormatProperties2KHR", 45},
    {"vkGetPhysicalDeviceMemoryProperties", 36},
    {"vkGetPhysicalDeviceMemoryProperties2", 37},
    {"vkGetPhysicalDeviceMemoryProperties2KHR", 40},
    {"vkGetPhysicalDeviceMultisamplePropertiesEXT", 44},
    {"vkGetPhysicalDeviceOpticalFlowImageFormatsNV", 45},
    {"vkGetPhysicalDevicePresentRectanglesKHR", 40},
    {"vkGetPhysicalDeviceProperties", 30},
    {"vkGetPhysicalDeviceProperties2", 31},
    {"vkGetPhysicalDeviceProperties2KHR", 34},
    {"vkGetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR", 56},
    {"vkGetPhysicalDeviceQueueFamilyProperties", 41},
    {"vkGetPhysicalDeviceQueueFamilyProperties2", 42},
    {"vkGetPhysicalDeviceQueueFamilyProperties2KHR", 45},
    {"vkGetPhysicalDeviceScreenPresentationSupportQNX", 48},
    {"vkGetPhysicalDeviceSparseImageFormatProperties", 47},
    {"vkGetPhysicalDeviceSparseImageFormatProperties2", 48},
    {"vkGetPhysicalDeviceSparseImageFormatProperties2KHR", 51},
    {"vkGetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV", 66},
    {"vkGetPhysicalDeviceSurfaceCapabilities2EXT", 43},
    {"vkGetPhysicalDeviceSurfaceCapabilities2KHR", 43},
    {"vkGetPhysicalDeviceSurfaceCapabilitiesKHR", 42},
    {"vkGetPhysicalDeviceSurfaceFormats2KHR", 38},
    {"vkGetPhysicalDeviceSurfaceFormatsKHR", 37},
    {"vkGetPhysicalDeviceSurfacePresentModes2EXT", 43},
    {"vkGetPhysicalDeviceSurfacePresentModesKHR", 42},
    {"vkGetPhysicalDeviceSurfaceSupportKHR", 37},
    {"vkGetPhysicalDeviceToolProperties", 34},
    {"vkGetPhysicalDeviceToolPropertiesEXT", 37},
    {"vkGetPhysicalDeviceVideoCapabilitiesKHR", 40},
    {"vkGetPhysicalDeviceVideoEncodeQualityLevelPropertiesKHR", 56},
    {"vkGetPhysicalDeviceVideoFormatPropertiesKHR", 44},
    {"vkGetPhysicalDeviceWaylandPresentationSupportKHR", 49},
    {"vkGetPhysicalDeviceWin32PresentationSupportKHR", 47},
    {"vkGetPhysicalDeviceXcbPresentationSupportKHR", 45},
    {"vkGetPhysicalDeviceXlibPresentationSupportKHR", 46},
    {"vkGetPipelineCacheData", 23},
    {"vkGetPipelineExecutableInternalRepresentationsKHR", 50},
    {"vkGetPipelineExecutablePropertiesKHR", 37},
    {"vkGetPipelineExecutableStatisticsKHR", 37},
    {"vkGetPipelineIndirectDeviceAddressNV", 37},
    {"vkGetPipelineIndirectMemoryRequirementsNV", 42},
    {"vkGetPipelinePropertiesEXT", 27},
    {"vkGetPrivateData", 17},
    {"vkGetPrivateDataEXT", 20},
    {"vkGetQueryPoolResults", 22},
    {"vkGetQueueCheckpointData2NV", 28},
    {"vkGetQueueCheckpointDataNV", 27},
    {"vkGetRandROutputDisplayEXT", 27},
    {"vkGetRayTracingCaptureReplayShaderGroupHandlesKHR", 50},
    {"vkGetRayTracingShaderGroupHandlesKHR", 37},
    {"vkGetRayTracingShaderGroupHandlesNV", 36},
    {"vkGetRayTracingShaderGroupStackSizeKHR", 39},
    {"vkGetRefreshCycleDurationGOOGLE", 32},
    {"vkGetRenderAreaGranularity", 27},
    {"vkGetRenderingAreaGranularityKHR", 33},
    {"vkGetSamplerOpaqueCaptureDescriptorDataEXT", 43},
    {"vkGetScreenBufferPropertiesQNX", 31},
    {"vkGetSemaphoreCounterValue", 27},
    {"vkGetSemaphoreCounterValueKHR", 30},
    {"vkGetSemaphoreFdKHR", 20},
    {"vkGetSemaphoreWin32HandleKHR", 29},
    {"vkGetSemaphoreZirconHandleFUCHSIA", 34},
    {"vkGetShaderBinaryDataEXT", 25},
    {"vkGetShaderInfoAMD", 19},
    {"vkGetShaderModuleCreateInfoIdentifierEXT", 41},
    {"vkGetShaderModuleIdentifierEXT", 31},
    {"vkGetSwapchainCounterEXT", 25},
    {"vkGetSwapchainImagesKHR", 24},
    {"vkGetSwapchainStatusKHR", 24},
    {"vkGetValidationCacheDataEXT", 28},
    {"vkGetVideoSessionMemoryRequirementsKHR", 39},
    {"vkGetWinrtDisplayNV", 20},
    {"vkImportFenceFdKHR", 19},
    {"vkImportFenceWin32HandleKHR", 28},
    {"vkImportSemaphoreFdKHR", 23},
    {"vkImportSemaphoreWin32HandleKHR", 32},
    {"vkImportSemaphoreZirconHandleFUCHSIA", 37},
    {"vkInitializePerformanceApiINTEL", 32},
    {"vkInvalidateMappedMemoryRanges", 31},
    {"vkLatencySleepNV", 17},
    {"vkMapMemory", 12},
    {"vkMapMemory2KHR", 16},
    {"vkMergePipelineCaches", 22},
    {"vkMergeValidationCachesEXT", 27},
    {"vkQueueBeginDebugUtilsLabelEXT", 31},
    {"vkQueueBindSparse", 18},
    {"vkQueueEndDebugUtilsLabelEXT", 29},
    {"vkQueueInsertDebugUtilsLabelEXT", 32},
    {"vkQueueNotifyOutOfBandNV", 25},
    {"vkQueuePresentKHR", 18},
    {"vkQueueSetPerformanceConfigurationINTEL", 40},
    {"vkQueueSubmit", 14},
    {"vkQueueSubmit2", 15},
    {"vkQueueSubmit2KHR", 18},
    {"vkQueueWaitIdle", 16},
    {"vkRegisterDeviceEventEXT", 25},
    {"vkRegisterDisplayEventEXT", 26},
    {"vkReleaseDisplayEXT", 20},
    {"vkReleaseFullScreenExclusiveModeEXT", 36},
    {"vkReleasePerformanceConfigurationINTEL", 39},
    {"vkReleaseProfilingLockKHR", 26},
    {"vkReleaseSwapchainImagesEXT", 28},
    {"vkResetCommandBuffer", 21},
    {"vkResetCommandPool", 19},
    {"vkResetDescriptorPool", 22},
    {"vkResetEvent", 13},
    {"vkResetFences", 14},
    {"vkResetQueryPool", 17},
    {"vkResetQueryPoolEXT", 20},
    {"vkSetBufferCollectionBufferConstraintsFUCHSIA", 46},
    {"vkSetBufferCollectionImageConstraintsFUCHSIA", 45},
    {"vkSetDebugUtilsObjectNameEXT", 29},
    {"vkSetDebugUtilsObjectTagEXT", 28},
    {"vkSetDeviceMemoryPriorityEXT", 29},
    {"vkSetEvent", 11},
    {"vkSetHdrMetadataEXT", 20},
    {"vkSetLatencyMarkerNV", 21},
    {"vkSetLatencySleepModeNV", 24},
    {"vkSetLocalDimmingAMD", 21},
    {"vkSetPrivateData", 17},
    {"vkSetPrivateDataEXT", 20},
    {"vkSignalSemaphore", 18},
    {"vkSignalSemaphoreKHR", 21},
    {"vkSubmitDebugUtilsMessageEXT", 29},
    {"vkTransitionImageLayoutEXT", 27},
    {"vkTrimCommandPool", 18},
    {"vkTrimCommandPoolKHR", 21},
    {"vkUninitializePerformanceApiINTEL", 34},
    {"vkUnmapMemory", 14},
    {"vkUnmapMemory2KHR", 18},
    {"vkUpdateDescriptorSetWithTemplate", 34},
    {"vkUpdateDescriptorSetWithTemplateKHR", 37},
    {"vkUpdateDescriptorSets", 23},
    {"vkUpdateVideoSessionParametersKHR", 34},
    {"vkWaitForFences", 16},
    {"vkWaitForPresentKHR", 20},
    {"vkWaitSemaphores", 17},
    {"vkWaitSemaphoresKHR", 20},
    {"vkWriteAccelerationStructuresPropertiesKHR", 43},
    {"vkWriteMicromapsPropertiesEXT", 30},
    };
    return table[(int)func].data();
}

const char* String(Struct structure) {
    static const std::string_view table[] = {
    {"INVALID_EMPTY", 15}, // Struct::Empty
    {"VkAabbPositionsKHR", 19},
    {"VkAccelerationStructureBuildGeometryInfoKHR", 44},
    {"VkAccelerationStructureBuildRangeInfoKHR", 41},
    {"VkAccelerationStructureBuildSizesInfoKHR", 41},
    {"VkAccelerationStructureCaptureDescriptorDataInfoEXT", 52},
    {"VkAccelerationStructureCreateInfoKHR", 37},
    {"VkAccelerationStructureCreateInfoNV", 36},
    {"VkAccelerationStructureDeviceAddressInfoKHR", 44},
    {"VkAccelerationStructureGeometryAabbsDataKHR", 44},
    {"VkAccelerationStructureGeometryDataKHR", 39},
    {"VkAccelerationStructureGeometryInstancesDataKHR", 48},
    {"VkAccelerationStructureGeometryKHR", 35},
    {"VkAccelerationStructureGeometryMotionTrianglesDataNV", 53},
    {"VkAccelerationStructureGeometryTrianglesDataKHR", 48},
    {"VkAccelerationStructureInfoNV", 30},
    {"VkAccelerationStructureInstanceKHR", 35},
    {"VkAccelerationStructureMatrixMotionInstanceNV", 46},
    {"VkAccelerationStructureMemoryRequirementsInfoNV", 48},
    {"VkAccelerationStructureMotionInfoNV", 36},
    {"VkAccelerationStructureMotionInstanceDataNV", 44},
    {"VkAccelerationStructureMotionInstanceNV", 40},
    {"VkAccelerationStructureSRTMotionInstanceNV", 43},
    {"VkAccelerationStructureTrianglesDisplacementMicromapNV", 55},
    {"VkAccelerationStructureTrianglesOpacityMicromapEXT", 51},
    {"VkAccelerationStructureVersionInfoKHR", 38},
    {"VkAcquireNextImageInfoKHR", 26},
    {"VkAcquireProfilingLockInfoKHR", 30},
    {"VkAllocationCallbacks", 22},
    {"VkAmigoProfilingSubmitInfoSEC", 30},
    {"VkAndroidHardwareBufferFormatProperties2ANDROID", 48},
    {"VkAndroidHardwareBufferFormatPropertiesANDROID", 47},
    {"VkAndroidHardwareBufferFormatResolvePropertiesANDROID", 54},
    {"VkAndroidHardwareBufferPropertiesANDROID", 41},
    {"VkAndroidHardwareBufferUsageANDROID", 36},
    {"VkAndroidSurfaceCreateInfoKHR", 30},
    {"VkApplicationInfo", 18},
    {"VkAttachmentDescription", 24},
    {"VkAttachmentDescription2", 25},
    {"VkAttachmentDescriptionStencilLayout", 37},
    {"VkAttachmentReference", 22},
    {"VkAttachmentReference2", 23},
    {"VkAttachmentReferenceStencilLayout", 35},
    {"VkAttachmentSampleCountInfoAMD", 31},
    {"VkAttachmentSampleLocationsEXT", 31},
    {"VkBaseInStructure", 18},
    {"VkBaseOutStructure", 19},
    {"VkBindAccelerationStructureMemoryInfoNV", 40},
    {"VkBindBufferMemoryDeviceGroupInfo", 34},
    {"VkBindBufferMemoryInfo", 23},
    {"VkBindDescriptorBufferEmbeddedSamplersInfoEXT", 46},
    {"VkBindDescriptorSetsInfoKHR", 28},
    {"VkBindImageMemoryDeviceGroupInfo", 33},
    {"VkBindImageMemoryInfo", 22},
    {"VkBindImageMemorySwapchainInfoKHR", 34},
    {"VkBindImagePlaneMemoryInfo", 27},
    {"VkBindIndexBufferIndirectCommandNV", 35},
    {"VkBindMemoryStatusKHR", 22},
    {"VkBindPipelineIndirectCommandNV", 32},
    {"VkBindShaderGroupIndirectCommandNV", 35},
    {"VkBindSparseInfo", 17},
    {"VkBindVertexBufferIndirectCommandNV", 36},
    {"VkBindVideoSessionMemoryInfoKHR", 32},
    {"VkBlitImageCubicWeightsInfoQCOM", 32},
    {"VkBlitImageInfo2", 17},
    {"VkBufferCaptureDescriptorDataInfoEXT", 37},
    {"VkBufferCollectionBufferCreateInfoFUCHSIA", 42},
    {"VkBufferCollectionConstraintsInfoFUCHSIA", 41},
    {"VkBufferCollectionCreateInfoFUCHSIA", 36},
    {"VkBufferCollectionImageCreateInfoFUCHSIA", 41},
    {"VkBufferCollectionPropertiesFUCHSIA", 36},
    {"VkBufferConstraintsInfoFUCHSIA", 31},
    {"VkBufferCopy", 13},
    {"VkBufferCopy2", 14},
    {"VkBufferCreateInfo", 19},
    {"VkBufferDeviceAddressCreateInfoEXT", 35},
    {"VkBufferDeviceAddressInfo", 26},
    {"VkBufferImageCopy", 18},
    {"VkBufferImageCopy2", 19},
    {"VkBufferMemoryBarrier", 22},
    {"VkBufferMemoryBarrier2", 23},
    {"VkBufferMemoryRequirementsInfo2", 32},
    {"VkBufferOpaqueCaptureAddressCreateInfo", 39},
    {"VkBufferUsageFlags2CreateInfoKHR", 33},
    {"VkBufferViewCreateInfo", 23},
    {"VkCalibratedTimestampInfoKHR", 29},
    {"VkCheckpointData2NV", 20},
    {"VkCheckpointDataNV", 19},
    {"VkClearAttachment", 18},
    {"VkClearColorValue", 18},
    {"VkClearDepthStencilValue", 25},
    {"VkClearRect", 12},
    {"VkClearValue", 13},
    {"VkCoarseSampleLocationNV", 25},
    {"VkCoarseSampleOrderCustomNV", 28},
    {"VkColorBlendAdvancedEXT", 24},
    {"VkColorBlendEquationEXT", 24},
    {"VkCommandBufferAllocateInfo", 28},
    {"VkCommandBufferBeginInfo", 25},
    {"VkCommandBufferInheritanceConditionalRenderingInfoEXT", 54},
    {"VkCommandBufferInheritanceInfo", 31},
    {"VkCommandBufferInheritanceRenderPassTransformInfoQCOM", 54},
    {"VkCommandBufferInheritanceRenderingInfo", 40},
    {"VkCommandBufferInheritanceViewportScissorInfoNV", 48},
    {"VkCommandBufferSubmitInfo", 26},
    {"VkCommandPoolCreateInfo", 24},
    {"VkComponentMapping", 19},
    {"VkComputePipelineCreateInfo", 28},
    {"VkComputePipelineIndirectBufferInfoNV", 38},
    {"VkConditionalRenderingBeginInfoEXT", 35},
    {"VkConformanceVersion", 21},
    {"VkCooperativeMatrixPropertiesKHR", 33},
    {"VkCooperativeMatrixPropertiesNV", 32},
    {"VkCopyAccelerationStructureInfoKHR", 35},
    {"VkCopyAccelerationStructureToMemoryInfoKHR", 43},
    {"VkCopyBufferInfo2", 18},
    {"VkCopyBufferToImageInfo2", 25},
    {"VkCopyCommandTransformInfoQCOM", 31},
    {"VkCopyDescriptorSet", 20},
    {"VkCopyImageInfo2", 17},
    {"VkCopyImageToBufferInfo2", 25},
    {"VkCopyImageToImageInfoEXT", 26},
    {"VkCopyImageToMemoryInfoEXT", 27},
    {"VkCopyMemoryIndirectCommandNV", 30},
    {"VkCopyMemoryToAccelerationStructureInfoKHR", 43},
    {"VkCopyMemoryToImageIndirectCommandNV", 37},
    {"VkCopyMemoryToImageInfoEXT", 27},
    {"VkCopyMemoryToMicromapInfoEXT", 30},
    {"VkCopyMicromapInfoEXT", 22},
    {"VkCopyMicromapToMemoryInfoEXT", 30},
    {"VkCuFunctionCreateInfoNVX", 26},
    {"VkCuLaunchInfoNVX", 18},
    {"VkCuModuleCreateInfoNVX", 24},
    {"VkCudaFunctionCreateInfoNV", 27},
    {"VkCudaLaunchInfoNV", 19},
    {"VkCudaModuleCreateInfoNV", 25},
    {"VkD3D12FenceSubmitInfoKHR", 26},
    {"VkDebugMarkerMarkerInfoEXT", 27},
    {"VkDebugMarkerObjectNameInfoEXT", 31},
    {"VkDebugMarkerObjectTagInfoEXT", 30},
    {"VkDebugReportCallbackCreateInfoEXT", 35},
    {"VkDebugUtilsLabelEXT", 21},
    {"VkDebugUtilsMessengerCallbackDataEXT", 37},
    {"VkDebugUtilsMessengerCreateInfoEXT", 35},
    {"VkDebugUtilsObjectNameInfoEXT", 30},
    {"VkDebugUtilsObjectTagInfoEXT", 29},
    {"VkDecompressMemoryRegionNV", 27},
    {"VkDedicatedAllocationBufferCreateInfoNV", 40},
    {"VkDedicatedAllocationImageCreateInfoNV", 39},
    {"VkDedicatedAllocationMemoryAllocateInfoNV", 42},
    {"VkDependencyInfo", 17},
    {"VkDepthBiasInfoEXT", 19},
    {"VkDepthBiasRepresentationInfoEXT", 33},
    {"VkDescriptorAddressInfoEXT", 27},
    {"VkDescriptorBufferBindingInfoEXT", 33},
    {"VkDescriptorBufferBindingPushDescriptorBufferHandleEXT", 55},
    {"VkDescriptorBufferInfo", 23},
    {"VkDescriptorDataEXT", 20},
    {"VkDescriptorGetInfoEXT", 23},
    {"VkDescriptorImageInfo", 22},
    {"VkDescriptorPoolCreateInfo", 27},
    {"VkDescriptorPoolInlineUniformBlockCreateInfo", 45},
    {"VkDescriptorPoolSize", 21},
    {"VkDescriptorSetAllocateInfo", 28},
    {"VkDescriptorSetBindingReferenceVALVE", 37},
    {"VkDescriptorSetLayoutBinding", 29},
    {"VkDescriptorSetLayoutBindingFlagsCreateInfo", 44},
    {"VkDescriptorSetLayoutCreateInfo", 32},
    {"VkDescriptorSetLayoutHostMappingInfoVALVE", 42},
    {"VkDescriptorSetLayoutSupport", 29},
    {"VkDescriptorSetVariableDescriptorCountAllocateInfo", 51},
    {"VkDescriptorSetVariableDescriptorCountLayoutSupport", 52},
    {"VkDescriptorUpdateTemplateCreateInfo", 37},
    {"VkDescriptorUpdateTemplateEntry", 32},
    {"VkDeviceAddressBindingCallbackDataEXT", 38},
    {"VkDeviceBufferMemoryRequirements", 33},
    {"VkDeviceCreateInfo", 19},
    {"VkDeviceDeviceMemoryReportCreateInfoEXT", 40},
    {"VkDeviceDiagnosticsConfigCreateInfoNV", 38},
    {"VkDeviceEventInfoEXT", 21},
    {"VkDeviceFaultAddressInfoEXT", 28},
    {"VkDeviceFaultCountsEXT", 23},
    {"VkDeviceFaultInfoEXT", 21},
    {"VkDeviceFaultVendorBinaryHeaderVersionOneEXT", 45},
    {"VkDeviceFaultVendorInfoEXT", 27},
    {"VkDeviceGroupBindSparseInfo", 28},
    {"VkDeviceGroupCommandBufferBeginInfo", 36},
    {"VkDeviceGroupDeviceCreateInfo", 30},
    {"VkDeviceGroupPresentCapabilitiesKHR", 36},
    {"VkDeviceGroupPresentInfoKHR", 28},
    {"VkDeviceGroupRenderPassBeginInfo", 33},
    {"VkDeviceGroupSubmitInfo", 24},
    {"VkDeviceGroupSwapchainCreateInfoKHR", 36},
    {"VkDeviceImageMemoryRequirements", 32},
    {"VkDeviceImageSubresourceInfoKHR", 32},
    {"VkDeviceMemoryOpaqueCaptureAddressInfo", 39},
    {"VkDeviceMemoryOverallocationCreateInfoAMD", 42},
    {"VkDeviceMemoryReportCallbackDataEXT", 36},
    {"VkDeviceOrHostAddressConstAMDX", 31},
    {"VkDeviceOrHostAddressConstKHR", 30},
    {"VkDeviceOrHostAddressKHR", 25},
    {"VkDevicePrivateDataCreateInfo", 30},
    {"VkDeviceQueueCreateInfo", 24},
    {"VkDeviceQueueGlobalPriorityCreateInfoKHR", 41},
    {"VkDeviceQueueInfo2", 19},
    {"VkDeviceQueueShaderCoreControlCreateInfoARM", 44},
    {"VkDirectDriverLoadingInfoLUNARG", 32},
    {"VkDirectDriverLoadingListLUNARG", 32},
    {"VkDirectFBSurfaceCreateInfoEXT", 31},
    {"VkDispatchGraphCountInfoAMDX", 29},
    {"VkDispatchGraphInfoAMDX", 24},
    {"VkDispatchIndirectCommand", 26},
    {"VkDisplayEventInfoEXT", 22},
    {"VkDisplayModeCreateInfoKHR", 27},
    {"VkDisplayModeParametersKHR", 27},
    {"VkDisplayModeProperties2KHR", 28},
    {"VkDisplayModePropertiesKHR", 27},
    {"VkDisplayNativeHdrSurfaceCapabilitiesAMD", 41},
    {"VkDisplayPlaneCapabilities2KHR", 31},
    {"VkDisplayPlaneCapabilitiesKHR", 30},
    {"VkDisplayPlaneInfo2KHR", 23},
    {"VkDisplayPlaneProperties2KHR", 29},
    {"VkDisplayPlanePropertiesKHR", 28},
    {"VkDisplayPowerInfoEXT", 22},
    {"VkDisplayPresentInfoKHR", 24},
    {"VkDisplayProperties2KHR", 24},
    {"VkDisplayPropertiesKHR", 23},
    {"VkDisplaySurfaceCreateInfoKHR", 30},
    {"VkDrawIndexedIndirectCommand", 29},
    {"VkDrawIndirectCommand", 22},
    {"VkDrawMeshTasksIndirectCommandEXT", 34},
    {"VkDrawMeshTasksIndirectCommandNV", 33},
    {"VkDrmFormatModifierProperties2EXT", 34},
    {"VkDrmFormatModifierPropertiesEXT", 33},
    {"VkDrmFormatModifierPropertiesList2EXT", 38},
    {"VkDrmFormatModifierPropertiesListEXT", 37},
    {"VkEventCreateInfo", 18},
    {"VkExecutionGraphPipelineCreateInfoAMDX", 39},
    {"VkExecutionGraphPipelineScratchSizeAMDX", 40},
    {"VkExportFenceCreateInfo", 24},
    {"VkExportFenceWin32HandleInfoKHR", 32},
    {"VkExportMemoryAllocateInfo", 27},
    {"VkExportMemoryAllocateInfoNV", 29},
    {"VkExportMemoryWin32HandleInfoKHR", 33},
    {"VkExportMemoryWin32HandleInfoNV", 32},
    {"VkExportMetalBufferInfoEXT", 27},
    {"VkExportMetalCommandQueueInfoEXT", 33},
    {"VkExportMetalDeviceInfoEXT", 27},
    {"VkExportMetalIOSurfaceInfoEXT", 30},
    {"VkExportMetalObjectCreateInfoEXT", 33},
    {"VkExportMetalObjectsInfoEXT", 28},
    {"VkExportMetalSharedEventInfoEXT", 32},
    {"VkExportMetalTextureInfoEXT", 28},
    {"VkExportSemaphoreCreateInfo", 28},
    {"VkExportSemaphoreWin32HandleInfoKHR", 36},
    {"VkExtensionProperties", 22},
    {"VkExtent2D", 11},
    {"VkExtent3D", 11},
    {"VkExternalBufferProperties", 27},
    {"VkExternalFenceProperties", 26},
    {"VkExternalFormatANDROID", 24},
    {"VkExternalFormatQNX", 20},
    {"VkExternalImageFormatProperties", 32},
    {"VkExternalImageFormatPropertiesNV", 34},
    {"VkExternalMemoryAcquireUnmodifiedEXT", 37},
    {"VkExternalMemoryBufferCreateInfo", 33},
    {"VkExternalMemoryImageCreateInfo", 32},
    {"VkExternalMemoryImageCreateInfoNV", 34},
    {"VkExternalMemoryProperties", 27},
    {"VkExternalSemaphoreProperties", 30},
    {"VkFenceCreateInfo", 18},
    {"VkFenceGetFdInfoKHR", 20},
    {"VkFenceGetWin32HandleInfoKHR", 29},
    {"VkFilterCubicImageViewImageFormatPropertiesEXT", 47},
    {"VkFormatProperties", 19},
    {"VkFormatProperties2", 20},
    {"VkFormatProperties3", 20},
    {"VkFragmentShadingRateAttachmentInfoKHR", 39},
    {"VkFrameBoundaryEXT", 19},
    {"VkFramebufferAttachmentImageInfo", 33},
    {"VkFramebufferAttachmentsCreateInfo", 35},
    {"VkFramebufferCreateInfo", 24},
    {"VkFramebufferMixedSamplesCombinationNV", 39},
    {"VkGeneratedCommandsInfoNV", 26},
    {"VkGeneratedCommandsMemoryRequirementsInfoNV", 44},
    {"VkGeometryAABBNV", 17},
    {"VkGeometryDataNV", 17},
    {"VkGeometryNV", 13},
    {"VkGeometryTrianglesNV", 22},
    {"VkGetLatencyMarkerInfoNV", 25},
    {"VkGraphicsPipelineCreateInfo", 29},
    {"VkGraphicsPipelineLibraryCreateInfoEXT", 39},
    {"VkGraphicsPipelineShaderGroupsCreateInfoNV", 43},
    {"VkGraphicsShaderGroupCreateInfoNV", 34},
    {"VkHdrMetadataEXT", 17},
    {"VkHeadlessSurfaceCreateInfoEXT", 31},
    {"VkHostImageCopyDevicePerformanceQueryEXT", 41},
    {"VkHostImageLayoutTransitionInfoEXT", 35},
    {"VkIOSSurfaceCreateInfoMVK", 26},
    {"VkImageBlit", 12},
    {"VkImageBlit2", 13},
    {"VkImageCaptureDescriptorDataInfoEXT", 36},
    {"VkImageCompressionControlEXT", 29},
    {"VkImageCompressionPropertiesEXT", 32},
    {"VkImageConstraintsInfoFUCHSIA", 30},
    {"VkImageCopy", 12},
    {"VkImageCopy2", 13},
    {"VkImageCreateInfo", 18},
    {"VkImageDrmFormatModifierExplicitCreateInfoEXT", 46},
    {"VkImageDrmFormatModifierListCreateInfoEXT", 42},
    {"VkImageDrmFormatModifierPropertiesEXT", 38},
    {"VkImageFormatConstraintsInfoFUCHSIA", 36},
    {"VkImageFormatListCreateInfo", 28},
    {"VkImageFormatProperties", 24},
    {"VkImageFormatProperties2", 25},
    {"VkImageMemoryBarrier", 21},
    {"VkImageMemoryBarrier2", 22},
    {"VkImageMemoryRequirementsInfo2", 31},
    {"VkImagePipeSurfaceCreateInfoFUCHSIA", 36},
    {"VkImagePlaneMemoryRequirementsInfo", 35},
    {"VkImageResolve", 15},
    {"VkImageResolve2", 16},
    {"VkImageSparseMemoryRequirementsInfo2", 37},
    {"VkImageStencilUsageCreateInfo", 30},
    {"VkImageSubresource", 19},
    {"VkImageSubresource2KHR", 23},
    {"VkImageSubresourceLayers", 25},
    {"VkImageSubresourceRange", 24},
    {"VkImageSwapchainCreateInfoKHR", 30},
    {"VkImageToMemoryCopyEXT", 23},
    {"VkImageViewASTCDecodeModeEXT", 29},
    {"VkImageViewAddressPropertiesNVX", 32},
    {"VkImageViewCaptureDescriptorDataInfoEXT", 40},
    {"VkImageViewCreateInfo", 22},
    {"VkImageViewHandleInfoNVX", 25},
    {"VkImageViewMinLodCreateInfoEXT", 31},
    {"VkImageViewSampleWeightCreateInfoQCOM", 38},
    {"VkImageViewSlicedCreateInfoEXT", 31},
    {"VkImageViewUsageCreateInfo", 27},
    {"VkImportAndroidHardwareBufferInfoANDROID", 41},
    {"VkImportFenceFdInfoKHR", 23},
    {"VkImportFenceWin32HandleInfoKHR", 32},
    {"VkImportMemoryBufferCollectionFUCHSIA", 38},
    {"VkImportMemoryFdInfoKHR", 24},
    {"VkImportMemoryHostPointerInfoEXT", 33},
    {"VkImportMemoryWin32HandleInfoKHR", 33},
    {"VkImportMemoryWin32HandleInfoNV", 32},
    {"VkImportMemoryZirconHandleInfoFUCHSIA", 38},
    {"VkImportMetalBufferInfoEXT", 27},
    {"VkImportMetalIOSurfaceInfoEXT", 30},
    {"VkImportMetalSharedEventInfoEXT", 32},
    {"VkImportMetalTextureInfoEXT", 28},
    {"VkImportScreenBufferInfoQNX", 28},
    {"VkImportSemaphoreFdInfoKHR", 27},
    {"VkImportSemaphoreWin32HandleInfoKHR", 36},
    {"VkImportSemaphoreZirconHandleInfoFUCHSIA", 41},
    {"VkIndirectCommandsLayoutCreateInfoNV", 37},
    {"VkIndirectCommandsLayoutTokenNV", 32},
    {"VkIndirectCommandsStreamNV", 27},
    {"VkInitializePerformanceApiInfoINTEL", 36},
    {"VkInputAttachmentAspectReference", 33},
    {"VkInstanceCreateInfo", 21},
    {"VkLatencySleepInfoNV", 21},
    {"VkLatencySleepModeInfoNV", 25},
    {"VkLatencySubmissionPresentIdNV", 31},
    {"VkLatencySurfaceCapabilitiesNV", 31},
    {"VkLatencyTimingsFrameReportNV", 30},
    {"VkLayerProperties", 18},
    {"VkLayerSettingEXT", 18},
    {"VkLayerSettingsCreateInfoEXT", 29},
    {"VkMacOSSurfaceCreateInfoMVK", 28},
    {"VkMappedMemoryRange", 20},
    {"VkMemoryAllocateFlagsInfo", 26},
    {"VkMemoryAllocateInfo", 21},
    {"VkMemoryBarrier", 16},
    {"VkMemoryBarrier2", 17},
    {"VkMemoryDedicatedAllocateInfo", 30},
    {"VkMemoryDedicatedRequirements", 30},
    {"VkMemoryFdPropertiesKHR", 24},
    {"VkMemoryGetAndroidHardwareBufferInfoANDROID", 44},
    {"VkMemoryGetFdInfoKHR", 21},
    {"VkMemoryGetRemoteAddressInfoNV", 31},
    {"VkMemoryGetWin32HandleInfoKHR", 30},
    {"VkMemoryGetZirconHandleInfoFUCHSIA", 35},
    {"VkMemoryHeap", 13},
    {"VkMemoryHostPointerPropertiesEXT", 33},
    {"VkMemoryMapInfoKHR", 19},
    {"VkMemoryOpaqueCaptureAddressAllocateInfo", 41},
    {"VkMemoryPriorityAllocateInfoEXT", 32},
    {"VkMemoryRequirements", 21},
    {"VkMemoryRequirements2", 22},
    {"VkMemoryToImageCopyEXT", 23},
    {"VkMemoryType", 13},
    {"VkMemoryUnmapInfoKHR", 21},
    {"VkMemoryWin32HandlePropertiesKHR", 33},
    {"VkMemoryZirconHandlePropertiesFUCHSIA", 38},
    {"VkMetalSurfaceCreateInfoEXT", 28},
    {"VkMicromapBuildInfoEXT", 23},
    {"VkMicromapBuildSizesInfoEXT", 28},
    {"VkMicromapCreateInfoEXT", 24},
    {"VkMicromapTriangleEXT", 22},
    {"VkMicromapUsageEXT", 19},
    {"VkMicromapVersionInfoEXT", 25},
    {"VkMultiDrawIndexedInfoEXT", 26},
    {"VkMultiDrawInfoEXT", 19},
    {"VkMultisamplePropertiesEXT", 27},
    {"VkMultisampledRenderToSingleSampledInfoEXT", 43},
    {"VkMultiviewPerViewAttributesInfoNVX", 36},
    {"VkMultiviewPerViewRenderAreasRenderPassBeginInfoQCOM", 53},
    {"VkMutableDescriptorTypeCreateInfoEXT", 37},
    {"VkMutableDescriptorTypeListEXT", 31},
    {"VkOffset2D", 11},
    {"VkOffset3D", 11},
    {"VkOpaqueCaptureDescriptorDataCreateInfoEXT", 43},
    {"VkOpticalFlowExecuteInfoNV", 27},
    {"VkOpticalFlowImageFormatInfoNV", 31},
    {"VkOpticalFlowImageFormatPropertiesNV", 37},
    {"VkOpticalFlowSessionCreateInfoNV", 33},
    {"VkOpticalFlowSessionCreatePrivateDataInfoNV", 44},
    {"VkOutOfBandQueueTypeInfoNV", 27},
    {"VkPastPresentationTimingGOOGLE", 31},
    {"VkPerformanceConfigurationAcquireInfoINTEL", 43},
    {"VkPerformanceCounterDescriptionKHR", 35},
    {"VkPerformanceCounterKHR", 24},
    {"VkPerformanceCounterResultKHR", 30},
    {"VkPerformanceMarkerInfoINTEL", 29},
    {"VkPerformanceOverrideInfoINTEL", 31},
    {"VkPerformanceQuerySubmitInfoKHR", 32},
    {"VkPerformanceStreamMarkerInfoINTEL", 35},
    {"VkPerformanceValueDataINTEL", 28},
    {"VkPerformanceValueINTEL", 24},
    {"VkPhysicalDevice16BitStorageFeatures", 37},
    {"VkPhysicalDevice4444FormatsFeaturesEXT", 39},
    {"VkPhysicalDevice8BitStorageFeatures", 36},
    {"VkPhysicalDeviceASTCDecodeFeaturesEXT", 38},
    {"VkPhysicalDeviceAccelerationStructureFeaturesKHR", 49},
    {"VkPhysicalDeviceAccelerationStructurePropertiesKHR", 51},
    {"VkPhysicalDeviceAddressBindingReportFeaturesEXT", 48},
    {"VkPhysicalDeviceAmigoProfilingFeaturesSEC", 42},
    {"VkPhysicalDeviceAttachmentFeedbackLoopDynamicStateFeaturesEXT", 62},
    {"VkPhysicalDeviceAttachmentFeedbackLoopLayoutFeaturesEXT", 56},
    {"VkPhysicalDeviceBlendOperationAdvancedFeaturesEXT", 50},
    {"VkPhysicalDeviceBlendOperationAdvancedPropertiesEXT", 52},
    {"VkPhysicalDeviceBorderColorSwizzleFeaturesEXT", 46},
    {"VkPhysicalDeviceBufferDeviceAddressFeatures", 44},
    {"VkPhysicalDeviceBufferDeviceAddressFeaturesEXT", 47},
    {"VkPhysicalDeviceClusterCullingShaderFeaturesHUAWEI", 51},
    {"VkPhysicalDeviceClusterCullingShaderPropertiesHUAWEI", 53},
    {"VkPhysicalDeviceClusterCullingShaderVrsFeaturesHUAWEI", 54},
    {"VkPhysicalDeviceCoherentMemoryFeaturesAMD", 42},
    {"VkPhysicalDeviceColorWriteEnableFeaturesEXT", 44},
    {"VkPhysicalDeviceComputeShaderDerivativesFeaturesNV", 51},
    {"VkPhysicalDeviceConditionalRenderingFeaturesEXT", 48},
    {"VkPhysicalDeviceConservativeRasterizationPropertiesEXT", 55},
    {"VkPhysicalDeviceCooperativeMatrixFeaturesKHR", 45},
    {"VkPhysicalDeviceCooperativeMatrixFeaturesNV", 44},
    {"VkPhysicalDeviceCooperativeMatrixPropertiesKHR", 47},
    {"VkPhysicalDeviceCooperativeMatrixPropertiesNV", 46},
    {"VkPhysicalDeviceCopyMemoryIndirectFeaturesNV", 45},
    {"VkPhysicalDeviceCopyMemoryIndirectPropertiesNV", 47},
    {"VkPhysicalDeviceCornerSampledImageFeaturesNV", 45},
    {"VkPhysicalDeviceCoverageReductionModeFeaturesNV", 48},
    {"VkPhysicalDeviceCubicClampFeaturesQCOM", 39},
    {"VkPhysicalDeviceCubicWeightsFeaturesQCOM", 41},
    {"VkPhysicalDeviceCudaKernelLaunchFeaturesNV", 43},
    {"VkPhysicalDeviceCudaKernelLaunchPropertiesNV", 45},
    {"VkPhysicalDeviceCustomBorderColorFeaturesEXT", 45},
    {"VkPhysicalDeviceCustomBorderColorPropertiesEXT", 47},
    {"VkPhysicalDeviceDedicatedAllocationImageAliasingFeaturesNV", 59},
    {"VkPhysicalDeviceDepthBiasControlFeaturesEXT", 44},
    {"VkPhysicalDeviceDepthClampZeroOneFeaturesEXT", 45},
    {"VkPhysicalDeviceDepthClipControlFeaturesEXT", 44},
    {"VkPhysicalDeviceDepthClipEnableFeaturesEXT", 43},
    {"VkPhysicalDeviceDepthStencilResolveProperties", 46},
    {"VkPhysicalDeviceDescriptorBufferDensityMapPropertiesEXT", 56},
    {"VkPhysicalDeviceDescriptorBufferFeaturesEXT", 44},
    {"VkPhysicalDeviceDescriptorBufferPropertiesEXT", 46},
    {"VkPhysicalDeviceDescriptorIndexingFeatures", 43},
    {"VkPhysicalDeviceDescriptorIndexingProperties", 45},
    {"VkPhysicalDeviceDescriptorPoolOverallocationFeaturesNV", 55},
    {"VkPhysicalDeviceDescriptorSetHostMappingFeaturesVALVE", 54},
    {"VkPhysicalDeviceDeviceGeneratedCommandsComputeFeaturesNV", 57},
    {"VkPhysicalDeviceDeviceGeneratedCommandsFeaturesNV", 50},
    {"VkPhysicalDeviceDeviceGeneratedCommandsPropertiesNV", 52},
    {"VkPhysicalDeviceDeviceMemoryReportFeaturesEXT", 46},
    {"VkPhysicalDeviceDiagnosticsConfigFeaturesNV", 44},
    {"VkPhysicalDeviceDiscardRectanglePropertiesEXT", 46},
    {"VkPhysicalDeviceDisplacementMicromapFeaturesNV", 47},
    {"VkPhysicalDeviceDisplacementMicromapPropertiesNV", 49},
    {"VkPhysicalDeviceDriverProperties", 33},
    {"VkPhysicalDeviceDrmPropertiesEXT", 33},
    {"VkPhysicalDeviceDynamicRenderingFeatures", 41},
    {"VkPhysicalDeviceDynamicRenderingUnusedAttachmentsFeaturesEXT", 61},
    {"VkPhysicalDeviceExclusiveScissorFeaturesNV", 43},
    {"VkPhysicalDeviceExtendedDynamicState2FeaturesEXT", 49},
    {"VkPhysicalDeviceExtendedDynamicState3FeaturesEXT", 49},
    {"VkPhysicalDeviceExtendedDynamicState3PropertiesEXT", 51},
    {"VkPhysicalDeviceExtendedDynamicStateFeaturesEXT", 48},
    {"VkPhysicalDeviceExtendedSparseAddressSpaceFeaturesNV", 53},
    {"VkPhysicalDeviceExtendedSparseAddressSpacePropertiesNV", 55},
    {"VkPhysicalDeviceExternalBufferInfo", 35},
    {"VkPhysicalDeviceExternalFenceInfo", 34},
    {"VkPhysicalDeviceExternalFormatResolveFeaturesANDROID", 53},
    {"VkPhysicalDeviceExternalFormatResolvePropertiesANDROID", 55},
    {"VkPhysicalDeviceExternalImageFormatInfo", 40},
    {"VkPhysicalDeviceExternalMemoryHostPropertiesEXT", 48},
    {"VkPhysicalDeviceExternalMemoryRDMAFeaturesNV", 45},
    {"VkPhysicalDeviceExternalMemoryScreenBufferFeaturesQNX", 54},
    {"VkPhysicalDeviceExternalSemaphoreInfo", 38},
    {"VkPhysicalDeviceFaultFeaturesEXT", 33},
    {"VkPhysicalDeviceFeatures", 25},
    {"VkPhysicalDeviceFeatures2", 26},
    {"VkPhysicalDeviceFloatControlsProperties", 40},
    {"VkPhysicalDeviceFragmentDensityMap2FeaturesEXT", 47},
    {"VkPhysicalDeviceFragmentDensityMap2PropertiesEXT", 49},
    {"VkPhysicalDeviceFragmentDensityMapFeaturesEXT", 46},
    {"VkPhysicalDeviceFragmentDensityMapOffsetFeaturesQCOM", 53},
    {"VkPhysicalDeviceFragmentDensityMapOffsetPropertiesQCOM", 55},
    {"VkPhysicalDeviceFragmentDensityMapPropertiesEXT", 48},
    {"VkPhysicalDeviceFragmentShaderBarycentricFeaturesKHR", 53},
    {"VkPhysicalDeviceFragmentShaderBarycentricPropertiesKHR", 55},
    {"VkPhysicalDeviceFragmentShaderInterlockFeaturesEXT", 51},
    {"VkPhysicalDeviceFragmentShadingRateEnumsFeaturesNV", 51},
    {"VkPhysicalDeviceFragmentShadingRateEnumsPropertiesNV", 53},
    {"VkPhysicalDeviceFragmentShadingRateFeaturesKHR", 47},
    {"VkPhysicalDeviceFragmentShadingRateKHR", 39},
    {"VkPhysicalDeviceFragmentShadingRatePropertiesKHR", 49},
    {"VkPhysicalDeviceFrameBoundaryFeaturesEXT", 41},
    {"VkPhysicalDeviceGlobalPriorityQueryFeaturesKHR", 47},
    {"VkPhysicalDeviceGraphicsPipelineLibraryFeaturesEXT", 51},
    {"VkPhysicalDeviceGraphicsPipelineLibraryPropertiesEXT", 53},
    {"VkPhysicalDeviceGroupProperties", 32},
    {"VkPhysicalDeviceHostImageCopyFeaturesEXT", 41},
    {"VkPhysicalDeviceHostImageCopyPropertiesEXT", 43},
    {"VkPhysicalDeviceHostQueryResetFeatures", 39},
    {"VkPhysicalDeviceIDProperties", 29},
    {"VkPhysicalDeviceImage2DViewOf3DFeaturesEXT", 43},
    {"VkPhysicalDeviceImageCompressionControlFeaturesEXT", 51},
    {"VkPhysicalDeviceImageCompressionControlSwapchainFeaturesEXT", 60},
    {"VkPhysicalDeviceImageDrmFormatModifierInfoEXT", 46},
    {"VkPhysicalDeviceImageFormatInfo2", 33},
    {"VkPhysicalDeviceImageProcessing2FeaturesQCOM", 45},
    {"VkPhysicalDeviceImageProcessing2PropertiesQCOM", 47},
    {"VkPhysicalDeviceImageProcessingFeaturesQCOM", 44},
    {"VkPhysicalDeviceImageProcessingPropertiesQCOM", 46},
    {"VkPhysicalDeviceImageRobustnessFeatures", 40},
    {"VkPhysicalDeviceImageSlicedViewOf3DFeaturesEXT", 47},
    {"VkPhysicalDeviceImageViewImageFormatInfoEXT", 44},
    {"VkPhysicalDeviceImageViewMinLodFeaturesEXT", 43},
    {"VkPhysicalDeviceImagelessFramebufferFeatures", 45},
    {"VkPhysicalDeviceIndexTypeUint8FeaturesEXT", 42},
    {"VkPhysicalDeviceInheritedViewportScissorFeaturesNV", 51},
    {"VkPhysicalDeviceInlineUniformBlockFeatures", 43},
    {"VkPhysicalDeviceInlineUniformBlockProperties", 45},
    {"VkPhysicalDeviceInvocationMaskFeaturesHUAWEI", 45},
    {"VkPhysicalDeviceLayeredDriverPropertiesMSFT", 44},
    {"VkPhysicalDeviceLegacyDitheringFeaturesEXT", 43},
    {"VkPhysicalDeviceLimits", 23},
    {"VkPhysicalDeviceLineRasterizationFeaturesEXT", 45},
    {"VkPhysicalDeviceLineRasterizationPropertiesEXT", 47},
    {"VkPhysicalDeviceLinearColorAttachmentFeaturesNV", 48},
    {"VkPhysicalDeviceMaintenance3Properties", 39},
    {"VkPhysicalDeviceMaintenance4Features", 37},
    {"VkPhysicalDeviceMaintenance4Properties", 39},
    {"VkPhysicalDeviceMaintenance5FeaturesKHR", 40},
    {"VkPhysicalDeviceMaintenance5PropertiesKHR", 42},
    {"VkPhysicalDeviceMaintenance6FeaturesKHR", 40},
    {"VkPhysicalDeviceMaintenance6PropertiesKHR", 42},
    {"VkPhysicalDeviceMemoryBudgetPropertiesEXT", 42},
    {"VkPhysicalDeviceMemoryDecompressionFeaturesNV", 46},
    {"VkPhysicalDeviceMemoryDecompressionPropertiesNV", 48},
    {"VkPhysicalDeviceMemoryPriorityFeaturesEXT", 42},
    {"VkPhysicalDeviceMemoryProperties", 33},
    {"VkPhysicalDeviceMemoryProperties2", 34},
    {"VkPhysicalDeviceMeshShaderFeaturesEXT", 38},
    {"VkPhysicalDeviceMeshShaderFeaturesNV", 37},
    {"VkPhysicalDeviceMeshShaderPropertiesEXT", 40},
    {"VkPhysicalDeviceMeshShaderPropertiesNV", 39},
    {"VkPhysicalDeviceMultiDrawFeaturesEXT", 37},
    {"VkPhysicalDeviceMultiDrawPropertiesEXT", 39},
    {"VkPhysicalDeviceMultisampledRenderToSingleSampledFeaturesEXT", 61},
    {"VkPhysicalDeviceMultiviewFeatures", 34},
    {"VkPhysicalDeviceMultiviewPerViewAttributesPropertiesNVX", 56},
    {"VkPhysicalDeviceMultiviewPerViewRenderAreasFeaturesQCOM", 56},
    {"VkPhysicalDeviceMultiviewPerViewViewportsFeaturesQCOM", 54},
    {"VkPhysicalDeviceMultiviewProperties", 36},
    {"VkPhysicalDeviceMutableDescriptorTypeFeaturesEXT", 49},
    {"VkPhysicalDeviceNestedCommandBufferFeaturesEXT", 47},
    {"VkPhysicalDeviceNestedCommandBufferPropertiesEXT", 49},
    {"VkPhysicalDeviceNonSeamlessCubeMapFeaturesEXT", 46},
    {"VkPhysicalDeviceOpacityMicromapFeaturesEXT", 43},
    {"VkPhysicalDeviceOpacityMicromapPropertiesEXT", 45},
    {"VkPhysicalDeviceOpticalFlowFeaturesNV", 38},
    {"VkPhysicalDeviceOpticalFlowPropertiesNV", 40},
    {"VkPhysicalDevicePCIBusInfoPropertiesEXT", 40},
    {"VkPhysicalDevicePageableDeviceLocalMemoryFeaturesEXT", 53},
    {"VkPhysicalDevicePerStageDescriptorSetFeaturesNV", 48},
    {"VkPhysicalDevicePerformanceQueryFeaturesKHR", 44},
    {"VkPhysicalDevicePerformanceQueryPropertiesKHR", 46},
    {"VkPhysicalDevicePipelineCreationCacheControlFeatures", 53},
    {"VkPhysicalDevicePipelineExecutablePropertiesFeaturesKHR", 56},
    {"VkPhysicalDevicePipelineLibraryGroupHandlesFeaturesEXT", 55},
    {"VkPhysicalDevicePipelinePropertiesFeaturesEXT", 46},
    {"VkPhysicalDevicePipelineProtectedAccessFeaturesEXT", 51},
    {"VkPhysicalDevicePipelineRobustnessFeaturesEXT", 46},
    {"VkPhysicalDevicePipelineRobustnessPropertiesEXT", 48},
    {"VkPhysicalDevicePointClippingProperties", 40},
    {"VkPhysicalDevicePortabilitySubsetFeaturesKHR", 45},
    {"VkPhysicalDevicePortabilitySubsetPropertiesKHR", 47},
    {"VkPhysicalDevicePresentBarrierFeaturesNV", 41},
    {"VkPhysicalDevicePresentIdFeaturesKHR", 37},
    {"VkPhysicalDevicePresentWaitFeaturesKHR", 39},
    {"VkPhysicalDevicePrimitiveTopologyListRestartFeaturesEXT", 56},
    {"VkPhysicalDevicePrimitivesGeneratedQueryFeaturesEXT", 52},
    {"VkPhysicalDevicePrivateDataFeatures", 36},
    {"VkPhysicalDeviceProperties", 27},
    {"VkPhysicalDeviceProperties2", 28},
    {"VkPhysicalDeviceProtectedMemoryFeatures", 40},
    {"VkPhysicalDeviceProtectedMemoryProperties", 42},
    {"VkPhysicalDeviceProvokingVertexFeaturesEXT", 43},
    {"VkPhysicalDeviceProvokingVertexPropertiesEXT", 45},
    {"VkPhysicalDevicePushDescriptorPropertiesKHR", 44},
    {"VkPhysicalDeviceRGBA10X6FormatsFeaturesEXT", 43},
    {"VkPhysicalDeviceRasterizationOrderAttachmentAccessFeaturesEXT", 62},
    {"VkPhysicalDeviceRayQueryFeaturesKHR", 36},
    {"VkPhysicalDeviceRayTracingInvocationReorderFeaturesNV", 54},
    {"VkPhysicalDeviceRayTracingInvocationReorderPropertiesNV", 56},
    {"VkPhysicalDeviceRayTracingMaintenance1FeaturesKHR", 50},
    {"VkPhysicalDeviceRayTracingMotionBlurFeaturesNV", 47},
    {"VkPhysicalDeviceRayTracingPipelineFeaturesKHR", 46},
    {"VkPhysicalDeviceRayTracingPipelinePropertiesKHR", 48},
    {"VkPhysicalDeviceRayTracingPositionFetchFeaturesKHR", 51},
    {"VkPhysicalDeviceRayTracingPropertiesNV", 39},
    {"VkPhysicalDeviceRelaxedLineRasterizationFeaturesIMG", 52},
    {"VkPhysicalDeviceRenderPassStripedFeaturesARM", 45},
    {"VkPhysicalDeviceRenderPassStripedPropertiesARM", 47},
    {"VkPhysicalDeviceRepresentativeFragmentTestFeaturesNV", 53},
    {"VkPhysicalDeviceRobustness2FeaturesEXT", 39},
    {"VkPhysicalDeviceRobustness2PropertiesEXT", 41},
    {"VkPhysicalDeviceSampleLocationsPropertiesEXT", 45},
    {"VkPhysicalDeviceSamplerFilterMinmaxProperties", 46},
    {"VkPhysicalDeviceSamplerYcbcrConversionFeatures", 47},
    {"VkPhysicalDeviceScalarBlockLayoutFeatures", 42},
    {"VkPhysicalDeviceSchedulingControlsFeaturesARM", 46},
    {"VkPhysicalDeviceSchedulingControlsPropertiesARM", 48},
    {"VkPhysicalDeviceSeparateDepthStencilLayoutsFeatures", 52},
    {"VkPhysicalDeviceShaderAtomicFloat2FeaturesEXT", 46},
    {"VkPhysicalDeviceShaderAtomicFloatFeaturesEXT", 45},
    {"VkPhysicalDeviceShaderAtomicInt64Features", 42},
    {"VkPhysicalDeviceShaderClockFeaturesKHR", 39},
    {"VkPhysicalDeviceShaderCoreBuiltinsFeaturesARM", 46},
    {"VkPhysicalDeviceShaderCoreBuiltinsPropertiesARM", 48},
    {"VkPhysicalDeviceShaderCoreProperties2AMD", 41},
    {"VkPhysicalDeviceShaderCorePropertiesAMD", 40},
    {"VkPhysicalDeviceShaderCorePropertiesARM", 40},
    {"VkPhysicalDeviceShaderDemoteToHelperInvocationFeatures", 55},
    {"VkPhysicalDeviceShaderDrawParametersFeatures", 45},
    {"VkPhysicalDeviceShaderEarlyAndLateFragmentTestsFeaturesAMD", 59},
    {"VkPhysicalDeviceShaderEnqueueFeaturesAMDX", 42},
    {"VkPhysicalDeviceShaderEnqueuePropertiesAMDX", 44},
    {"VkPhysicalDeviceShaderFloat16Int8Features", 42},
    {"VkPhysicalDeviceShaderImageAtomicInt64FeaturesEXT", 50},
    {"VkPhysicalDeviceShaderImageFootprintFeaturesNV", 47},
    {"VkPhysicalDeviceShaderIntegerDotProductFeatures", 48},
    {"VkPhysicalDeviceShaderIntegerDotProductProperties", 50},
    {"VkPhysicalDeviceShaderIntegerFunctions2FeaturesINTEL", 53},
    {"VkPhysicalDeviceShaderModuleIdentifierFeaturesEXT", 50},
    {"VkPhysicalDeviceShaderModuleIdentifierPropertiesEXT", 52},
    {"VkPhysicalDeviceShaderObjectFeaturesEXT", 40},
    {"VkPhysicalDeviceShaderObjectPropertiesEXT", 42},
    {"VkPhysicalDeviceShaderSMBuiltinsFeaturesNV", 43},
    {"VkPhysicalDeviceShaderSMBuiltinsPropertiesNV", 45},
    {"VkPhysicalDeviceShaderSubgroupExtendedTypesFeatures", 52},
    {"VkPhysicalDeviceShaderSubgroupUniformControlFlowFeaturesKHR", 60},
    {"VkPhysicalDeviceShaderTerminateInvocationFeatures", 50},
    {"VkPhysicalDeviceShaderTileImageFeaturesEXT", 43},
    {"VkPhysicalDeviceShaderTileImagePropertiesEXT", 45},
    {"VkPhysicalDeviceShadingRateImageFeaturesNV", 43},
    {"VkPhysicalDeviceShadingRateImagePropertiesNV", 45},
    {"VkPhysicalDeviceSparseImageFormatInfo2", 39},
    {"VkPhysicalDeviceSparseProperties", 33},
    {"VkPhysicalDeviceSubgroupProperties", 35},
    {"VkPhysicalDeviceSubgroupSizeControlFeatures", 44},
    {"VkPhysicalDeviceSubgroupSizeControlProperties", 46},
    {"VkPhysicalDeviceSubpassMergeFeedbackFeaturesEXT", 48},
    {"VkPhysicalDeviceSubpassShadingFeaturesHUAWEI", 45},
    {"VkPhysicalDeviceSubpassShadingPropertiesHUAWEI", 47},
    {"VkPhysicalDeviceSurfaceInfo2KHR", 32},
    {"VkPhysicalDeviceSwapchainMaintenance1FeaturesEXT", 49},
    {"VkPhysicalDeviceSynchronization2Features", 41},
    {"VkPhysicalDeviceTexelBufferAlignmentFeaturesEXT", 48},
    {"VkPhysicalDeviceTexelBufferAlignmentProperties", 47},
    {"VkPhysicalDeviceTextureCompressionASTCHDRFeatures", 50},
    {"VkPhysicalDeviceTilePropertiesFeaturesQCOM", 43},
    {"VkPhysicalDeviceTimelineSemaphoreFeatures", 42},
    {"VkPhysicalDeviceTimelineSemaphoreProperties", 44},
    {"VkPhysicalDeviceToolProperties", 31},
    {"VkPhysicalDeviceTransformFeedbackFeaturesEXT", 45},
    {"VkPhysicalDeviceTransformFeedbackPropertiesEXT", 47},
    {"VkPhysicalDeviceUniformBufferStandardLayoutFeatures", 52},
    {"VkPhysicalDeviceVariablePointersFeatures", 41},
    {"VkPhysicalDeviceVertexAttributeDivisorFeaturesKHR", 50},
    {"VkPhysicalDeviceVertexAttributeDivisorPropertiesEXT", 52},
    {"VkPhysicalDeviceVertexAttributeDivisorPropertiesKHR", 52},
    {"VkPhysicalDeviceVertexInputDynamicStateFeaturesEXT", 51},
    {"VkPhysicalDeviceVideoEncodeQualityLevelInfoKHR", 47},
    {"VkPhysicalDeviceVideoFormatInfoKHR", 35},
    {"VkPhysicalDeviceVideoMaintenance1FeaturesKHR", 45},
    {"VkPhysicalDeviceVulkan11Features", 33},
    {"VkPhysicalDeviceVulkan11Properties", 35},
    {"VkPhysicalDeviceVulkan12Features", 33},
    {"VkPhysicalDeviceVulkan12Properties", 35},
    {"VkPhysicalDeviceVulkan13Features", 33},
    {"VkPhysicalDeviceVulkan13Properties", 35},
    {"VkPhysicalDeviceVulkanMemoryModelFeatures", 42},
    {"VkPhysicalDeviceWorkgroupMemoryExplicitLayoutFeaturesKHR", 57},
    {"VkPhysicalDeviceYcbcr2Plane444FormatsFeaturesEXT", 49},
    {"VkPhysicalDeviceYcbcrDegammaFeaturesQCOM", 41},
    {"VkPhysicalDeviceYcbcrImageArraysFeaturesEXT", 44},
    {"VkPhysicalDeviceZeroInitializeWorkgroupMemoryFeatures", 54},
    {"VkPipelineCacheCreateInfo", 26},
    {"VkPipelineCacheHeaderVersionOne", 32},
    {"VkPipelineColorBlendAdvancedStateCreateInfoEXT", 47},
    {"VkPipelineColorBlendAttachmentState", 36},
    {"VkPipelineColorBlendStateCreateInfo", 36},
    {"VkPipelineColorWriteCreateInfoEXT", 34},
    {"VkPipelineCompilerControlCreateInfoAMD", 39},
    {"VkPipelineCoverageModulationStateCreateInfoNV", 46},
    {"VkPipelineCoverageReductionStateCreateInfoNV", 45},
    {"VkPipelineCoverageToColorStateCreateInfoNV", 43},
    {"VkPipelineCreateFlags2CreateInfoKHR", 36},
    {"VkPipelineCreationFeedback", 27},
    {"VkPipelineCreationFeedbackCreateInfo", 37},
    {"VkPipelineDepthStencilStateCreateInfo", 38},
    {"VkPipelineDiscardRectangleStateCreateInfoEXT", 45},
    {"VkPipelineDynamicStateCreateInfo", 33},
    {"VkPipelineExecutableInfoKHR", 28},
    {"VkPipelineExecutableInternalRepresentationKHR", 46},
    {"VkPipelineExecutablePropertiesKHR", 34},
    {"VkPipelineExecutableStatisticKHR", 33},
    {"VkPipelineExecutableStatisticValueKHR", 38},
    {"VkPipelineFragmentShadingRateEnumStateCreateInfoNV", 51},
    {"VkPipelineFragmentShadingRateStateCreateInfoKHR", 48},
    {"VkPipelineIndirectDeviceAddressInfoNV", 38},
    {"VkPipelineInfoKHR", 18},
    {"VkPipelineInputAssemblyStateCreateInfo", 39},
    {"VkPipelineLayoutCreateInfo", 27},
    {"VkPipelineLibraryCreateInfoKHR", 31},
    {"VkPipelineMultisampleStateCreateInfo", 37},
    {"VkPipelinePropertiesIdentifierEXT", 34},
    {"VkPipelineRasterizationConservativeStateCreateInfoEXT", 54},
    {"VkPipelineRasterizationDepthClipStateCreateInfoEXT", 51},
    {"VkPipelineRasterizationLineStateCreateInfoEXT", 46},
    {"VkPipelineRasterizationProvokingVertexStateCreateInfoEXT", 57},
    {"VkPipelineRasterizationStateCreateInfo", 39},
    {"VkPipelineRasterizationStateRasterizationOrderAMD", 50},
    {"VkPipelineRasterizationStateStreamCreateInfoEXT", 48},
    {"VkPipelineRenderingCreateInfo", 30},
    {"VkPipelineRepresentativeFragmentTestStateCreateInfoNV", 54},
    {"VkPipelineRobustnessCreateInfoEXT", 34},
    {"VkPipelineSampleLocationsStateCreateInfoEXT", 44},
    {"VkPipelineShaderStageCreateInfo", 32},
    {"VkPipelineShaderStageModuleIdentifierCreateInfoEXT", 51},
    {"VkPipelineShaderStageNodeCreateInfoAMDX", 40},
    {"VkPipelineShaderStageRequiredSubgroupSizeCreateInfo", 52},
    {"VkPipelineTessellationDomainOriginStateCreateInfo", 50},
    {"VkPipelineTessellationStateCreateInfo", 38},
    {"VkPipelineVertexInputDivisorStateCreateInfoKHR", 47},
    {"VkPipelineVertexInputStateCreateInfo", 37},
    {"VkPipelineViewportCoarseSampleOrderStateCreateInfoNV", 53},
    {"VkPipelineViewportDepthClipControlCreateInfoEXT", 48},
    {"VkPipelineViewportExclusiveScissorStateCreateInfoNV", 52},
    {"VkPipelineViewportShadingRateImageStateCreateInfoNV", 52},
    {"VkPipelineViewportStateCreateInfo", 34},
    {"VkPipelineViewportSwizzleStateCreateInfoNV", 43},
    {"VkPipelineViewportWScalingStateCreateInfoNV", 44},
    {"VkPresentFrameTokenGGP", 23},
    {"VkPresentIdKHR", 15},
    {"VkPresentInfoKHR", 17},
    {"VkPresentRegionKHR", 19},
    {"VkPresentRegionsKHR", 20},
    {"VkPresentTimeGOOGLE", 20},
    {"VkPresentTimesInfoGOOGLE", 25},
    {"VkPrivateDataSlotCreateInfo", 28},
    {"VkProtectedSubmitInfo", 22},
    {"VkPushConstantRange", 20},
    {"VkPushConstantsInfoKHR", 23},
    {"VkPushDescriptorSetInfoKHR", 27},
    {"VkPushDescriptorSetWithTemplateInfoKHR", 39},
    {"VkQueryLowLatencySupportNV", 27},
    {"VkQueryPoolCreateInfo", 22},
    {"VkQueryPoolPerformanceCreateInfoKHR", 36},
    {"VkQueryPoolPerformanceQueryCreateInfoINTEL", 43},
    {"VkQueryPoolVideoEncodeFeedbackCreateInfoKHR", 44},
    {"VkQueueFamilyCheckpointProperties2NV", 37},
    {"VkQueueFamilyCheckpointPropertiesNV", 36},
    {"VkQueueFamilyGlobalPriorityPropertiesKHR", 41},
    {"VkQueueFamilyProperties", 24},
    {"VkQueueFamilyProperties2", 25},
    {"VkQueueFamilyQueryResultStatusPropertiesKHR", 44},
    {"VkQueueFamilyVideoPropertiesKHR", 32},
    {"VkRayTracingPipelineCreateInfoKHR", 34},
    {"VkRayTracingPipelineCreateInfoNV", 33},
    {"VkRayTracingPipelineInterfaceCreateInfoKHR", 43},
    {"VkRayTracingShaderGroupCreateInfoKHR", 37},
    {"VkRayTracingShaderGroupCreateInfoNV", 36},
    {"VkRect2D", 9},
    {"VkRectLayerKHR", 15},
    {"VkRefreshCycleDurationGOOGLE", 29},
    {"VkReleaseSwapchainImagesInfoEXT", 32},
    {"VkRenderPassAttachmentBeginInfo", 32},
    {"VkRenderPassBeginInfo", 22},
    {"VkRenderPassCreateInfo", 23},
    {"VkRenderPassCreateInfo2", 24},
    {"VkRenderPassCreationControlEXT", 31},
    {"VkRenderPassCreationFeedbackCreateInfoEXT", 42},
    {"VkRenderPassCreationFeedbackInfoEXT", 36},
    {"VkRenderPassFragmentDensityMapCreateInfoEXT", 44},
    {"VkRenderPassInputAttachmentAspectCreateInfo", 44},
    {"VkRenderPassMultiviewCreateInfo", 32},
    {"VkRenderPassSampleLocationsBeginInfoEXT", 40},
    {"VkRenderPassStripeBeginInfoARM", 31},
    {"VkRenderPassStripeInfoARM", 26},
    {"VkRenderPassStripeSubmitInfoARM", 32},
    {"VkRenderPassSubpassFeedbackCreateInfoEXT", 41},
    {"VkRenderPassSubpassFeedbackInfoEXT", 35},
    {"VkRenderPassTransformBeginInfoQCOM", 35},
    {"VkRenderingAreaInfoKHR", 23},
    {"VkRenderingAttachmentInfo", 26},
    {"VkRenderingFragmentDensityMapAttachmentInfoEXT", 47},
    {"VkRenderingFragmentShadingRateAttachmentInfoKHR", 48},
    {"VkRenderingInfo", 16},
    {"VkResolveImageInfo2", 20},
    {"VkSRTDataNV", 12},
    {"VkSampleLocationEXT", 20},
    {"VkSampleLocationsInfoEXT", 25},
    {"VkSamplerBlockMatchWindowCreateInfoQCOM", 40},
    {"VkSamplerBorderColorComponentMappingCreateInfoEXT", 50},
    {"VkSamplerCaptureDescriptorDataInfoEXT", 38},
    {"VkSamplerCreateInfo", 20},
    {"VkSamplerCubicWeightsCreateInfoQCOM", 36},
    {"VkSamplerCustomBorderColorCreateInfoEXT", 40},
    {"VkSamplerReductionModeCreateInfo", 33},
    {"VkSamplerYcbcrConversionCreateInfo", 35},
    {"VkSamplerYcbcrConversionImageFormatProperties", 46},
    {"VkSamplerYcbcrConversionInfo", 29},
    {"VkSamplerYcbcrConversionYcbcrDegammaCreateInfoQCOM", 51},
    {"VkScreenBufferFormatPropertiesQNX", 34},
    {"VkScreenBufferPropertiesQNX", 28},
    {"VkScreenSurfaceCreateInfoQNX", 29},
    {"VkSemaphoreCreateInfo", 22},
    {"VkSemaphoreGetFdInfoKHR", 24},
    {"VkSemaphoreGetWin32HandleInfoKHR", 33},
    {"VkSemaphoreGetZirconHandleInfoFUCHSIA", 38},
    {"VkSemaphoreSignalInfo", 22},
    {"VkSemaphoreSubmitInfo", 22},
    {"VkSemaphoreTypeCreateInfo", 26},
    {"VkSemaphoreWaitInfo", 20},
    {"VkSetDescriptorBufferOffsetsInfoEXT", 36},
    {"VkSetLatencyMarkerInfoNV", 25},
    {"VkSetStateFlagsIndirectCommandNV", 33},
    {"VkShaderCreateInfoEXT", 22},
    {"VkShaderModuleCreateInfo", 25},
    {"VkShaderModuleIdentifierEXT", 28},
    {"VkShaderModuleValidationCacheCreateInfoEXT", 43},
    {"VkShaderResourceUsageAMD", 25},
    {"VkShaderStatisticsInfoAMD", 26},
    {"VkShadingRatePaletteNV", 23},
    {"VkSharedPresentSurfaceCapabilitiesKHR", 38},
    {"VkSparseBufferMemoryBindInfo", 29},
    {"VkSparseImageFormatProperties", 30},
    {"VkSparseImageFormatProperties2", 31},
    {"VkSparseImageMemoryBind", 24},
    {"VkSparseImageMemoryBindInfo", 28},
    {"VkSparseImageMemoryRequirements", 32},
    {"VkSparseImageMemoryRequirements2", 33},
    {"VkSparseImageOpaqueMemoryBindInfo", 34},
    {"VkSparseMemoryBind", 19},
    {"VkSpecializationInfo", 21},
    {"VkSpecializationMapEntry", 25},
    {"VkStencilOpState", 17},
    {"VkStreamDescriptorSurfaceCreateInfoGGP", 39},
    {"VkStridedDeviceAddressRegionKHR", 32},
    {"VkSubmitInfo", 13},
    {"VkSubmitInfo2", 14},
    {"VkSubpassBeginInfo", 19},
    {"VkSubpassDependency", 20},
    {"VkSubpassDependency2", 21},
    {"VkSubpassDescription", 21},
    {"VkSubpassDescription2", 22},
    {"VkSubpassDescriptionDepthStencilResolve", 40},
    {"VkSubpassEndInfo", 17},
    {"VkSubpassFragmentDensityMapOffsetEndInfoQCOM", 45},
    {"VkSubpassResolvePerformanceQueryEXT", 36},
    {"VkSubpassSampleLocationsEXT", 28},
    {"VkSubpassShadingPipelineCreateInfoHUAWEI", 41},
    {"VkSubresourceHostMemcpySizeEXT", 31},
    {"VkSubresourceLayout", 20},
    {"VkSubresourceLayout2KHR", 24},
    {"VkSurfaceCapabilities2EXT", 26},
    {"VkSurfaceCapabilities2KHR", 26},
    {"VkSurfaceCapabilitiesFullScreenExclusiveEXT", 44},
    {"VkSurfaceCapabilitiesKHR", 25},
    {"VkSurfaceCapabilitiesPresentBarrierNV", 38},
    {"VkSurfaceFormat2KHR", 20},
    {"VkSurfaceFormatKHR", 19},
    {"VkSurfaceFullScreenExclusiveInfoEXT", 36},
    {"VkSurfaceFullScreenExclusiveWin32InfoEXT", 41},
    {"VkSurfacePresentModeCompatibilityEXT", 37},
    {"VkSurfacePresentModeEXT", 24},
    {"VkSurfacePresentScalingCapabilitiesEXT", 39},
    {"VkSurfaceProtectedCapabilitiesKHR", 34},
    {"VkSwapchainCounterCreateInfoEXT", 32},
    {"VkSwapchainCreateInfoKHR", 25},
    {"VkSwapchainDisplayNativeHdrCreateInfoAMD", 41},
    {"VkSwapchainLatencyCreateInfoNV", 31},
    {"VkSwapchainPresentBarrierCreateInfoNV", 38},
    {"VkSwapchainPresentFenceInfoEXT", 31},
    {"VkSwapchainPresentModeInfoEXT", 30},
    {"VkSwapchainPresentModesCreateInfoEXT", 37},
    {"VkSwapchainPresentScalingCreateInfoEXT", 39},
    {"VkSysmemColorSpaceFUCHSIA", 26},
    {"VkTextureLODGatherFormatPropertiesAMD", 38},
    {"VkTilePropertiesQCOM", 21},
    {"VkTimelineSemaphoreSubmitInfo", 30},
    {"VkTraceRaysIndirectCommand2KHR", 31},
    {"VkTraceRaysIndirectCommandKHR", 30},
    {"VkTransformMatrixKHR", 21},
    {"VkValidationCacheCreateInfoEXT", 31},
    {"VkValidationFeaturesEXT", 24},
    {"VkValidationFlagsEXT", 21},
    {"VkVertexInputAttributeDescription", 34},
    {"VkVertexInputAttributeDescription2EXT", 38},
    {"VkVertexInputBindingDescription", 32},
    {"VkVertexInputBindingDescription2EXT", 36},
    {"VkVertexInputBindingDivisorDescriptionKHR", 42},
    {"VkViSurfaceCreateInfoNN", 24},
    {"VkVideoBeginCodingInfoKHR", 26},
    {"VkVideoCapabilitiesKHR", 23},
    {"VkVideoCodingControlInfoKHR", 28},
    {"VkVideoDecodeCapabilitiesKHR", 29},
    {"VkVideoDecodeH264CapabilitiesKHR", 33},
    {"VkVideoDecodeH264DpbSlotInfoKHR", 32},
    {"VkVideoDecodeH264PictureInfoKHR", 32},
    {"VkVideoDecodeH264ProfileInfoKHR", 32},
    {"VkVideoDecodeH264SessionParametersAddInfoKHR", 45},
    {"VkVideoDecodeH264SessionParametersCreateInfoKHR", 48},
    {"VkVideoDecodeH265CapabilitiesKHR", 33},
    {"VkVideoDecodeH265DpbSlotInfoKHR", 32},
    {"VkVideoDecodeH265PictureInfoKHR", 32},
    {"VkVideoDecodeH265ProfileInfoKHR", 32},
    {"VkVideoDecodeH265SessionParametersAddInfoKHR", 45},
    {"VkVideoDecodeH265SessionParametersCreateInfoKHR", 48},
    {"VkVideoDecodeInfoKHR", 21},
    {"VkVideoDecodeUsageInfoKHR", 26},
    {"VkVideoEncodeCapabilitiesKHR", 29},
    {"VkVideoEncodeH264CapabilitiesKHR", 33},
    {"VkVideoEncodeH264DpbSlotInfoKHR", 32},
    {"VkVideoEncodeH264FrameSizeKHR", 30},
    {"VkVideoEncodeH264GopRemainingFrameInfoKHR", 42},
    {"VkVideoEncodeH264NaluSliceInfoKHR", 34},
    {"VkVideoEncodeH264PictureInfoKHR", 32},
    {"VkVideoEncodeH264ProfileInfoKHR", 32},
    {"VkVideoEncodeH264QpKHR", 23},
    {"VkVideoEncodeH264QualityLevelPropertiesKHR", 43},
    {"VkVideoEncodeH264RateControlInfoKHR", 36},
    {"VkVideoEncodeH264RateControlLayerInfoKHR", 41},
    {"VkVideoEncodeH264SessionCreateInfoKHR", 38},
    {"VkVideoEncodeH264SessionParametersAddInfoKHR", 45},
    {"VkVideoEncodeH264SessionParametersCreateInfoKHR", 48},
    {"VkVideoEncodeH264SessionParametersFeedbackInfoKHR", 50},
    {"VkVideoEncodeH264SessionParametersGetInfoKHR", 45},
    {"VkVideoEncodeH265CapabilitiesKHR", 33},
    {"VkVideoEncodeH265DpbSlotInfoKHR", 32},
    {"VkVideoEncodeH265FrameSizeKHR", 30},
    {"VkVideoEncodeH265GopRemainingFrameInfoKHR", 42},
    {"VkVideoEncodeH265NaluSliceSegmentInfoKHR", 41},
    {"VkVideoEncodeH265PictureInfoKHR", 32},
    {"VkVideoEncodeH265ProfileInfoKHR", 32},
    {"VkVideoEncodeH265QpKHR", 23},
    {"VkVideoEncodeH265QualityLevelPropertiesKHR", 43},
    {"VkVideoEncodeH265RateControlInfoKHR", 36},
    {"VkVideoEncodeH265RateControlLayerInfoKHR", 41},
    {"VkVideoEncodeH265SessionCreateInfoKHR", 38},
    {"VkVideoEncodeH265SessionParametersAddInfoKHR", 45},
    {"VkVideoEncodeH265SessionParametersCreateInfoKHR", 48},
    {"VkVideoEncodeH265SessionParametersFeedbackInfoKHR", 50},
    {"VkVideoEncodeH265SessionParametersGetInfoKHR", 45},
    {"VkVideoEncodeInfoKHR", 21},
    {"VkVideoEncodeQualityLevelInfoKHR", 33},
    {"VkVideoEncodeQualityLevelPropertiesKHR", 39},
    {"VkVideoEncodeRateControlInfoKHR", 32},
    {"VkVideoEncodeRateControlLayerInfoKHR", 37},
    {"VkVideoEncodeSessionParametersFeedbackInfoKHR", 46},
    {"VkVideoEncodeSessionParametersGetInfoKHR", 41},
    {"VkVideoEncodeUsageInfoKHR", 26},
    {"VkVideoEndCodingInfoKHR", 24},
    {"VkVideoFormatPropertiesKHR", 27},
    {"VkVideoInlineQueryInfoKHR", 26},
    {"VkVideoPictureResourceInfoKHR", 30},
    {"VkVideoProfileInfoKHR", 22},
    {"VkVideoProfileListInfoKHR", 26},
    {"VkVideoReferenceSlotInfoKHR", 28},
    {"VkVideoSessionCreateInfoKHR", 28},
    {"VkVideoSessionMemoryRequirementsKHR", 36},
    {"VkVideoSessionParametersCreateInfoKHR", 38},
    {"VkVideoSessionParametersUpdateInfoKHR", 38},
    {"VkViewport", 11},
    {"VkViewportSwizzleNV", 20},
    {"VkViewportWScalingNV", 21},
    {"VkWaylandSurfaceCreateInfoKHR", 30},
    {"VkWin32KeyedMutexAcquireReleaseInfoKHR", 39},
    {"VkWin32KeyedMutexAcquireReleaseInfoNV", 38},
    {"VkWin32SurfaceCreateInfoKHR", 28},
    {"VkWriteDescriptorSet", 21},
    {"VkWriteDescriptorSetAccelerationStructureKHR", 45},
    {"VkWriteDescriptorSetAccelerationStructureNV", 44},
    {"VkWriteDescriptorSetInlineUniformBlock", 39},
    {"VkXYColorEXT", 13},
    {"VkXcbSurfaceCreateInfoKHR", 26},
    {"VkXlibSurfaceCreateInfoKHR", 27},
    };
    return table[(int)structure].data();
}

const char* String(Field field) {
    static const std::string_view table[] = {
    {"INVALID_EMPTY", 15}, // Field::Empty
    {"AType", 6},
    {"BType", 6},
    {"CType", 6},
    {"DType", 6},
    {"KSize", 6},
    {"MSize", 6},
    {"NSize", 6},
    {"ResultType", 11},
    {"a", 2},
    {"aabbData", 9},
    {"aabbs", 6},
    {"accelerationStructure", 22},
    {"accelerationStructureCaptureReplay", 35},
    {"accelerationStructureCaptureReplayDescriptorDataSize", 53},
    {"accelerationStructureCount", 27},
    {"accelerationStructureDescriptorSize", 36},
    {"accelerationStructureHostCommands", 34},
    {"accelerationStructureIndirectBuild", 35},
    {"accelerationStructureNV", 24},
    {"accelerationStructureReference", 31},
    {"accelerationStructureSize", 26},
    {"acquireCount", 13},
    {"acquireUnmodifiedMemory", 24},
    {"activeComputeUnitCount", 23},
    {"actualPresentTime", 18},
    {"address", 8},
    {"addressInfoCount", 17},
    {"addressModeU", 13},
    {"addressModeV", 13},
    {"addressModeW", 13},
    {"addressPrecision", 17},
    {"addressType", 12},
    {"advancedBlendAllOperations", 27},
    {"advancedBlendCoherentOperations", 32},
    {"advancedBlendCorrelatedOverlap", 31},
    {"advancedBlendIndependentBlend", 30},
    {"advancedBlendMaxColorAttachments", 33},
    {"advancedBlendNonPremultipliedDstColor", 38},
    {"advancedBlendNonPremultipliedSrcColor", 38},
    {"advancedBlendOp", 16},
    {"alignment", 10},
    {"allocationSize", 15},
    {"allowCommandBufferQueryCopies", 30},
    {"allowSamplerImageViewPostSubmitCreation", 40},
    {"alphaBlendOp", 13},
    {"alphaMode", 10},
    {"alphaToCoverageEnable", 22},
    {"alphaToOne", 11},
    {"alphaToOneEnable", 17},
    {"amigoProfiling", 15},
    {"androidHardwareBufferUsage", 27},
    {"anisotropyEnable", 17},
    {"anyHitShader", 13},
    {"apiVersion", 11},
    {"applicationNameOffset", 22},
    {"applicationVersion", 19},
    {"apronSize", 10},
    {"arrayLayer", 11},
    {"arrayLayers", 12},
    {"arrayOfPointers", 16},
    {"arrayPitch", 11},
    {"aspectMask", 11},
    {"aspectReferenceCount", 21},
    {"attachment", 11},
    {"attachmentCount", 16},
    {"attachmentFeedbackLoopDynamicState", 35},
    {"attachmentFeedbackLoopLayout", 29},
    {"attachmentFragmentShadingRate", 30},
    {"attachmentImageInfoCount", 25},
    {"attachmentIndex", 16},
    {"attachmentInitialSampleLocationsCount", 38},
    {"averageBitrate", 15},
    {"b", 2},
    {"b32", 4},
    {"back", 5},
    {"baseAddress", 12},
    {"baseArrayLayer", 15},
    {"baseGroupX", 11},
    {"baseGroupY", 11},
    {"baseGroupZ", 11},
    {"baseMipLevel", 13},
    {"basePipelineHandle", 19},
    {"basePipelineIndex", 18},
    {"baseTriangle", 13},
    {"bidirectionalFlowSupported", 27},
    {"bindCount", 10},
    {"bindInfoCount", 14},
    {"bindSessionMemoryInfoCount", 27},
    {"binding", 8},
    {"bindingCount", 13},
    {"bindingPoint", 13},
    {"bindingType", 12},
    {"blendConstants", 15},
    {"blendEnable", 12},
    {"blendOverlap", 13},
    {"blockDimX", 10},
    {"blockDimY", 10},
    {"blockDimZ", 10},
    {"blockTexelViewCompatibleMultipleLayers", 39},
    {"borderColor", 12},
    {"borderColorSwizzle", 19},
    {"borderColorSwizzleFromImage", 28},
    {"bresenhamLines", 15},
    {"buffer", 7},
    {"bufferAddress", 14},
    {"bufferBindCount", 16},
    {"bufferCaptureReplayDescriptorDataSize", 38},
    {"bufferCollectionConstraints", 28},
    {"bufferCount", 12},
    {"bufferDeviceAddress", 20},
    {"bufferDeviceAddressCaptureReplay", 33},
    {"bufferDeviceAddressMultiDevice", 31},
    {"bufferFeatures", 15},
    {"bufferImageGranularity", 23},
    {"bufferImageHeight", 18},
    {"bufferMemoryBarrierCount", 25},
    {"bufferOffset", 13},
    {"bufferRowLength", 16},
    {"bufferView", 11},
    {"bufferlessPushDescriptors", 26},
    {"buildScratchSize", 17},
    {"buildType", 10},
    {"c", 2},
    {"callableShaderBindingOffset", 28},
    {"callableShaderBindingStride", 28},
    {"callableShaderBindingTableAddress", 34},
    {"callableShaderBindingTableBuffer", 33},
    {"callableShaderBindingTableSize", 31},
    {"callableShaderBindingTableStride", 33},
    {"callback", 9},
    {"capabilities", 13},
    {"category", 9},
    {"checkpointExecutionStageMask", 29},
    {"chromaBitDepth", 15},
    {"chromaFilter", 13},
    {"chromaSubsampling", 18},
    {"clampResults", 13},
    {"clearValue", 11},
    {"clearValueCount", 16},
    {"clipped", 8},
    {"closestHitShader", 17},
    {"clusterShadingRate", 19},
    {"clustercullingShader", 21},
    {"cmdBufLabelCount", 17},
    {"codeSize", 9},
    {"codeType", 9},
    {"codedExtent", 12},
    {"codedOffset", 12},
    {"collection", 11},
    {"collectionToken", 16},
    {"color", 6},
    {"colorAttachment", 16},
    {"colorAttachmentCount", 21},
    {"colorAttachmentFormat", 22},
    {"colorBlendOp", 13},
    {"colorSamples", 13},
    {"colorSpace", 11},
    {"colorSpaceCount", 16},
    {"colorWriteEnable", 17},
    {"colorWriteMask", 15},
    {"combinedImageSamplerDensityMapDescriptorSize", 45},
    {"combinedImageSamplerDescriptorCount", 36},
    {"combinedImageSamplerDescriptorSingleArray", 42},
    {"combinedImageSamplerDescriptorSize", 35},
    {"combinerOps", 12},
    {"commandBuffer", 14},
    {"commandBufferCount", 19},
    {"commandBufferInfoCount", 23},
    {"commandPool", 12},
    {"compactedSize", 14},
    {"compareEnable", 14},
    {"compareMask", 12},
    {"compareOp", 10},
    {"compatibleHandleTypes", 22},
    {"compilerControlFlags", 21},
    {"componentMapping", 17},
    {"components", 11},
    {"compositeAlpha", 15},
    {"compressedSize", 15},
    {"compressionControlPlaneCount", 29},
    {"computeCapabilityMajor", 23},
    {"computeCapabilityMinor", 23},
    {"computeDerivativeGroupLinear", 29},
    {"computeDerivativeGroupQuads", 28},
    {"computeFullSubgroups", 21},
    {"computeUnitsPerShaderArray", 27},
    {"computeWorkGroupSize", 21},
    {"conditionalRendering", 21},
    {"conditionalRenderingEnable", 27},
    {"configuration", 14},
    {"conformanceVersion", 19},
    {"connection", 11},
    {"connectorId", 12},
    {"consecutiveBFrameCount", 23},
    {"conservativePointAndLineRasterization", 38},
    {"conservativeRasterizationMode", 30},
    {"conservativeRasterizationPostDepthCoverage", 43},
    {"constantAlphaColorBlendFactors", 31},
    {"constantID", 11},
    {"constantQp", 11},
    {"contents", 9},
    {"context", 8},
    {"conversion", 11},
    {"cooperativeMatrix", 18},
    {"cooperativeMatrixRobustBufferAccess", 36},
    {"cooperativeMatrixSupportedStages", 33},
    {"copyBufferAddress", 18},
    {"copyCount", 10},
    {"copyDstLayoutCount", 19},
    {"copySrcLayoutCount", 19},
    {"cornerSampledImage", 19},
    {"correlatedViewMaskCount", 24},
    {"correlationMaskCount", 21},
    {"costFormat", 11},
    {"costSupported", 14},
    {"count", 6},
    {"countBuffer", 12},
    {"countBufferOffset", 18},
    {"countInfo", 10},
    {"counter", 8},
    {"counterBuffer", 14},
    {"counterBufferCount", 19},
    {"counterBufferOffset", 20},
    {"counterIndexCount", 18},
    {"counterOffset", 14},
    {"counterPassIndex", 17},
    {"coverageModulationMode", 23},
    {"coverageModulationTableCount", 29},
    {"coverageModulationTableEnable", 30},
    {"coverageReductionMode", 22},
    {"coverageToColorEnable", 22},
    {"coverageToColorLocation", 24},
    {"createFlags", 12},
    {"createInfo", 11},
    {"createInfoCount", 16},
    {"createInfoIndex", 16},
    {"ctbSizes", 9},
    {"cubicRangeClamp", 16},
    {"cubicWeights", 13},
    {"cudaKernelLaunchFeatures", 25},
    {"cullMode", 9},
    {"currentDisplay", 15},
    {"currentExtent", 14},
    {"currentStackIndex", 18},
    {"currentTransform", 17},
    {"customBorderColor", 18},
    {"customBorderColorWithoutFormat", 31},
    {"customBorderColors", 19},
    {"customSampleOrderCount", 23},
    {"data", 5},
    {"dataOffset", 11},
    {"dataSize", 9},
    {"decodeMode", 11},
    {"decodeModeSharedExponent", 25},
    {"decompressRegionCount", 22},
    {"decompressedSize", 17},
    {"decompressionMethod", 20},
    {"decompressionMethods", 21},
    {"dedicatedAllocation", 20},
    {"dedicatedAllocationImageAliasing", 33},
    {"defaultRobustnessImages", 24},
    {"defaultRobustnessStorageBuffers", 32},
    {"defaultRobustnessUniformBuffers", 32},
    {"defaultRobustnessVertexInputs", 30},
    {"deferredOperation", 18},
    {"degenerateLinesRasterized", 26},
    {"degenerateTrianglesRasterized", 30},
    {"denormBehaviorIndependence", 27},
    {"dependencyCount", 16},
    {"dependencyFlags", 16},
    {"depth", 6},
    {"depthAttachmentFormat", 22},
    {"depthBiasClamp", 15},
    {"depthBiasConstantFactor", 24},
    {"depthBiasControl", 17},
    {"depthBiasEnable", 16},
    {"depthBiasExact", 15},
    {"depthBiasRepresentation", 24},
    {"depthBiasSlopeFactor", 21},
    {"depthBounds", 12},
    {"depthBoundsTestEnable", 22},
    {"depthClamp", 11},
    {"depthClampEnable", 17},
    {"depthClampZeroOne", 18},
    {"depthClipControl", 17},
    {"depthClipEnable", 16},
    {"depthCompareOp", 15},
    {"depthFailOp", 12},
    {"depthPitch", 11},
    {"depthResolveMode", 17},
    {"depthStencil", 13},
    {"depthStencilAttachmentSamples", 30},
    {"depthStencilSamples", 20},
    {"depthStencilSwizzleOneSupport", 30},
    {"depthTestEnable", 16},
    {"depthWriteEnable", 17},
    {"description", 12},
    {"descriptorBindingAccelerationStructureUpdateAfterBind", 54},
    {"descriptorBindingInlineUniformBlockUpdateAfterBind", 51},
    {"descriptorBindingPartiallyBound", 32},
    {"descriptorBindingSampledImageUpdateAfterBind", 45},
    {"descriptorBindingStorageBufferUpdateAfterBind", 46},
    {"descriptorBindingStorageImageUpdateAfterBind", 45},
    {"descriptorBindingStorageTexelBufferUpdateAfterBind", 51},
    {"descriptorBindingUniformBufferUpdateAfterBind", 46},
    {"descriptorBindingUniformTexelBufferUpdateAfterBind", 51},
    {"descriptorBindingUpdateUnusedWhilePending", 42},
    {"descriptorBindingVariableDescriptorCount", 41},
    {"descriptorBuffer", 17},
    {"descriptorBufferAddressSpaceSize", 33},
    {"descriptorBufferCaptureReplay", 30},
    {"descriptorBufferImageLayoutIgnored", 35},
    {"descriptorBufferOffsetAlignment", 32},
    {"descriptorBufferPushDescriptors", 32},
    {"descriptorCopyCount", 20},
    {"descriptorCount", 16},
    {"descriptorIndexing", 19},
    {"descriptorOffset", 17},
    {"descriptorPool", 15},
    {"descriptorPoolOverallocation", 29},
    {"descriptorSet", 14},
    {"descriptorSetCount", 19},
    {"descriptorSetHostMapping", 25},
    {"descriptorSetLayout", 20},
    {"descriptorSize", 15},
    {"descriptorType", 15},
    {"descriptorTypeCount", 20},
    {"descriptorUpdateEntryCount", 27},
    {"descriptorUpdateTemplate", 25},
    {"descriptorWriteCount", 21},
    {"desiredPresentTime", 19},
    {"device", 7},
    {"deviceAddress", 14},
    {"deviceCoherentMemory", 21},
    {"deviceEvent", 12},
    {"deviceFault", 12},
    {"deviceFaultVendorBinary", 24},
    {"deviceGeneratedCommands", 24},
    {"deviceGeneratedCompute", 23},
    {"deviceGeneratedComputeCaptureReplay", 36},
    {"deviceGeneratedComputePipelines", 32},
    {"deviceID", 9},
    {"deviceIndex", 12},
    {"deviceIndexCount", 17},
    {"deviceLUID", 11},
    {"deviceLUIDValid", 16},
    {"deviceMask", 11},
    {"deviceMemoryReport", 19},
    {"deviceName", 11},
    {"deviceNodeMask", 15},
    {"deviceRelativeId", 17},
    {"deviceRenderAreaCount", 22},
    {"deviceType", 11},
    {"deviceUUID", 11},
    {"dfb", 4},
    {"diagnosticsConfig", 18},
    {"disabledValidationCheckCount", 29},
    {"disabledValidationFeatureCount", 31},
    {"disallowMerging", 16},
    {"discardRectangleCount", 22},
    {"discardRectangleEnable", 23},
    {"discardRectangleMode", 21},
    {"discardable", 12},
    {"discreteQueuePriorities", 24},
    {"displacedMicromapPrimitiveFlags", 32},
    {"displacedMicromapPrimitiveFlagsStride", 38},
    {"displacementBiasAndScaleBuffer", 31},
    {"displacementBiasAndScaleFormat", 31},
    {"displacementBiasAndScaleStride", 31},
    {"displacementMicromap", 21},
    {"displacementVectorBuffer", 25},
    {"displacementVectorFormat", 25},
    {"displacementVectorStride", 25},
    {"display", 8},
    {"displayEvent", 13},
    {"displayMode", 12},
    {"displayModeProperties", 22},
    {"displayName", 12},
    {"displayPlaneProperties", 23},
    {"displayPrimaryBlue", 19},
    {"displayPrimaryGreen", 20},
    {"displayPrimaryRed", 18},
    {"displayProperties", 18},
    {"divisor", 8},
    {"domainOrigin", 13},
    {"dpy", 4},
    {"drawCount", 10},
    {"drawIndirectCount", 18},
    {"drawIndirectFirstInstance", 26},
    {"driverCount", 12},
    {"driverEndTimeUs", 16},
    {"driverID", 9},
    {"driverInfo", 11},
    {"driverName", 11},
    {"driverStartTimeUs", 18},
    {"driverUUID", 11},
    {"driverVersion", 14},
    {"drmFd", 6},
    {"drmFormatModifier", 18},
    {"drmFormatModifierCount", 23},
    {"drmFormatModifierPlaneCount", 28},
    {"drmFormatModifierTilingFeatures", 32},
    {"dst", 4},
    {"dstAccelerationStructure", 25},
    {"dstAccessMask", 14},
    {"dstAddress", 11},
    {"dstAlphaBlendFactor", 20},
    {"dstArrayElement", 16},
    {"dstBinding", 11},
    {"dstBuffer", 10},
    {"dstBufferOffset", 16},
    {"dstBufferRange", 15},
    {"dstCache", 9},
    {"dstColorBlendFactor", 20},
    {"dstImage", 9},
    {"dstImageLayout", 15},
    {"dstMicromap", 12},
    {"dstOffset", 10},
    {"dstOffsets", 11},
    {"dstPictureResource", 19},
    {"dstPremultiplied", 17},
    {"dstQueueFamilyIndex", 20},
    {"dstRect", 8},
    {"dstSet", 7},
    {"dstStageMask", 13},
    {"dstSubpass", 11},
    {"dstSubresource", 15},
    {"dualSrcBlend", 13},
    {"duration", 9},
    {"dwAccess", 9},
    {"dynamicOffsetCount", 19},
    {"dynamicPipelineLayout", 22},
    {"dynamicPrimitiveTopologyUnrestricted", 37},
    {"dynamicRendering", 17},
    {"dynamicRenderingUnusedAttachments", 34},
    {"dynamicStateCount", 18},
    {"earliestPresentTime", 20},
    {"earlyFragmentMultisampleCoverageAfterSampleCounting", 52},
    {"earlyFragmentSampleMaskTestBeforeSampleCounting", 48},
    {"enable", 7},
    {"enableCbCrDegamma", 18},
    {"enableYDegamma", 15},
    {"enabledExtensionCount", 22},
    {"enabledLayerCount", 18},
    {"enabledValidationFeatureCount", 30},
    {"encodeFeedbackFlags", 20},
    {"encodeInputPictureGranularity", 30},
    {"engineNameOffset", 17},
    {"engineVersion", 14},
    {"event", 6},
    {"eventCount", 11},
    {"events", 7},
    {"exclusiveScissor", 17},
    {"exclusiveScissorCount", 22},
    {"executableIndex", 16},
    {"executionGraph", 15},
    {"executionGraphDispatchAddressAlignment", 39},
    {"expectDyadicTemporalLayerPattern", 33},
    {"expectDyadicTemporalSubLayerPattern", 36},
    {"exportFromImportedHandleTypes", 30},
    {"exportObjectType", 17},
    {"extendedDynamicState", 21},
    {"extendedDynamicState2", 22},
    {"extendedDynamicState2LogicOp", 29},
    {"extendedDynamicState2PatchControlPoints", 40},
    {"extendedDynamicState3AlphaToCoverageEnable", 43},
    {"extendedDynamicState3AlphaToOneEnable", 38},
    {"extendedDynamicState3ColorBlendAdvanced", 40},
    {"extendedDynamicState3ColorBlendEnable", 38},
    {"extendedDynamicState3ColorBlendEquation", 40},
    {"extendedDynamicState3ColorWriteMask", 36},
    {"extendedDynamicState3ConservativeRasterizationMode", 51},
    {"extendedDynamicState3CoverageModulationMode", 44},
    {"extendedDynamicState3CoverageModulationTable", 45},
    {"extendedDynamicState3CoverageModulationTableEnable", 51},
    {"extendedDynamicState3CoverageReductionMode", 43},
    {"extendedDynamicState3CoverageToColorEnable", 43},
    {"extendedDynamicState3CoverageToColorLocation", 45},
    {"extendedDynamicState3DepthClampEnable", 38},
    {"extendedDynamicState3DepthClipEnable", 37},
    {"extendedDynamicState3DepthClipNegativeOneToOne", 47},
    {"extendedDynamicState3ExtraPrimitiveOverestimationSize", 54},
    {"extendedDynamicState3LineRasterizationMode", 43},
    {"extendedDynamicState3LineStippleEnable", 39},
    {"extendedDynamicState3LogicOpEnable", 35},
    {"extendedDynamicState3PolygonMode", 33},
    {"extendedDynamicState3ProvokingVertexMode", 41},
    {"extendedDynamicState3RasterizationSamples", 42},
    {"extendedDynamicState3RasterizationStream", 41},
    {"extendedDynamicState3RepresentativeFragmentTestEnable", 54},
    {"extendedDynamicState3SampleLocationsEnable", 43},
    {"extendedDynamicState3SampleMask", 32},
    {"extendedDynamicState3ShadingRateImageEnable", 44},
    {"extendedDynamicState3TessellationDomainOrigin", 46},
    {"extendedDynamicState3ViewportSwizzle", 37},
    {"extendedDynamicState3ViewportWScalingEnable", 44},
    {"extendedSparseAddressSpace", 27},
    {"extendedSparseAddressSpaceSize", 31},
    {"extendedSparseBufferUsageFlags", 31},
    {"extendedSparseImageUsageFlags", 30},
    {"extensionName", 14},
    {"extent", 7},
    {"externalFenceFeatures", 22},
    {"externalFormat", 15},
    {"externalFormatResolve", 22},
    {"externalFormatResolveChromaOffsetX", 35},
    {"externalFormatResolveChromaOffsetY", 35},
    {"externalHandleType", 19},
    {"externalMemoryFeatures", 23},
    {"externalMemoryProperties", 25},
    {"externalMemoryRDMA", 19},
    {"externalSemaphoreFeatures", 26},
    {"extraCount", 11},
    {"extraPrimitiveOverestimationSize", 33},
    {"extraPrimitiveOverestimationSizeGranularity", 44},
    {"f64", 4},
    {"faceMask", 9},
    {"failOp", 7},
    {"fd", 3},
    {"features", 9},
    {"fence", 6},
    {"fenceCount", 11},
    {"fieldOffsetGranularity", 23},
    {"fillModeNonSolid", 17},
    {"filter", 7},
    {"filterCenter", 13},
    {"filterCubic", 12},
    {"filterCubicMinmax", 18},
    {"filterMinmaxImageComponentMapping", 34},
    {"filterMinmaxSingleComponentFormats", 35},
    {"filterSize", 11},
    {"finalLayout", 12},
    {"firstAttachment", 16},
    {"firstBinding", 13},
    {"firstCounterBuffer", 19},
    {"firstDiscardRectangle", 22},
    {"firstDrawTimestamp", 19},
    {"firstExclusiveScissor", 22},
    {"firstGroup", 11},
    {"firstIndex", 11},
    {"firstInstance", 14},
    {"firstQuery", 11},
    {"firstScissor", 13},
    {"firstSet", 9},
    {"firstTask", 10},
    {"firstVertex", 12},
    {"firstViewport", 14},
    {"flags", 6},
    {"float32", 8},
    {"float64", 8},
    {"floatRepresentation", 20},
    {"flowVectorFormat", 17},
    {"fmaRate", 8},
    {"forceExplicitReconstruction", 28},
    {"format", 7},
    {"formatA4B4G4R4", 15},
    {"formatA4R4G4B4", 15},
    {"formatConstraintsCount", 23},
    {"formatFeatures", 15},
    {"formatProperties", 17},
    {"formatRgba10x6WithoutYCbCrSampler", 34},
    {"fragmentDensityInvocations", 27},
    {"fragmentDensityMap", 19},
    {"fragmentDensityMapAttachment", 29},
    {"fragmentDensityMapDeferred", 27},
    {"fragmentDensityMapDynamic", 26},
    {"fragmentDensityMapNonSubsampledImages", 38},
    {"fragmentDensityMapOffset", 25},
    {"fragmentDensityOffsetCount", 27},
    {"fragmentDensityOffsetGranularity", 33},
    {"fragmentShaderBarycentric", 26},
    {"fragmentShaderPixelInterlock", 29},
    {"fragmentShaderSampleInterlock", 30},
    {"fragmentShaderShadingRateInterlock", 35},
    {"fragmentShadingRateClampCombinerInputs", 39},
    {"fragmentShadingRateEnums", 25},
    {"fragmentShadingRateNonTrivialCombinerOps", 41},
    {"fragmentShadingRateStrictMultiplyCombiner", 42},
    {"fragmentShadingRateWithConservativeRasterization", 49},
    {"fragmentShadingRateWithCustomSampleLocations", 45},
    {"fragmentShadingRateWithFragmentShaderInterlock", 47},
    {"fragmentShadingRateWithSampleMask", 34},
    {"fragmentShadingRateWithShaderDepthStencilWrites", 48},
    {"fragmentShadingRateWithShaderSampleMask", 40},
    {"fragmentSize", 13},
    {"fragmentStoresAndAtomics", 25},
    {"frameBSize", 11},
    {"frameBoundary", 14},
    {"frameID", 8},
    {"frameISize", 11},
    {"framePSize", 11},
    {"frameRateDenominator", 21},
    {"frameRateNumerator", 19},
    {"frameToken", 11},
    {"framebuffer", 12},
    {"framebufferColorSampleCounts", 29},
    {"framebufferDepthSampleCounts", 29},
    {"framebufferIntegerColorSampleCounts", 36},
    {"framebufferNoAttachmentsSampleCounts", 37},
    {"framebufferStencilSampleCounts", 31},
    {"front", 6},
    {"frontFace", 10},
    {"fullDrawIndexUint32", 20},
    {"fullScreenExclusive", 20},
    {"fullScreenExclusiveSupported", 29},
    {"fullyCoveredFragmentShaderInputVariable", 40},
    {"function", 9},
    {"g", 2},
    {"generalShader", 14},
    {"generatePrefixNalu", 19},
    {"geometry", 9},
    {"geometryCount", 14},
    {"geometryShader", 15},
    {"geometryStreams", 16},
    {"geometryType", 13},
    {"globalAlpha", 12},
    {"globalFlowSupported", 20},
    {"globalPriority", 15},
    {"globalPriorityQuery", 20},
    {"gopFrameCount", 14},
    {"gopRemainingB", 14},
    {"gopRemainingI", 14},
    {"gopRemainingP", 14},
    {"gpuRenderEndTimeUs", 19},
    {"gpuRenderStartTimeUs", 21},
    {"graphicsPipelineLibrary", 24},
    {"graphicsPipelineLibraryFastLinking", 35},
    {"graphicsPipelineLibraryIndependentInterpolationDecoration", 58},
    {"gridDimX", 9},
    {"gridDimY", 9},
    {"gridDimZ", 9},
    {"group", 6},
    {"groupCount", 11},
    {"groupCountX", 12},
    {"groupCountY", 12},
    {"groupCountZ", 12},
    {"groupIndex", 11},
    {"groupShader", 12},
    {"handle", 7},
    {"handleType", 11},
    {"handleTypes", 12},
    {"hasOverrides", 13},
    {"hasPrimary", 11},
    {"hasRender", 10},
    {"hasStdPPSOverrides", 19},
    {"hasStdSPSOverrides", 19},
    {"hasStdVPSOverrides", 19},
    {"headerSize", 11},
    {"headerVersion", 14},
    {"heapBudget", 11},
    {"heapIndex", 10},
    {"heapUsage", 10},
    {"height", 7},
    {"hinstance", 10},
    {"hintGridSize", 13},
    {"hintSupported", 14},
    {"hitShaderBindingOffset", 23},
    {"hitShaderBindingStride", 23},
    {"hitShaderBindingTableAddress", 29},
    {"hitShaderBindingTableBuffer", 28},
    {"hitShaderBindingTableSize", 26},
    {"hitShaderBindingTableStride", 28},
    {"hmonitor", 9},
    {"hostAddress", 12},
    {"hostImageCopy", 14},
    {"hostQueryReset", 15},
    {"hwnd", 5},
    {"i64", 4},
    {"id", 3},
    {"identicalMemoryLayout", 22},
    {"identicalMemoryTypeRequirements", 32},
    {"identifier", 11},
    {"identifierSize", 15},
    {"idrPeriod", 10},
    {"image", 6},
    {"image2DViewOf3D", 16},
    {"imageArrayLayers", 17},
    {"imageBindCount", 15},
    {"imageCaptureReplayDescriptorDataSize", 37},
    {"imageColorSpace", 16},
    {"imageCompressionControl", 24},
    {"imageCompressionControlSwapchain", 33},
    {"imageCompressionFixedRateFlags", 31},
    {"imageCompressionFlags", 22},
    {"imageCount", 11},
    {"imageCreateFlags", 17},
    {"imageCreateInfo", 16},
    {"imageCubeArray", 15},
    {"imageExtent", 12},
    {"imageFootprint", 15},
    {"imageFormat", 12},
    {"imageFormatProperties", 22},
    {"imageGranularity", 17},
    {"imageIndex", 11},
    {"imageIndexCount", 16},
    {"imageLayout", 12},
    {"imageMemoryBarrierCount", 24},
    {"imageMipTailFirstLod", 21},
    {"imageMipTailOffset", 19},
    {"imageMipTailSize", 17},
    {"imageMipTailStride", 19},
    {"imageOffset", 12},
    {"imageOpaqueBindCount", 21},
    {"imagePipeHandle", 16},
    {"imageSharingMode", 17},
    {"imageSlicedViewOf3D", 20},
    {"imageSubresource", 17},
    {"imageTiling", 12},
    {"imageType", 10},
    {"imageUsage", 11},
    {"imageUsageFlags", 16},
    {"imageView", 10},
    {"imageView2DOn3DImage", 21},
    {"imageViewBinding", 17},
    {"imageViewCaptureReplayDescriptorDataSize", 41},
    {"imageViewFormatReinterpretation", 32},
    {"imageViewFormatSwizzle", 23},
    {"imageViewType", 14},
    {"imagelessFramebuffer", 21},
    {"images", 7},
    {"implementationVersion", 22},
    {"independentBlend", 17},
    {"independentResolve", 19},
    {"independentResolveNone", 23},
    {"index", 6},
    {"indexBuffer", 12},
    {"indexCount", 11},
    {"indexData", 10},
    {"indexOffset", 12},
    {"indexStride", 12},
    {"indexType", 10},
    {"indexTypeCount", 15},
    {"indexTypeUint8", 15},
    {"indirectBufferOffsetAlignment", 30},
    {"indirectCommandsAddress", 24},
    {"indirectCommandsCountAddress", 29},
    {"indirectCommandsLayout", 23},
    {"indirectCopy", 13},
    {"indirectDeviceAddress", 22},
    {"indirectStateFlags", 19},
    {"info", 5},
    {"infoCount", 10},
    {"infoType", 9},
    {"infos", 6},
    {"inheritedConditionalRendering", 30},
    {"inheritedQueries", 17},
    {"inheritedViewportScissor2D", 27},
    {"initialDataSize", 16},
    {"initialLayout", 14},
    {"initialValue", 13},
    {"initialVirtualBufferSizeInMs", 29},
    {"inlineUniformBlock", 19},
    {"inputAttachmentCount", 21},
    {"inputAttachmentDescriptorSize", 30},
    {"inputAttachmentIndex", 21},
    {"inputRate", 10},
    {"inputSampleTimeUs", 18},
    {"instance", 9},
    {"instanceCount", 14},
    {"instanceCustomIndex", 20},
    {"instanceData", 13},
    {"instanceOffset", 15},
    {"instanceShaderBindingTableRecordOffset", 39},
    {"instances", 10},
    {"int32", 6},
    {"int64", 6},
    {"integerDotProduct16BitMixedSignednessAccelerated", 49},
    {"integerDotProduct16BitSignedAccelerated", 40},
    {"integerDotProduct16BitUnsignedAccelerated", 42},
    {"integerDotProduct32BitMixedSignednessAccelerated", 49},
    {"integerDotProduct32BitSignedAccelerated", 40},
    {"integerDotProduct32BitUnsignedAccelerated", 42},
    {"integerDotProduct4x8BitPackedMixedSignednessAccelerated", 56},
    {"integerDotProduct4x8BitPackedSignedAccelerated", 47},
    {"integerDotProduct4x8BitPackedUnsignedAccelerated", 49},
    {"integerDotProduct64BitMixedSignednessAccelerated", 49},
    {"integerDotProduct64BitSignedAccelerated", 40},
    {"integerDotProduct64BitUnsignedAccelerated", 42},
    {"integerDotProduct8BitMixedSignednessAccelerated", 48},
    {"integerDotProduct8BitSignedAccelerated", 39},
    {"integerDotProduct8BitUnsignedAccelerated", 41},
    {"integerDotProductAccumulatingSaturating16BitMixedSignednessAccelerated", 71},
    {"integerDotProductAccumulatingSaturating16BitSignedAccelerated", 62},
    {"integerDotProductAccumulatingSaturating16BitUnsignedAccelerated", 64},
    {"integerDotProductAccumulatingSaturating32BitMixedSignednessAccelerated", 71},
    {"integerDotProductAccumulatingSaturating32BitSignedAccelerated", 62},
    {"integerDotProductAccumulatingSaturating32BitUnsignedAccelerated", 64},
    {"integerDotProductAccumulatingSaturating4x8BitPackedMixedSignednessAccelerated", 78},
    {"integerDotProductAccumulatingSaturating4x8BitPackedSignedAccelerated", 69},
    {"integerDotProductAccumulatingSaturating4x8BitPackedUnsignedAccelerated", 71},
    {"integerDotProductAccumulatingSaturating64BitMixedSignednessAccelerated", 71},
    {"integerDotProductAccumulatingSaturating64BitSignedAccelerated", 62},
    {"integerDotProductAccumulatingSaturating64BitUnsignedAccelerated", 64},
    {"integerDotProductAccumulatingSaturating8BitMixedSignednessAccelerated", 70},
    {"integerDotProductAccumulatingSaturating8BitSignedAccelerated", 61},
    {"integerDotProductAccumulatingSaturating8BitUnsignedAccelerated", 63},
    {"intersectionShader", 19},
    {"invocationMask", 15},
    {"ioSurface", 10},
    {"isPreprocessed", 15},
    {"isText", 7},
    {"largePoints", 12},
    {"latencyModeEnable", 18},
    {"layer", 6},
    {"layerCount", 11},
    {"layerName", 10},
    {"layeredShadingRateAttachments", 30},
    {"layers", 7},
    {"layout", 7},
    {"ldsSizePerLocalWorkGroup", 25},
    {"ldsUsageSizeInBytes", 20},
    {"leastRepresentableValueForceUnormRepresentation", 48},
    {"legacyDithering", 16},
    {"level", 6},
    {"levelCount", 11},
    {"libraryCount", 13},
    {"limits", 7},
    {"lineRasterizationMode", 22},
    {"lineStippleFactor", 18},
    {"lineStipplePattern", 19},
    {"lineSubPixelPrecisionBits", 26},
    {"lineWidth", 10},
    {"lineWidthGranularity", 21},
    {"lineWidthRange", 15},
    {"linearColorAttachment", 22},
    {"linearTilingFeatures", 21},
    {"loadOp", 7},
    {"localDeviceIndex", 17},
    {"localDimmingEnable", 19},
    {"localDimmingSupport", 20},
    {"location", 9},
    {"logicOp", 8},
    {"logicOpEnable", 14},
    {"lowLatencyBoost", 16},
    {"lowLatencyMode", 15},
    {"lumaBitDepth", 13},
    {"magFilter", 10},
    {"maintenance4", 13},
    {"maintenance5", 13},
    {"maintenance6", 13},
    {"major", 6},
    {"mapEntryCount", 14},
    {"marker", 7},
    {"mask", 5},
    {"matrix", 7},
    {"matrixMotionInstance", 21},
    {"maxActiveReferencePictures", 27},
    {"maxAnisotropy", 14},
    {"maxArrayLayers", 15},
    {"maxBPictureL0ReferenceCount", 28},
    {"maxBitrate", 11},
    {"maxBlockMatchRegion", 20},
    {"maxBlockMatchWindow", 20},
    {"maxBoundDescriptorSets", 23},
    {"maxBoxFilterBlockSize", 22},
    {"maxBufferCount", 15},
    {"maxBufferSize", 14},
    {"maxClipDistances", 17},
    {"maxCodedExtent", 15},
    {"maxColorAttachments", 20},
    {"maxCombinedClipAndCullDistances", 32},
    {"maxCombinedImageSamplerDescriptorCount", 39},
    {"maxCommandBufferNestingLevel", 29},
    {"maxComputeSharedMemorySize", 27},
    {"maxComputeWorkGroupCount", 25},
    {"maxComputeWorkGroupInvocations", 31},
    {"maxComputeWorkGroupSize", 24},
    {"maxComputeWorkgroupSubgroups", 29},
    {"maxContentLightLevel", 21},
    {"maxCullDistances", 17},
    {"maxCustomBorderColorSamplers", 29},
    {"maxDecompressionIndirectCount", 30},
    {"maxDepth", 9},
    {"maxDepthBounds", 15},
    {"maxDescriptorBufferBindings", 28},
    {"maxDescriptorSetAccelerationStructures", 39},
    {"maxDescriptorSetInlineUniformBlocks", 36},
    {"maxDescriptorSetInputAttachments", 33},
    {"maxDescriptorSetSampledImages", 30},
    {"maxDescriptorSetSamplers", 25},
    {"maxDescriptorSetStorageBuffers", 31},
    {"maxDescriptorSetStorageBuffersDynamic", 38},
    {"maxDescriptorSetStorageImages", 30},
    {"maxDescriptorSetSubsampledSamplers", 35},
    {"maxDescriptorSetUniformBuffers", 31},
    {"maxDescriptorSetUniformBuffersDynamic", 38},
    {"maxDescriptorSetUpdateAfterBindAccelerationStructures", 54},
    {"maxDescriptorSetUpdateAfterBindInlineUniformBlocks", 51},
    {"maxDescriptorSetUpdateAfterBindInputAttachments", 48},
    {"maxDescriptorSetUpdateAfterBindSampledImages", 45},
    {"maxDescriptorSetUpdateAfterBindSamplers", 40},
    {"maxDescriptorSetUpdateAfterBindStorageBuffers", 46},
    {"maxDescriptorSetUpdateAfterBindStorageBuffersDynamic", 53},
    {"maxDescriptorSetUpdateAfterBindStorageImages", 45},
    {"maxDescriptorSetUpdateAfterBindUniformBuffers", 46},
    {"maxDescriptorSetUpdateAfterBindUniformBuffersDynamic", 53},
    {"maxDiscardRectangles", 21},
    {"maxDisplacementMicromapSubdivisionLevel", 40},
    {"maxDpbSlots", 12},
    {"maxDrawCount", 13},
    {"maxDrawIndexedIndexValue", 25},
    {"maxDrawIndirectCount", 21},
    {"maxDrawMeshTasksCount", 22},
    {"maxDstExtent", 13},
    {"maxDstPosition", 15},
    {"maxEmbeddedImmutableSamplerBindings", 36},
    {"maxEmbeddedImmutableSamplers", 29},
    {"maxExecutionGraphDepth", 23},
    {"maxExecutionGraphShaderOutputNodes", 35},
    {"maxExecutionGraphShaderPayloadCount", 36},
    {"maxExecutionGraphShaderPayloadSize", 35},
    {"maxExtent", 10},
    {"maxExtraPrimitiveOverestimationSize", 36},
    {"maxFragmentCombinedOutputResources", 35},
    {"maxFragmentDensityTexelSize", 28},
    {"maxFragmentDualSrcAttachments", 30},
    {"maxFragmentInputComponents", 27},
    {"maxFragmentOutputAttachments", 29},
    {"maxFragmentShadingRateAttachmentTexelSize", 42},
    {"maxFragmentShadingRateAttachmentTexelSizeAspectRatio", 53},
    {"maxFragmentShadingRateCoverageSamples", 38},
    {"maxFragmentShadingRateInvocationCount", 38},
    {"maxFragmentShadingRateRasterizationSamples", 43},
    {"maxFragmentSize", 16},
    {"maxFragmentSizeAspectRatio", 27},
    {"maxFrameAverageLightLevel", 26},
    {"maxFrameSize", 13},
    {"maxFramebufferHeight", 21},
    {"maxFramebufferLayers", 21},
    {"maxFramebufferWidth", 20},
    {"maxGeometryCount", 17},
    {"maxGeometryInputComponents", 27},
    {"maxGeometryOutputComponents", 28},
    {"maxGeometryOutputVertices", 26},
    {"maxGeometryShaderInvocations", 29},
    {"maxGeometryTotalOutputComponents", 33},
    {"maxGraphicsShaderGroupCount", 28},
    {"maxHeight", 10},
    {"maxImageArrayLayers", 20},
    {"maxImageCount", 14},
    {"maxImageDimension1D", 20},
    {"maxImageDimension2D", 20},
    {"maxImageDimension3D", 20},
    {"maxImageDimensionCube", 22},
    {"maxImageExtent", 15},
    {"maxIndirectCommandsStreamCount", 31},
    {"maxIndirectCommandsStreamStride", 32},
    {"maxIndirectCommandsTokenCount", 30},
    {"maxIndirectCommandsTokenOffset", 31},
    {"maxIndirectSequenceCount", 25},
    {"maxInlineUniformBlockBindings", 30},
    {"maxInlineUniformBlockSize", 26},
    {"maxInlineUniformTotalSize", 26},
    {"maxInstanceCount", 17},
    {"maxInstances", 13},
    {"maxInterpolationOffset", 23},
    {"maxL1ReferenceCount", 20},
    {"maxLevelIdc", 12},
    {"maxLod", 7},
    {"maxLuminance", 13},
    {"maxMemoryAllocationCount", 25},
    {"maxMemoryAllocationSize", 24},
    {"maxMeshMultiviewViewCount", 26},
    {"maxMeshOutputComponents", 24},
    {"maxMeshOutputLayers", 20},
    {"maxMeshOutputMemorySize", 24},
    {"maxMeshOutputPrimitives", 24},
    {"maxMeshOutputVertices", 22},
    {"maxMeshPayloadAndOutputMemorySize", 34},
    {"maxMeshPayloadAndSharedMemorySize", 34},
    {"maxMeshSharedMemorySize", 24},
    {"maxMeshTotalMemorySize", 23},
    {"maxMeshWorkGroupCount", 22},
    {"maxMeshWorkGroupInvocations", 28},
    {"maxMeshWorkGroupSize", 21},
    {"maxMeshWorkGroupTotalCount", 27},
    {"maxMipLevels", 13},
    {"maxMultiDrawCount", 18},
    {"maxMultiviewInstanceIndex", 26},
    {"maxMultiviewViewCount", 22},
    {"maxNumRegionsOfInterest", 24},
    {"maxOpacity2StateSubdivisionLevel", 33},
    {"maxOpacity4StateSubdivisionLevel", 33},
    {"maxOutputClusterCount", 22},
    {"maxPPictureL0ReferenceCount", 28},
    {"maxPerSetDescriptors", 21},
    {"maxPerStageDescriptorAccelerationStructures", 44},
    {"maxPerStageDescriptorInlineUniformBlocks", 41},
    {"maxPerStageDescriptorInputAttachments", 38},
    {"maxPerStageDescriptorSampledImages", 35},
    {"maxPerStageDescriptorSamplers", 30},
    {"maxPerStageDescriptorStorageBuffers", 36},
    {"maxPerStageDescriptorStorageImages", 35},
    {"maxPerStageDescriptorUniformBuffers", 36},
    {"maxPerStageDescriptorUpdateAfterBindAccelerationStructures", 59},
    {"maxPerStageDescriptorUpdateAfterBindInlineUniformBlocks", 56},
    {"maxPerStageDescriptorUpdateAfterBindInputAttachments", 53},
    {"maxPerStageDescriptorUpdateAfterBindSampledImages", 50},
    {"maxPerStageDescriptorUpdateAfterBindSamplers", 45},
    {"maxPerStageDescriptorUpdateAfterBindStorageBuffers", 51},
    {"maxPerStageDescriptorUpdateAfterBindStorageImages", 50},
    {"maxPerStageDescriptorUpdateAfterBindUniformBuffers", 51},
    {"maxPerStageResources", 21},
    {"maxPerStageUpdateAfterBindResources", 36},
    {"maxPipelineRayHitAttributeSize", 31},
    {"maxPipelineRayPayloadSize", 26},
    {"maxPipelineRayRecursionDepth", 29},
    {"maxPreferredMeshWorkGroupInvocations", 37},
    {"maxPreferredTaskWorkGroupInvocations", 37},
    {"maxPrimitiveCount", 18},
    {"maxPushConstantsSize", 21},
    {"maxPushDescriptors", 19},
    {"maxQp", 6},
    {"maxQualityLevels", 17},
    {"maxRateControlLayers", 21},
    {"maxRayDispatchInvocationCount", 30},
    {"maxRayHitAttributeSize", 23},
    {"maxRayRecursionDepth", 21},
    {"maxRecursionDepth", 18},
    {"maxRenderPassStripes", 21},
    {"maxResourceDescriptorBufferBindings", 36},
    {"maxResourceDescriptorBufferRange", 33},
    {"maxResourceSize", 16},
    {"maxSampleLocationGridSize", 26},
    {"maxSampleMaskWords", 19},
    {"maxSamplerAllocationCount", 26},
    {"maxSamplerAnisotropy", 21},
    {"maxSamplerDescriptorBufferBindings", 35},
    {"maxSamplerDescriptorBufferRange", 32},
    {"maxSamplerLodBias", 18},
    {"maxScaledImageExtent", 21},
    {"maxSequencesCount", 18},
    {"maxSets", 8},
    {"maxSgprAllocation", 18},
    {"maxShaderGroupStride", 21},
    {"maxSliceCount", 14},
    {"maxSliceSegmentCount", 21},
    {"maxSrcExtent", 13},
    {"maxSrcPosition", 15},
    {"maxStdPPSCount", 15},
    {"maxStdSPSCount", 15},
    {"maxStdVPSCount", 15},
    {"maxStorageBufferRange", 22},
    {"maxSubLayerCount", 17},
    {"maxSubgroupSize", 16},
    {"maxSubpassShadingWorkgroupSizeAspectRatio", 42},
    {"maxSubsampledArrayLayers", 25},
    {"maxTaskOutputCount", 19},
    {"maxTaskPayloadAndSharedMemorySize", 34},
    {"maxTaskPayloadSize", 19},
    {"maxTaskSharedMemorySize", 24},
    {"maxTaskTotalMemorySize", 23},
    {"maxTaskWorkGroupCount", 22},
    {"maxTaskWorkGroupInvocations", 28},
    {"maxTaskWorkGroupSize", 21},
    {"maxTaskWorkGroupTotalCount", 27},
    {"maxTemporalLayerCount", 22},
    {"maxTessellationControlPerPatchOutputComponents", 47},
    {"maxTessellationControlPerVertexInputComponents", 47},
    {"maxTessellationControlPerVertexOutputComponents", 48},
    {"maxTessellationControlTotalOutputComponents", 44},
    {"maxTessellationEvaluationInputComponents", 41},
    {"maxTessellationEvaluationOutputComponents", 42},
    {"maxTessellationGenerationLevel", 31},
    {"maxTessellationPatchSize", 25},
    {"maxTexelBufferElements", 23},
    {"maxTexelGatherOffset", 21},
    {"maxTexelOffset", 15},
    {"maxTiles", 9},
    {"maxTimelineSemaphoreValueDifference", 36},
    {"maxTransformFeedbackBufferDataSize", 35},
    {"maxTransformFeedbackBufferDataStride", 37},
    {"maxTransformFeedbackBufferSize", 31},
    {"maxTransformFeedbackBuffers", 28},
    {"maxTransformFeedbackStreamDataSize", 35},
    {"maxTransformFeedbackStreams", 28},
    {"maxTriangleCount", 17},
    {"maxUniformBufferRange", 22},
    {"maxUpdateAfterBindDescriptorsInAllPools", 40},
    {"maxVariableDescriptorCount", 27},
    {"maxVertex", 10},
    {"maxVertexAttribDivisor", 23},
    {"maxVertexInputAttributeOffset", 30},
    {"maxVertexInputAttributes", 25},
    {"maxVertexInputBindingStride", 28},
    {"maxVertexInputBindings", 23},
    {"maxVertexOutputComponents", 26},
    {"maxVgprAllocation", 18},
    {"maxViewportDimensions", 22},
    {"maxViewports", 13},
    {"maxWeightFilterDimension", 25},
    {"maxWeightFilterPhases", 22},
    {"maxWidth", 9},
    {"maxWorkGroupCount", 18},
    {"maxWorkGroupSize", 17},
    {"maxX", 5},
    {"maxY", 5},
    {"maxZ", 5},
    {"memory", 7},
    {"memoryBarrierCount", 19},
    {"memoryBindIndex", 16},
    {"memoryDecompression", 20},
    {"memoryDeviceIndex", 18},
    {"memoryHeapCount", 16},
    {"memoryHeaps", 12},
    {"memoryImageHeight", 18},
    {"memoryObjectId", 15},
    {"memoryOffset", 13},
    {"memoryPriority", 15},
    {"memoryProperties", 17},
    {"memoryRangeCount", 17},
    {"memoryRequirements", 19},
    {"memoryRowLength", 16},
    {"memorySize", 11},
    {"memoryTypeBits", 15},
    {"memoryTypeCount", 16},
    {"memoryTypeIndex", 16},
    {"memoryTypes", 12},
    {"meshOutputPerPrimitiveGranularity", 34},
    {"meshOutputPerVertexGranularity", 31},
    {"meshShader", 11},
    {"meshShaderQueries", 18},
    {"messageCode", 12},
    {"messageIdNumber", 16},
    {"messageSeverity", 16},
    {"messageType", 12},
    {"messageTypes", 13},
    {"messenger", 10},
    {"micromap", 9},
    {"micromapCaptureReplay", 22},
    {"micromapCount", 14},
    {"micromapHostCommands", 21},
    {"micromapSize", 13},
    {"minAccelerationStructureScratchOffsetAlignment", 47},
    {"minBitstreamBufferOffsetAlignment", 34},
    {"minBitstreamBufferSizeAlignment", 32},
    {"minBufferCount", 15},
    {"minBufferCountForCamping", 25},
    {"minBufferCountForDedicatedSlack", 32},
    {"minBufferCountForSharedSlack", 29},
    {"minCodedExtent", 15},
    {"minDepth", 9},
    {"minDepthBounds", 15},
    {"minDstExtent", 13},
    {"minDstPosition", 15},
    {"minFilter", 10},
    {"minFragmentDensityTexelSize", 28},
    {"minFragmentShadingRateAttachmentTexelSize", 42},
    {"minHeight", 10},
    {"minImageCount", 14},
    {"minImageExtent", 15},
    {"minImageTransferGranularity", 28},
    {"minImportedHostPointerAlignment", 32},
    {"minIndirectCommandsBufferOffsetAlignment", 41},
    {"minInterpolationOffset", 23},
    {"minLod", 7},
    {"minLuminance", 13},
    {"minMemoryMapAlignment", 22},
    {"minQp", 6},
    {"minSampleShading", 17},
    {"minScaledImageExtent", 21},
    {"minSequencesCountBufferOffsetAlignment", 39},
    {"minSequencesIndexBufferOffsetAlignment", 39},
    {"minSgprAllocation", 18},
    {"minSrcExtent", 13},
    {"minSrcPosition", 15},
    {"minStorageBufferOffsetAlignment", 32},
    {"minSubgroupSize", 16},
    {"minTexelBufferOffsetAlignment", 30},
    {"minTexelGatherOffset", 21},
    {"minTexelOffset", 15},
    {"minUniformBufferOffsetAlignment", 32},
    {"minVertexInputBindingStrideAlignment", 37},
    {"minVgprAllocation", 18},
    {"minWidth", 9},
    {"minX", 5},
    {"minY", 5},
    {"minZ", 5},
    {"minimumIntervalUs", 18},
    {"minor", 6},
    {"mipLevel", 9},
    {"mipLevels", 10},
    {"mipLodBias", 11},
    {"mipmapMode", 11},
    {"mipmapPrecisionBits", 20},
    {"missShaderBindingOffset", 24},
    {"missShaderBindingStride", 24},
    {"missShaderBindingTableAddress", 30},
    {"missShaderBindingTableBuffer", 29},
    {"missShaderBindingTableSize", 27},
    {"missShaderBindingTableStride", 29},
    {"mode", 5},
    {"modes", 6},
    {"module", 7},
    {"mtlBuffer", 10},
    {"mtlCommandQueue", 16},
    {"mtlDevice", 10},
    {"mtlSharedEvent", 15},
    {"mtlTexture", 11},
    {"multiDraw", 10},
    {"multiDrawIndirect", 18},
    {"multiViewport", 14},
    {"multisampleArrayImage", 22},
    {"multisampledRenderToSingleSampled", 34},
    {"multisampledRenderToSingleSampledEnable", 40},
    {"multiview", 10},
    {"multiviewClusterCullingShader", 30},
    {"multiviewGeometryShader", 24},
    {"multiviewMeshShader", 20},
    {"multiviewPerViewRenderAreas", 28},
    {"multiviewPerViewViewports", 26},
    {"multiviewTessellationShader", 28},
    {"mutableComparisonSamplers", 26},
    {"mutableDescriptorType", 22},
    {"mutableDescriptorTypeListCount", 31},
    {"naluSliceEntryCount", 20},
    {"naluSliceSegmentEntryCount", 27},
    {"name", 5},
    {"negativeOneToOne", 17},
    {"nestedCommandBuffer", 20},
    {"nestedCommandBufferRendering", 29},
    {"nestedCommandBufferSimultaneousUse", 35},
    {"newLayout", 10},
    {"nextStage", 10},
    {"noInvocationFragmentShadingRates", 33},
    {"nodeIndex", 10},
    {"nonCoherentAtomSize", 20},
    {"nonSeamlessCubeMap", 19},
    {"nonStrictSinglePixelWideLinesUseParallelogram", 46},
    {"nonStrictWideLinesUseParallelogram", 35},
    {"nullColorAttachmentWithExternalFormatResolve", 45},
    {"nullDescriptor", 15},
    {"numAABBs", 9},
    {"numAvailableSgprs", 18},
    {"numAvailableVgprs", 18},
    {"numPhases", 10},
    {"numPhysicalSgprs", 17},
    {"numPhysicalVgprs", 17},
    {"numUsedSgprs", 13},
    {"numUsedVgprs", 13},
    {"object", 7},
    {"objectCount", 12},
    {"objectHandle", 13},
    {"objectType", 11},
    {"occlusionQueryEnable", 21},
    {"occlusionQueryPrecise", 22},
    {"offset", 7},
    {"oldLayout", 10},
    {"oldSwapchain", 13},
    {"opaqueCaptureAddress", 21},
    {"opaqueCaptureDescriptorData", 28},
    {"operation", 10},
    {"opticalFlow", 12},
    {"optimal", 8},
    {"optimalBufferCopyOffsetAlignment", 33},
    {"optimalBufferCopyRowPitchAlignment", 35},
    {"optimalDeviceAccess", 20},
    {"optimalTilingFeatures", 22},
    {"optimalTilingLayoutUUID", 24},
    {"origin", 7},
    {"osRenderQueueEndTimeUs", 23},
    {"osRenderQueueStartTimeUs", 25},
    {"outputGridSize", 15},
    {"overallocationBehavior", 23},
    {"pAccelerationStructure", 23},
    {"pAccelerationStructures", 24},
    {"pAcquireInfo", 13},
    {"pAcquireKeys", 13},
    {"pAcquireSyncs", 14},
    {"pAcquireTimeoutMilliseconds", 28},
    {"pAcquireTimeouts", 17},
    {"pAddress", 9},
    {"pAddressInfos", 14},
    {"pAllocateInfo", 14},
    {"pAllocator", 11},
    {"pApiVersion", 12},
    {"pApplicationInfo", 17},
    {"pApplicationName", 17},
    {"pAspectReferences", 18},
    {"pAttachmentImageInfos", 22},
    {"pAttachmentInitialSampleLocations", 34},
    {"pAttachments", 13},
    {"pAttributes", 12},
    {"pBeginInfo", 11},
    {"pBindDescriptorBufferEmbeddedSamplersInfo", 42},
    {"pBindDescriptorSetsInfo", 24},
    {"pBindInfo", 10},
    {"pBindInfos", 11},
    {"pBindSessionMemoryInfos", 24},
    {"pBindingFlags", 14},
    {"pBindingInfos", 14},
    {"pBindingReference", 18},
    {"pBindings", 10},
    {"pBinds", 7},
    {"pBlitImageInfo", 15},
    {"pBuffer", 8},
    {"pBufferBinds", 13},
    {"pBufferConstraintsInfo", 23},
    {"pBufferIndices", 15},
    {"pBufferInfo", 12},
    {"pBufferMemoryBarriers", 22},
    {"pBuffers", 9},
    {"pBuildInfo", 11},
    {"pCacheData", 11},
    {"pCacheSize", 11},
    {"pCallableShaderBindingTable", 28},
    {"pCallback", 10},
    {"pCallbackData", 14},
    {"pCapabilities", 14},
    {"pCheckpointData", 16},
    {"pCheckpointDataCount", 21},
    {"pCheckpointMarker", 18},
    {"pClearValues", 13},
    {"pCmdBufLabels", 14},
    {"pCode", 6},
    {"pCodingControlInfo", 19},
    {"pCollection", 12},
    {"pColor", 7},
    {"pColorAttachmentFormats", 24},
    {"pColorAttachmentSamples", 24},
    {"pColorAttachments", 18},
    {"pColorBlendAdvanced", 20},
    {"pColorBlendEnables", 19},
    {"pColorBlendEquations", 21},
    {"pColorBlendState", 17},
    {"pColorSpaces", 13},
    {"pColorWriteEnables", 19},
    {"pColorWriteMasks", 17},
    {"pCombinationCount", 18},
    {"pCombinations", 14},
    {"pCombinedImageSampler", 22},
    {"pCommandBufferDeviceMasks", 26},
    {"pCommandBufferInfos", 20},
    {"pCommandBuffers", 16},
    {"pCommandPool", 13},
    {"pCommittedMemoryInBytes", 24},
    {"pCompatibility", 15},
    {"pConditionalRenderingBegin", 27},
    {"pConfiguration", 15},
    {"pCopyBufferInfo", 16},
    {"pCopyBufferToImageInfo", 23},
    {"pCopyDstLayouts", 16},
    {"pCopyImageInfo", 15},
    {"pCopyImageToBufferInfo", 23},
    {"pCopyImageToImageInfo", 22},
    {"pCopyImageToMemoryInfo", 23},
    {"pCopyMemoryToImageInfo", 23},
    {"pCopySrcLayouts", 16},
    {"pCorrelatedViewMasks", 21},
    {"pCorrelationMasks", 18},
    {"pCountInfo", 11},
    {"pCounterBufferOffsets", 22},
    {"pCounterBuffers", 16},
    {"pCounterCount", 14},
    {"pCounterDescriptions", 21},
    {"pCounterIndices", 16},
    {"pCounterValue", 14},
    {"pCounters", 10},
    {"pCoverageModulationTable", 25},
    {"pCreateInfo", 12},
    {"pCreateInfos", 13},
    {"pCustomSampleOrders", 20},
    {"pData", 6},
    {"pDataSize", 10},
    {"pDecodeInfo", 12},
    {"pDecompressMemoryRegions", 25},
    {"pDeferredOperation", 19},
    {"pDependencies", 14},
    {"pDependencyInfo", 16},
    {"pDependencyInfos", 17},
    {"pDepthAttachment", 17},
    {"pDepthBiasInfo", 15},
    {"pDepthStencil", 14},
    {"pDepthStencilAttachment", 24},
    {"pDepthStencilResolveAttachment", 31},
    {"pDepthStencilState", 19},
    {"pDescriptor", 12},
    {"pDescriptorCopies", 18},
    {"pDescriptorCounts", 18},
    {"pDescriptorInfo", 16},
    {"pDescriptorPool", 16},
    {"pDescriptorSets", 16},
    {"pDescriptorTypes", 17},
    {"pDescriptorUpdateEntries", 25},
    {"pDescriptorUpdateTemplate", 26},
    {"pDescriptorWrites", 18},
    {"pDevice", 8},
    {"pDeviceEventInfo", 17},
    {"pDeviceGroupPresentCapabilities", 32},
    {"pDeviceIndices", 15},
    {"pDeviceMasks", 13},
    {"pDeviceRenderAreas", 19},
    {"pDisabledValidationChecks", 26},
    {"pDisabledValidationFeatures", 28},
    {"pDiscardRectangles", 19},
    {"pDisplay", 9},
    {"pDisplayCount", 14},
    {"pDisplayEventInfo", 18},
    {"pDisplayPlaneInfo", 18},
    {"pDisplayPowerInfo", 18},
    {"pDisplayTimingProperties", 25},
    {"pDisplays", 10},
    {"pDrivers", 9},
    {"pDrmFormatModifierProperties", 29},
    {"pDrmFormatModifiers", 20},
    {"pDynamicOffsets", 16},
    {"pDynamicState", 14},
    {"pDynamicStates", 15},
    {"pEnabledFeatures", 17},
    {"pEnabledValidationFeatures", 27},
    {"pEncodeInfo", 12},
    {"pEndCodingInfo", 15},
    {"pEngineName", 12},
    {"pEvent", 7},
    {"pEvents", 8},
    {"pExclusiveScissorEnables", 25},
    {"pExclusiveScissors", 19},
    {"pExecutableCount", 17},
    {"pExecutableInfo", 16},
    {"pExecuteInfo", 13},
    {"pExternalBufferInfo", 20},
    {"pExternalBufferProperties", 26},
    {"pExternalFenceInfo", 19},
    {"pExternalFenceProperties", 25},
    {"pExternalImageFormatProperties", 31},
    {"pExternalSemaphoreInfo", 23},
    {"pExternalSemaphoreProperties", 29},
    {"pExtras", 8},
    {"pFaultCounts", 13},
    {"pFaultInfo", 11},
    {"pFd", 4},
    {"pFeatures", 10},
    {"pFeedbackInfo", 14},
    {"pFence", 7},
    {"pFences", 8},
    {"pFixedRateFlags", 16},
    {"pFormatConstraints", 19},
    {"pFormatCount", 13},
    {"pFormatInfo", 12},
    {"pFormatProperties", 18},
    {"pFragmentDensityOffsets", 24},
    {"pFragmentShadingRateAttachment", 31},
    {"pFragmentShadingRateCount", 26},
    {"pFragmentShadingRates", 22},
    {"pFragmentSize", 14},
    {"pFramebuffer", 13},
    {"pFunction", 10},
    {"pGeneratedCommandsInfo", 23},
    {"pGeometries", 12},
    {"pGetFdInfo", 11},
    {"pGetWin32HandleInfo", 20},
    {"pGetZirconHandleInfo", 21},
    {"pGranularity", 13},
    {"pGroups", 8},
    {"pHandle", 8},
    {"pHitShaderBindingTable", 23},
    {"pHostMapping", 13},
    {"pHostPointer", 13},
    {"pIdentifier", 12},
    {"pImage", 7},
    {"pImageBinds", 12},
    {"pImageConstraintsInfo", 22},
    {"pImageFormatInfo", 17},
    {"pImageFormatProperties", 23},
    {"pImageIndex", 12},
    {"pImageIndices", 14},
    {"pImageInfo", 11},
    {"pImageMemoryBarriers", 21},
    {"pImageOpaqueBinds", 18},
    {"pImageSubresources", 19},
    {"pImages", 8},
    {"pImmutableSamplers", 19},
    {"pImportFenceFdInfo", 19},
    {"pImportFenceWin32HandleInfo", 28},
    {"pImportSemaphoreFdInfo", 23},
    {"pImportSemaphoreWin32HandleInfo", 32},
    {"pImportSemaphoreZirconHandleInfo", 33},
    {"pIndexInfo", 11},
    {"pIndexTypeValues", 17},
    {"pIndexTypes", 12},
    {"pIndirectCommandsLayout", 24},
    {"pIndirectDeviceAddresses", 25},
    {"pIndirectStrides", 17},
    {"pInfo", 6},
    {"pInfoSize", 10},
    {"pInfos", 7},
    {"pInheritanceInfo", 17},
    {"pInitialData", 13},
    {"pInitializeInfo", 16},
    {"pInputAssemblyState", 20},
    {"pInputAttachmentImage", 22},
    {"pInputAttachments", 18},
    {"pInstance", 10},
    {"pInternalRepresentationCount", 29},
    {"pInternalRepresentations", 25},
    {"pLabelInfo", 11},
    {"pLabelName", 11},
    {"pLatencyMarkerInfo", 19},
    {"pLaunchInfo", 12},
    {"pLayer", 7},
    {"pLayerName", 11},
    {"pLayerPrefix", 13},
    {"pLayers", 8},
    {"pLayout", 8},
    {"pLayoutSizeInBytes", 19},
    {"pLibraries", 11},
    {"pLibraryInfo", 13},
    {"pLibraryInterface", 18},
    {"pMapEntries", 12},
    {"pMarkerInfo", 12},
    {"pMarkerName", 12},
    {"pMaxDeviation", 14},
    {"pMaxPrimitiveCounts", 20},
    {"pMaxWorkgroupSize", 18},
    {"pMemory", 8},
    {"pMemoryBarriers", 16},
    {"pMemoryFdProperties", 20},
    {"pMemoryGetRemoteAddressInfo", 28},
    {"pMemoryHostPointerProperties", 29},
    {"pMemoryMapInfo", 15},
    {"pMemoryProperties", 18},
    {"pMemoryRanges", 14},
    {"pMemoryRequirements", 20},
    {"pMemoryRequirementsCount", 25},
    {"pMemoryUnmapInfo", 17},
    {"pMemoryWin32HandleProperties", 29},
    {"pMemoryZirconHandleProperties", 30},
    {"pMessage", 9},
    {"pMessageIdName", 15},
    {"pMessenger", 11},
    {"pMetadata", 10},
    {"pMetalObjectsInfo", 18},
    {"pMicromap", 10},
    {"pMicromaps", 11},
    {"pMissShaderBindingTable", 24},
    {"pMode", 6},
    {"pModes", 7},
    {"pModule", 8},
    {"pMultisampleProperties", 23},
    {"pMultisampleState", 18},
    {"pMutableDescriptorTypeLists", 28},
    {"pNaluSliceEntries", 18},
    {"pNaluSliceSegmentEntries", 25},
    {"pName", 6},
    {"pNameInfo", 10},
    {"pNext", 6},
    {"pNodeIndex", 11},
    {"pNodeInfo", 10},
    {"pNumPasses", 11},
    {"pObjectName", 12},
    {"pObjects", 9},
    {"pOffset", 8},
    {"pOffsets", 9},
    {"pOpticalFlowImageFormatInfo", 28},
    {"pOverrideInfo", 14},
    {"pParametersAddInfo", 19},
    {"pParams", 8},
    {"pPeerMemoryFeatures", 20},
    {"pPerViewRenderAreas", 20},
    {"pPerformanceQueryCreateInfo", 28},
    {"pPhysicalDeviceCount", 21},
    {"pPhysicalDeviceGroupCount", 26},
    {"pPhysicalDeviceGroupProperties", 31},
    {"pPhysicalDevices", 17},
    {"pPictureResource", 17},
    {"pPipelineCache", 15},
    {"pPipelineCreationFeedback", 26},
    {"pPipelineInfo", 14},
    {"pPipelineLayout", 16},
    {"pPipelineProperties", 20},
    {"pPipelineStageCreationFeedbacks", 32},
    {"pPipelines", 11},
    {"pPlaneLayouts", 14},
    {"pPoolSizes", 11},
    {"pPostSubpassSampleLocations", 28},
    {"pPresentIds", 12},
    {"pPresentInfo", 13},
    {"pPresentModeCount", 18},
    {"pPresentModes", 14},
    {"pPresentationTimingCount", 25},
    {"pPresentationTimings", 21},
    {"pPreserveAttachments", 21},
    {"pPrivateData", 13},
    {"pPrivateDataSlot", 17},
    {"pProfiles", 10},
    {"pProperties", 12},
    {"pPropertiesCount", 17},
    {"pPropertyCount", 15},
    {"pPushConstantRanges", 20},
    {"pPushConstantsInfo", 19},
    {"pPushDescriptorSetInfo", 23},
    {"pPushDescriptorSetWithTemplateInfo", 35},
    {"pQualityLevelInfo", 18},
    {"pQualityLevelProperties", 24},
    {"pQueriedLowLatencyData", 23},
    {"pQueryPool", 11},
    {"pQueue", 7},
    {"pQueueCreateInfos", 18},
    {"pQueueFamilyIndices", 20},
    {"pQueueFamilyProperties", 23},
    {"pQueueFamilyPropertyCount", 26},
    {"pQueueInfo", 11},
    {"pQueueLabels", 13},
    {"pQueuePriorities", 17},
    {"pQueueTypeInfo", 15},
    {"pRanges", 8},
    {"pRasterizationState", 20},
    {"pRaygenShaderBindingTable", 26},
    {"pRectCount", 11},
    {"pRectangles", 12},
    {"pRects", 7},
    {"pReferenceSlots", 16},
    {"pRegions", 9},
    {"pReleaseInfo", 13},
    {"pReleaseKeys", 13},
    {"pReleaseSyncs", 14},
    {"pRenderPass", 12},
    {"pRenderPassBegin", 17},
    {"pRenderPassFeedback", 20},
    {"pRenderingAreaInfo", 19},
    {"pRenderingInfo", 15},
    {"pResolveAttachments", 20},
    {"pResolveImageInfo", 18},
    {"pResult", 8},
    {"pResults", 9},
    {"pSampleLocations", 17},
    {"pSampleLocationsInfo", 21},
    {"pSampleMask", 12},
    {"pSampledImage", 14},
    {"pSampler", 9},
    {"pScissors", 10},
    {"pSemaphore", 11},
    {"pSemaphores", 12},
    {"pSession", 9},
    {"pSetDescriptorBufferOffsetsInfo", 32},
    {"pSetLayout", 11},
    {"pSetLayouts", 12},
    {"pSettingName", 13},
    {"pSettings", 10},
    {"pSetupReferenceSlot", 20},
    {"pShaderGroupCaptureReplayHandle", 32},
    {"pShaderModule", 14},
    {"pShaders", 9},
    {"pShadingRatePaletteEntries", 27},
    {"pShadingRatePalettes", 21},
    {"pSignalInfo", 12},
    {"pSignalSemaphoreDeviceIndices", 30},
    {"pSignalSemaphoreInfos", 22},
    {"pSignalSemaphoreValues", 23},
    {"pSignalSemaphores", 18},
    {"pSizeInfo", 10},
    {"pSizes", 7},
    {"pSleepInfo", 11},
    {"pSleepModeInfo", 15},
    {"pSliceOffsets", 14},
    {"pSliceSegmentOffsets", 21},
    {"pSparseMemoryRequirementCount", 30},
    {"pSparseMemoryRequirements", 26},
    {"pSpecializationInfo", 20},
    {"pSplitInstanceBindRegions", 26},
    {"pSrcCaches", 11},
    {"pStages", 8},
    {"pStatisticCount", 16},
    {"pStatistics", 12},
    {"pStdHeaderVersion", 18},
    {"pStdPPSs", 9},
    {"pStdPictureInfo", 16},
    {"pStdReferenceInfo", 18},
    {"pStdSPSs", 9},
    {"pStdSliceHeader", 16},
    {"pStdSliceSegmentHeader", 23},
    {"pStdVPSs", 9},
    {"pStencilAttachment", 19},
    {"pStorageBuffer", 15},
    {"pStorageImage", 14},
    {"pStorageTexelBuffer", 20},
    {"pStreamStrides", 15},
    {"pStreams", 9},
    {"pStrides", 9},
    {"pStripeInfos", 13},
    {"pStripeSemaphoreInfos", 22},
    {"pSubmits", 9},
    {"pSubpassBeginInfo", 18},
    {"pSubpassEndInfo", 16},
    {"pSubpassFeedback", 17},
    {"pSubpasses", 11},
    {"pSubresource", 13},
    {"pSupport", 9},
    {"pSupported", 11},
    {"pSurface", 9},
    {"pSurfaceCapabilities", 21},
    {"pSurfaceFormatCount", 20},
    {"pSurfaceFormats", 16},
    {"pSurfaceInfo", 13},
    {"pSwapchain", 11},
    {"pSwapchainImageCount", 21},
    {"pSwapchainImages", 17},
    {"pSwapchains", 12},
    {"pTag", 5},
    {"pTagInfo", 9},
    {"pTessellationState", 19},
    {"pTexelBufferView", 17},
    {"pTimeDomainCount", 17},
    {"pTimeDomains", 13},
    {"pTimes", 7},
    {"pTimestampInfos", 16},
    {"pTimestamps", 12},
    {"pTimings", 9},
    {"pTokens", 8},
    {"pToolCount", 11},
    {"pToolProperties", 16},
    {"pTransitions", 13},
    {"pUniformBuffer", 15},
    {"pUniformTexelBuffer", 20},
    {"pUpdateInfo", 12},
    {"pUsageCounts", 13},
    {"pUserData", 10},
    {"pValidationCache", 17},
    {"pValue", 7},
    {"pValues", 8},
    {"pVendorBinaryData", 18},
    {"pVendorInfos", 13},
    {"pVersionData", 13},
    {"pVersionInfo", 13},
    {"pVertexAttributeDescriptions", 29},
    {"pVertexBindingDescriptions", 27},
    {"pVertexBindingDivisors", 23},
    {"pVertexInfo", 12},
    {"pVertexInputState", 18},
    {"pVertexOffset", 14},
    {"pVideoFormatInfo", 17},
    {"pVideoFormatProperties", 23},
    {"pVideoFormatPropertyCount", 26},
    {"pVideoProfile", 14},
    {"pVideoSession", 14},
    {"pVideoSessionParameters", 24},
    {"pVideoSessionParametersInfo", 28},
    {"pView", 6},
    {"pViewFormats", 13},
    {"pViewMasks", 11},
    {"pViewOffsets", 13},
    {"pViewportDepths", 16},
    {"pViewportState", 15},
    {"pViewportSwizzles", 18},
    {"pViewportWScalings", 19},
    {"pViewports", 11},
    {"pWaitDstStageMask", 18},
    {"pWaitInfo", 10},
    {"pWaitSemaphoreDeviceIndices", 28},
    {"pWaitSemaphoreInfos", 20},
    {"pWaitSemaphoreValues", 21},
    {"pWaitSemaphores", 16},
    {"pYcbcrConversion", 17},
    {"pZirconHandle", 14},
    {"pageableDeviceLocalMemory", 26},
    {"paramCount", 11},
    {"parameter", 10},
    {"parameters", 11},
    {"passOp", 7},
    {"patch", 6},
    {"patchControlPoints", 19},
    {"payloadCount", 13},
    {"payloadStride", 14},
    {"payloads", 9},
    {"pciBus", 7},
    {"pciDevice", 10},
    {"pciDomain", 10},
    {"pciFunction", 12},
    {"perStageDescriptorSet", 22},
    {"perViewAttributes", 18},
    {"perViewAttributesPositionXOnly", 31},
    {"perViewPositionAllComponents", 29},
    {"perViewRenderAreaCount", 23},
    {"performanceCounterMultipleQueryPools", 37},
    {"performanceCounterQueryPools", 29},
    {"performanceCountersSampling", 28},
    {"performanceLevel", 17},
    {"persistent", 11},
    {"persistentContent", 18},
    {"pfnAllocation", 14},
    {"pfnCallback", 12},
    {"pfnFree", 8},
    {"pfnGetInstanceProcAddr", 23},
    {"pfnInternalAllocation", 22},
    {"pfnInternalFree", 16},
    {"pfnReallocation", 16},
    {"pfnUserCallback", 16},
    {"physicalDevice", 15},
    {"physicalDeviceCount", 20},
    {"physicalDevices", 16},
    {"physicalDimensions", 19},
    {"physicalResolution", 19},
    {"pictureAccessGranularity", 25},
    {"pictureFormat", 14},
    {"pictureLayout", 14},
    {"pipeline", 9},
    {"pipelineAddress", 16},
    {"pipelineBindPoint", 18},
    {"pipelineCache", 14},
    {"pipelineCacheUUID", 18},
    {"pipelineCount", 14},
    {"pipelineCreationCacheControl", 29},
    {"pipelineDeviceAddressCaptureReplay", 35},
    {"pipelineExecutableInfo", 23},
    {"pipelineFragmentShadingRate", 28},
    {"pipelineIdentifier", 19},
    {"pipelineLayout", 15},
    {"pipelineLibraryGroupHandles", 28},
    {"pipelinePropertiesIdentifier", 29},
    {"pipelineProtectedAccess", 24},
    {"pipelineRobustness", 19},
    {"pipelineStackSize", 18},
    {"pipelineStage", 14},
    {"pipelineStageCreationFeedbackCount", 35},
    {"pipelineStatistics", 19},
    {"pipelineStatisticsQuery", 24},
    {"pixelRate", 10},
    {"pixelX", 7},
    {"pixelY", 7},
    {"plane", 6},
    {"planeAspect", 12},
    {"planeIndex", 11},
    {"planeReorderPossible", 21},
    {"planeStackIndex", 16},
    {"pointClippingBehavior", 22},
    {"pointPolygons", 14},
    {"pointSizeGranularity", 21},
    {"pointSizeRange", 15},
    {"polygonMode", 12},
    {"polygonModePointSize", 21},
    {"poolSizeCount", 14},
    {"postMergeIndex", 15},
    {"postMergeSubpassCount", 22},
    {"postSubpassSampleLocationsCount", 32},
    {"powerState", 11},
    {"ppBuildRangeInfos", 18},
    {"ppData", 7},
    {"ppEnabledExtensionNames", 24},
    {"ppEnabledLayerNames", 20},
    {"ppGeometries", 13},
    {"ppMaxPrimitiveCounts", 21},
    {"ppUsageCounts", 14},
    {"preTransform", 13},
    {"precedingExternallyEncodedBytes", 32},
    {"preferredConsecutiveBFrameCount", 32},
    {"preferredConstantQp", 20},
    {"preferredGopFrameCount", 23},
    {"preferredIdrPeriod", 19},
    {"preferredMaxL0ReferenceCount", 29},
    {"preferredMaxL1ReferenceCount", 29},
    {"preferredRateControlFlags", 26},
    {"preferredRateControlLayerCount", 31},
    {"preferredRateControlMode", 25},
    {"preferredStdEntropyCodingModeFlag", 34},
    {"preferredSubLayerCount", 23},
    {"preferredTemporalLayerCount", 28},
    {"prefersCompactPrimitiveOutput", 30},
    {"prefersCompactVertexOutput", 27},
    {"prefersDedicatedAllocation", 27},
    {"prefersGopRemainingFrames", 26},
    {"prefersLocalInvocationPrimitiveOutput", 38},
    {"prefersLocalInvocationVertexOutput", 35},
    {"preprocessBuffer", 17},
    {"preprocessOffset", 17},
    {"preprocessSize", 15},
    {"presentBarrier", 15},
    {"presentBarrierEnable", 21},
    {"presentBarrierSupported", 24},
    {"presentEndTimeUs", 17},
    {"presentGravityX", 16},
    {"presentGravityY", 16},
    {"presentID", 10},
    {"presentId", 10},
    {"presentMargin", 14},
    {"presentMask", 12},
    {"presentMode", 12},
    {"presentModeCount", 17},
    {"presentStartTimeUs", 19},
    {"presentWait", 12},
    {"preserveAttachmentCount", 24},
    {"primaryMajor", 13},
    {"primaryMinor", 13},
    {"primitiveCount", 15},
    {"primitiveFragmentShadingRate", 29},
    {"primitiveFragmentShadingRateMeshShader", 39},
    {"primitiveFragmentShadingRateWithMultipleViewports", 50},
    {"primitiveOffset", 16},
    {"primitiveOverestimationSize", 28},
    {"primitiveRestartEnable", 23},
    {"primitiveTopology", 18},
    {"primitiveTopologyListRestart", 29},
    {"primitiveTopologyPatchListRestart", 34},
    {"primitiveUnderestimation", 25},
    {"primitivesGeneratedQuery", 25},
    {"primitivesGeneratedQueryWithNonZeroStreams", 43},
    {"primitivesGeneratedQueryWithRasterizerDiscard", 46},
    {"priorities", 11},
    {"priority", 9},
    {"priorityCount", 14},
    {"privateData", 12},
    {"privateDataSlot", 16},
    {"privateDataSlotRequestCount", 28},
    {"profileCount", 13},
    {"properties", 11},
    {"propertyFlags", 14},
    {"protectedMemory", 16},
    {"protectedNoFault", 17},
    {"protectedSubmit", 16},
    {"provokingVertexLast", 20},
    {"provokingVertexMode", 20},
    {"provokingVertexModePerPipeline", 31},
    {"purposes", 9},
    {"pushConstantRangeCount", 23},
    {"pushconstantOffset", 19},
    {"pushconstantPipelineLayout", 27},
    {"pushconstantShaderStageFlags", 29},
    {"pushconstantSize", 17},
    {"pvx", 4},
    {"pvy", 4},
    {"pvz", 4},
    {"qpB", 4},
    {"qpI", 4},
    {"qpP", 4},
    {"quadDivergentImplicitLod", 25},
    {"quadOperationsInAllStages", 26},
    {"qualityLevel", 13},
    {"query", 6},
    {"queryCount", 11},
    {"queryFlags", 11},
    {"queryPool", 10},
    {"queryResultStatusSupport", 25},
    {"queryType", 10},
    {"queue", 6},
    {"queueCount", 11},
    {"queueCreateInfoCount", 21},
    {"queueFamilyIndex", 17},
    {"queueFamilyIndexCount", 22},
    {"queueFamilyProperties", 22},
    {"queueFlags", 11},
    {"queueIndex", 11},
    {"queueLabelCount", 16},
    {"queueType", 10},
    {"qw", 3},
    {"qx", 3},
    {"qy", 3},
    {"qz", 3},
    {"r", 2},
    {"range", 6},
    {"rangeCount", 11},
    {"rasterizationOrder", 19},
    {"rasterizationOrderColorAttachmentAccess", 40},
    {"rasterizationOrderDepthAttachmentAccess", 40},
    {"rasterizationOrderStencilAttachmentAccess", 42},
    {"rasterizationSamples", 21},
    {"rasterizationStream", 20},
    {"rasterizerDiscardEnable", 24},
    {"rateControlMode", 16},
    {"rateControlModes", 17},
    {"rayQuery", 9},
    {"rayTracingInvocationReorder", 28},
    {"rayTracingInvocationReorderReorderingHint", 42},
    {"rayTracingMaintenance1", 23},
    {"rayTracingMotionBlur", 21},
    {"rayTracingMotionBlurPipelineTraceRaysIndirect", 46},
    {"rayTracingPipeline", 19},
    {"rayTracingPipelineShaderGroupHandleCaptureReplay", 49},
    {"rayTracingPipelineShaderGroupHandleCaptureReplayMixed", 54},
    {"rayTracingPipelineTraceRaysIndirect", 36},
    {"rayTracingPipelineTraceRaysIndirect2", 37},
    {"rayTracingPositionFetch", 24},
    {"rayTraversalPrimitiveCulling", 29},
    {"raygenShaderBindingOffset", 26},
    {"raygenShaderBindingTableBuffer", 31},
    {"raygenShaderRecordAddress", 26},
    {"raygenShaderRecordSize", 23},
    {"rect", 5},
    {"rectCount", 10},
    {"rectangleCount", 15},
    {"rectangularLines", 17},
    {"reductionMode", 14},
    {"reference", 10},
    {"referencePictureFormat", 23},
    {"referenceSlotCount", 19},
    {"refreshDuration", 16},
    {"refreshRate", 12},
    {"regionCount", 12},
    {"relaxedLineRasterization", 25},
    {"releaseCount", 13},
    {"remoteDeviceIndex", 18},
    {"renderArea", 11},
    {"renderMajor", 12},
    {"renderMinor", 12},
    {"renderPass", 11},
    {"renderPassStripeGranularity", 28},
    {"renderPassStriped", 18},
    {"renderSubmitEndTimeUs", 22},
    {"renderSubmitStartTimeUs", 24},
    {"renderpass", 11},
    {"reportAddressBinding", 21},
    {"reportedAddress", 16},
    {"representativeFragmentTest", 27},
    {"representativeFragmentTestEnable", 33},
    {"requiredFormatFeatures", 23},
    {"requiredSubgroupSize", 21},
    {"requiredSubgroupSizeStages", 27},
    {"requiresDedicatedAllocation", 28},
    {"requiresGopRemainingFrames", 27},
    {"residencyAlignedMipSize", 24},
    {"residencyNonResidentStrict", 27},
    {"residencyStandard2DBlockShape", 30},
    {"residencyStandard2DMultisampleBlockShape", 41},
    {"residencyStandard3DBlockShape", 30},
    {"resolveImageLayout", 19},
    {"resolveImageView", 17},
    {"resolveMode", 12},
    {"resourceDescriptorBufferAddressSpaceSize", 41},
    {"resourceDeviceIndex", 20},
    {"resourceOffset", 15},
    {"resourceUsage", 14},
    {"robustBufferAccess", 19},
    {"robustBufferAccess2", 20},
    {"robustBufferAccessUpdateAfterBind", 34},
    {"robustImageAccess", 18},
    {"robustImageAccess2", 19},
    {"robustStorageBufferAccessSizeAlignment", 39},
    {"robustStorageBufferDescriptorSize", 34},
    {"robustStorageTexelBufferDescriptorSize", 39},
    {"robustUniformBufferAccessSizeAlignment", 39},
    {"robustUniformBufferDescriptorSize", 34},
    {"robustUniformTexelBufferDescriptorSize", 39},
    {"roundingModeIndependence", 25},
    {"rowPitch", 9},
    {"rrOutput", 9},
    {"runtimeDescriptorArray", 23},
    {"sType", 6},
    {"sample", 7},
    {"sampleCount", 12},
    {"sampleCounts", 13},
    {"sampleLocationCoordinateRange", 30},
    {"sampleLocationCount", 20},
    {"sampleLocationGridSize", 23},
    {"sampleLocationSampleCounts", 27},
    {"sampleLocationSubPixelBits", 27},
    {"sampleLocationsCount", 21},
    {"sampleLocationsEnable", 22},
    {"sampleLocationsInfo", 20},
    {"sampleLocationsPerPixel", 24},
    {"sampleOrderType", 16},
    {"sampleRateShading", 18},
    {"sampleShadingEnable", 20},
    {"sampledImageColorSampleCounts", 30},
    {"sampledImageDepthSampleCounts", 30},
    {"sampledImageDescriptorSize", 27},
    {"sampledImageIntegerSampleCounts", 32},
    {"sampledImageStencilSampleCounts", 32},
    {"sampler", 8},
    {"sampler2DViewOf3D", 18},
    {"samplerAnisotropy", 18},
    {"samplerCaptureReplayDescriptorDataSize", 39},
    {"samplerDescriptorBufferAddressSpaceSize", 40},
    {"samplerDescriptorSize", 22},
    {"samplerFilterMinmax", 20},
    {"samplerMipLodBias", 18},
    {"samplerMirrorClampToEdge", 25},
    {"samplerYcbcrConversion", 23},
    {"samplerYcbcrConversionComponents", 33},
    {"samples", 8},
    {"saturatingAccumulation", 23},
    {"scalarBlockLayout", 18},
    {"scalingBehavior", 16},
    {"schedulingControls", 19},
    {"schedulingControlsFlags", 24},
    {"scissorCount", 13},
    {"scope", 6},
    {"scratch", 8},
    {"scratchData", 12},
    {"scratchMemUsageInBytes", 23},
    {"scratchOffset", 14},
    {"screenBufferImport", 19},
    {"screenUsage", 12},
    {"selectableCubicWeights", 23},
    {"semaphore", 10},
    {"semaphoreCount", 15},
    {"semaphoreType", 14},
    {"separateDepthStencilLayouts", 28},
    {"separateStencilMaskRef", 23},
    {"sequencesCount", 15},
    {"sequencesCountBuffer", 21},
    {"sequencesCountOffset", 21},
    {"sequencesIndexBuffer", 21},
    {"sequencesIndexOffset", 21},
    {"session", 8},
    {"set", 4},
    {"setCount", 9},
    {"setLayoutCount", 15},
    {"settingCount", 13},
    {"sgprAllocationGranularity", 26},
    {"sgprsPerSimd", 13},
    {"shader", 7},
    {"shaderArraysPerEngineCount", 27},
    {"shaderBinaryUUID", 17},
    {"shaderBinaryVersion", 20},
    {"shaderBufferFloat16AtomicAdd", 29},
    {"shaderBufferFloat16AtomicMinMax", 32},
    {"shaderBufferFloat16Atomics", 27},
    {"shaderBufferFloat32AtomicAdd", 29},
    {"shaderBufferFloat32AtomicMinMax", 32},
    {"shaderBufferFloat32Atomics", 27},
    {"shaderBufferFloat64AtomicAdd", 29},
    {"shaderBufferFloat64AtomicMinMax", 32},
    {"shaderBufferFloat64Atomics", 27},
    {"shaderBufferInt64Atomics", 25},
    {"shaderClipDistance", 19},
    {"shaderCoreBuiltins", 19},
    {"shaderCoreCount", 16},
    {"shaderCoreFeatures", 19},
    {"shaderCoreMask", 15},
    {"shaderCullDistance", 19},
    {"shaderDemoteToHelperInvocation", 31},
    {"shaderDenormFlushToZeroFloat16", 31},
    {"shaderDenormFlushToZeroFloat32", 31},
    {"shaderDenormFlushToZeroFloat64", 31},
    {"shaderDenormPreserveFloat16", 28},
    {"shaderDenormPreserveFloat32", 28},
    {"shaderDenormPreserveFloat64", 28},
    {"shaderDeviceClock", 18},
    {"shaderDrawParameters", 21},
    {"shaderEarlyAndLateFragmentTests", 32},
    {"shaderEngineCount", 18},
    {"shaderEnqueue", 14},
    {"shaderFloat16", 14},
    {"shaderFloat64", 14},
    {"shaderGroupBaseAlignment", 25},
    {"shaderGroupHandleAlignment", 27},
    {"shaderGroupHandleCaptureReplaySize", 35},
    {"shaderGroupHandleSize", 22},
    {"shaderImageFloat32AtomicAdd", 28},
    {"shaderImageFloat32AtomicMinMax", 31},
    {"shaderImageFloat32Atomics", 26},
    {"shaderImageGatherExtended", 26},
    {"shaderImageInt64Atomics", 24},
    {"shaderInputAttachmentArrayDynamicIndexing", 42},
    {"shaderInputAttachmentArrayNonUniformIndexing", 45},
    {"shaderInputAttachmentArrayNonUniformIndexingNative", 51},
    {"shaderInt16", 12},
    {"shaderInt64", 12},
    {"shaderInt8", 11},
    {"shaderIntegerDotProduct", 24},
    {"shaderIntegerFunctions2", 24},
    {"shaderModule", 13},
    {"shaderModuleIdentifier", 23},
    {"shaderModuleIdentifierAlgorithmUUID", 36},
    {"shaderObject", 13},
    {"shaderOutputLayer", 18},
    {"shaderOutputViewportIndex", 26},
    {"shaderResourceMinLod", 21},
    {"shaderResourceResidency", 24},
    {"shaderRoundingModeRTEFloat16", 29},
    {"shaderRoundingModeRTEFloat32", 29},
    {"shaderRoundingModeRTEFloat64", 29},
    {"shaderRoundingModeRTZFloat16", 29},
    {"shaderRoundingModeRTZFloat32", 29},
    {"shaderRoundingModeRTZFloat64", 29},
    {"shaderSMBuiltins", 17},
    {"shaderSMCount", 14},
    {"shaderSampleRateInterpolationFunctions", 39},
    {"shaderSampledImageArrayDynamicIndexing", 39},
    {"shaderSampledImageArrayNonUniformIndexing", 42},
    {"shaderSampledImageArrayNonUniformIndexingNative", 48},
    {"shaderSharedFloat16AtomicAdd", 29},
    {"shaderSharedFloat16AtomicMinMax", 32},
    {"shaderSharedFloat16Atomics", 27},
    {"shaderSharedFloat32AtomicAdd", 29},
    {"shaderSharedFloat32AtomicMinMax", 32},
    {"shaderSharedFloat32Atomics", 27},
    {"shaderSharedFloat64AtomicAdd", 29},
    {"shaderSharedFloat64AtomicMinMax", 32},
    {"shaderSharedFloat64Atomics", 27},
    {"shaderSharedInt64Atomics", 25},
    {"shaderSignedZeroInfNanPreserveFloat16", 38},
    {"shaderSignedZeroInfNanPreserveFloat32", 38},
    {"shaderSignedZeroInfNanPreserveFloat64", 38},
    {"shaderStage", 12},
    {"shaderStageMask", 16},
    {"shaderStorageBufferArrayDynamicIndexing", 40},
    {"shaderStorageBufferArrayNonUniformIndexing", 43},
    {"shaderStorageBufferArrayNonUniformIndexingNative", 49},
    {"shaderStorageImageArrayDynamicIndexing", 39},
    {"shaderStorageImageArrayNonUniformIndexing", 42},
    {"shaderStorageImageArrayNonUniformIndexingNative", 48},
    {"shaderStorageImageExtendedFormats", 34},
    {"shaderStorageImageMultisample", 30},
    {"shaderStorageImageReadWithoutFormat", 36},
    {"shaderStorageImageWriteWithoutFormat", 37},
    {"shaderStorageTexelBufferArrayDynamicIndexing", 45},
    {"shaderStorageTexelBufferArrayNonUniformIndexing", 48},
    {"shaderSubgroupClock", 20},
    {"shaderSubgroupExtendedTypes", 28},
    {"shaderSubgroupUniformControlFlow", 33},
    {"shaderTerminateInvocation", 26},
    {"shaderTessellationAndGeometryPointSize", 39},
    {"shaderTileImageCoherentReadAccelerated", 39},
    {"shaderTileImageColorReadAccess", 31},
    {"shaderTileImageDepthReadAccess", 31},
    {"shaderTileImageReadFromHelperInvocation", 40},
    {"shaderTileImageReadSampleFromPixelRateInvocation", 49},
    {"shaderTileImageStencilReadAccess", 33},
    {"shaderUniformBufferArrayDynamicIndexing", 40},
    {"shaderUniformBufferArrayNonUniformIndexing", 43},
    {"shaderUniformBufferArrayNonUniformIndexingNative", 49},
    {"shaderUniformTexelBufferArrayDynamicIndexing", 45},
    {"shaderUniformTexelBufferArrayNonUniformIndexing", 48},
    {"shaderWarpsPerCore", 19},
    {"shaderWarpsPerSM", 17},
    {"shaderZeroInitializeWorkgroupMemory", 36},
    {"shadingRate", 12},
    {"shadingRateAttachmentTexelSize", 31},
    {"shadingRateCoarseSampleOrder", 29},
    {"shadingRateImage", 17},
    {"shadingRateImageEnable", 23},
    {"shadingRateMaxCoarseSamples", 28},
    {"shadingRatePaletteEntryCount", 29},
    {"shadingRatePaletteSize", 23},
    {"shadingRateTexelSize", 21},
    {"shadingRateType", 16},
    {"sharedMemBytes", 15},
    {"sharedPresentSupportedUsageFlags", 33},
    {"sharingMode", 12},
    {"signalSemaphore", 16},
    {"signalSemaphoreCount", 21},
    {"signalSemaphoreInfoCount", 25},
    {"signalSemaphoreValueCount", 26},
    {"signalSemaphoreValuesCount", 27},
    {"simEndTimeUs", 13},
    {"simStartTimeUs", 15},
    {"simdPerComputeUnit", 19},
    {"size", 5},
    {"sliceCount", 11},
    {"sliceOffset", 12},
    {"sliceSegmentCount", 18},
    {"slotIndex", 10},
    {"smoothLines", 12},
    {"sparseAddressSpaceSize", 23},
    {"sparseBinding", 14},
    {"sparseImageFloat32AtomicAdd", 28},
    {"sparseImageFloat32AtomicMinMax", 31},
    {"sparseImageFloat32Atomics", 26},
    {"sparseImageInt64Atomics", 24},
    {"sparseProperties", 17},
    {"sparseResidency16Samples", 25},
    {"sparseResidency2Samples", 24},
    {"sparseResidency4Samples", 24},
    {"sparseResidency8Samples", 24},
    {"sparseResidencyAliased", 23},
    {"sparseResidencyBuffer", 22},
    {"sparseResidencyImage2D", 23},
    {"sparseResidencyImage3D", 23},
    {"specVersion", 12},
    {"splitInstanceBindRegionCount", 29},
    {"src", 4},
    {"srcAccelerationStructure", 25},
    {"srcAccessMask", 14},
    {"srcAddress", 11},
    {"srcAlphaBlendFactor", 20},
    {"srcArrayElement", 16},
    {"srcBinding", 11},
    {"srcBuffer", 10},
    {"srcBufferOffset", 16},
    {"srcBufferRange", 15},
    {"srcCacheCount", 14},
    {"srcColorBlendFactor", 20},
    {"srcImage", 9},
    {"srcImageLayout", 15},
    {"srcOffset", 10},
    {"srcOffsets", 11},
    {"srcPictureResource", 19},
    {"srcPremultiplied", 17},
    {"srcQueueFamilyIndex", 20},
    {"srcRect", 8},
    {"srcSet", 7},
    {"srcStageMask", 13},
    {"srcSubpass", 11},
    {"srcSubresource", 15},
    {"srgb", 5},
    {"srtMotionInstance", 18},
    {"stage", 6},
    {"stageCount", 11},
    {"stageFlags", 11},
    {"stageMask", 10},
    {"stages", 7},
    {"standardSampleLocations", 24},
    {"staticInstance", 15},
    {"stdHeaderVersion", 17},
    {"stdPPSCount", 12},
    {"stdPPSId", 9},
    {"stdProfileIdc", 14},
    {"stdSPSCount", 12},
    {"stdSPSId", 9},
    {"stdSyntaxFlags", 15},
    {"stdVPSCount", 12},
    {"stdVPSId", 9},
    {"stencil", 8},
    {"stencilAttachmentFormat", 24},
    {"stencilFinalLayout", 19},
    {"stencilInitialLayout", 21},
    {"stencilLayout", 14},
    {"stencilLoadOp", 14},
    {"stencilResolveMode", 19},
    {"stencilStoreOp", 15},
    {"stencilTestEnable", 18},
    {"stencilUsage", 13},
    {"stippledBresenhamLines", 23},
    {"stippledLineEnable", 19},
    {"stippledRectangularLines", 25},
    {"stippledSmoothLines", 20},
    {"storage", 8},
    {"storageBuffer16BitAccess", 25},
    {"storageBuffer8BitAccess", 24},
    {"storageBufferDescriptorSize", 28},
    {"storageBuffers", 15},
    {"storageImageDescriptorSize", 27},
    {"storageImageSampleCounts", 25},
    {"storageInputOutput16", 21},
    {"storagePushConstant16", 22},
    {"storagePushConstant8", 21},
    {"storageTexelBufferDescriptorSize", 33},
    {"storageTexelBufferOffsetAlignmentBytes", 39},
    {"storageTexelBufferOffsetSingleTexelAlignment", 45},
    {"storeOp", 8},
    {"stream", 7},
    {"streamCount", 12},
    {"streamDescriptor", 17},
    {"strictLines", 12},
    {"stride", 7},
    {"stripeArea", 11},
    {"stripeInfoCount", 16},
    {"stripeSemaphoreInfoCount", 25},
    {"subLayerCount", 14},
    {"subPixelInterpolationOffsetBits", 32},
    {"subPixelPrecisionBits", 22},
    {"subTexelPrecisionBits", 22},
    {"subdivisionLevel", 17},
    {"subgroupBroadcastDynamicId", 27},
    {"subgroupQuadOperationsInAllStages", 34},
    {"subgroupSize", 13},
    {"subgroupSizeControl", 20},
    {"subgroupSupportedOperations", 28},
    {"subgroupSupportedStages", 24},
    {"subminor", 9},
    {"submitCount", 12},
    {"subpass", 8},
    {"subpassCount", 13},
    {"subpassIndex", 13},
    {"subpassMergeFeedback", 21},
    {"subpassMergeStatus", 19},
    {"subpassShading", 15},
    {"subresource", 12},
    {"subresourceLayout", 18},
    {"subresourceRange", 17},
    {"subsampledCoarseReconstructionEarlyAccess", 42},
    {"subsampledLoads", 16},
    {"subsetAllocation", 17},
    {"suggestedXChromaOffset", 23},
    {"suggestedYChromaOffset", 23},
    {"suggestedYcbcrModel", 20},
    {"suggestedYcbcrRange", 20},
    {"supersampleFragmentShadingRates", 32},
    {"supported", 10},
    {"supportedAlpha", 15},
    {"supportedCompositeAlpha", 24},
    {"supportedDepthResolveModes", 27},
    {"supportedEncodeFeedbackFlags", 29},
    {"supportedHintGridSizes", 23},
    {"supportedOperations", 20},
    {"supportedOutputGridSizes", 25},
    {"supportedPresentGravityX", 25},
    {"supportedPresentGravityY", 25},
    {"supportedPresentScaling", 24},
    {"supportedQueues", 16},
    {"supportedStages", 16},
    {"supportedStencilResolveModes", 29},
    {"supportedSurfaceCounters", 25},
    {"supportedTransforms", 20},
    {"supportedUsageFlags", 20},
    {"supportsNonZeroFirstInstance", 29},
    {"supportsProtected", 18},
    {"supportsTextureGatherLODBiasAMD", 32},
    {"surface", 8},
    {"surfaceCapabilities", 20},
    {"surfaceCounters", 16},
    {"surfaceFormat", 14},
    {"swapBufferTimestamp", 20},
    {"swapChain", 10},
    {"swapchain", 10},
    {"swapchainCount", 15},
    {"swapchainMaintenance1", 22},
    {"sx", 3},
    {"sy", 3},
    {"synchronization2", 17},
    {"sysmemColorSpaceIndex", 22},
    {"sysmemPixelFormat", 18},
    {"sz", 3},
    {"tagName", 8},
    {"tagSize", 8},
    {"taskCount", 10},
    {"taskShader", 11},
    {"templateType", 13},
    {"temporalLayerCount", 19},
    {"tessellationIsolines", 21},
    {"tessellationPointMode", 22},
    {"tessellationShader", 19},
    {"texelBufferAlignment", 21},
    {"texelRate", 10},
    {"textureBlockMatch", 18},
    {"textureBlockMatch2", 19},
    {"textureBoxFilter", 17},
    {"textureCompressionASTC_HDR", 27},
    {"textureCompressionASTC_LDR", 27},
    {"textureCompressionBC", 21},
    {"textureCompressionETC2", 23},
    {"textureSampleWeighted", 22},
    {"tileProperties", 15},
    {"tileSize", 9},
    {"tiling", 7},
    {"timeDomain", 11},
    {"timelineSemaphore", 18},
    {"timeout", 8},
    {"timestampComputeAndGraphics", 28},
    {"timestampCount", 15},
    {"timestampPeriod", 16},
    {"timestampValidBits", 19},
    {"timingCount", 12},
    {"tokenCount", 11},
    {"tokenType", 10},
    {"topology", 9},
    {"transform", 10},
    {"transformBlockSizes", 20},
    {"transformData", 14},
    {"transformFeedback", 18},
    {"transformFeedbackDraw", 22},
    {"transformFeedbackPreservesProvokingVertex", 42},
    {"transformFeedbackPreservesTriangleFanProvokingVertex", 53},
    {"transformFeedbackQueries", 25},
    {"transformFeedbackRasterizationStreamSelect", 43},
    {"transformFeedbackStreamsLinesTriangles", 39},
    {"transformOffset", 16},
    {"transformT0", 12},
    {"transformT1", 12},
    {"transitionCount", 16},
    {"triStripVertexOrderIndependentOfProvokingVertex", 48},
    {"triangleArray", 14},
    {"triangleArrayStride", 20},
    {"triangleFans", 13},
    {"triangles", 10},
    {"tuningMode", 11},
    {"tx", 3},
    {"ty", 3},
    {"type", 5},
    {"tz", 3},
    {"u64", 4},
    {"uint32", 7},
    {"uint64", 7},
    {"underlyingAPI", 14},
    {"uniformAndStorageBuffer16BitAccess", 35},
    {"uniformAndStorageBuffer8BitAccess", 34},
    {"uniformBufferDescriptorSize", 28},
    {"uniformBufferStandardLayout", 28},
    {"uniformBuffers", 15},
    {"uniformTexelBufferDescriptorSize", 33},
    {"uniformTexelBufferOffsetAlignmentBytes", 39},
    {"uniformTexelBufferOffsetSingleTexelAlignment", 45},
    {"unit", 5},
    {"unnormalizedCoordinates", 24},
    {"update", 7},
    {"updateScratchSize", 18},
    {"updateSequenceCount", 20},
    {"usage", 6},
    {"usageCountsCount", 17},
    {"useGopRemainingFrames", 22},
    {"useMaxFrameSize", 16},
    {"useMaxLevelIdc", 15},
    {"useMaxQp", 9},
    {"useMinQp", 9},
    {"uuid", 5},
    {"validationCache", 16},
    {"value", 6},
    {"value32", 8},
    {"value64", 8},
    {"valueBool", 10},
    {"valueCount", 11},
    {"valueFloat", 11},
    {"valueString", 12},
    {"variableMultisampleRate", 24},
    {"variablePointers", 17},
    {"variablePointersStorageBuffer", 30},
    {"variableSampleLocations", 24},
    {"vendorBinarySize", 17},
    {"vendorFaultCode", 16},
    {"vendorFaultData", 16},
    {"vendorID", 9},
    {"vendorInfoCount", 16},
    {"version", 8},
    {"vertexAttributeAccessBeyondStride", 34},
    {"vertexAttributeDescriptionCount", 32},
    {"vertexAttributeInstanceRateDivisor", 35},
    {"vertexAttributeInstanceRateZeroDivisor", 39},
    {"vertexBindingDescriptionCount", 30},
    {"vertexBindingDivisorCount", 26},
    {"vertexBindingUnit", 18},
    {"vertexCount", 12},
    {"vertexData", 11},
    {"vertexDynamicStride", 20},
    {"vertexFormat", 13},
    {"vertexInputDynamicState", 24},
    {"vertexInputs", 13},
    {"vertexOffset", 13},
    {"vertexPipelineStoresAndAtomics", 31},
    {"vertexStride", 13},
    {"vgprAllocationGranularity", 26},
    {"vgprsPerSimd", 13},
    {"videoCodecOperation", 20},
    {"videoCodecOperations", 21},
    {"videoContentHints", 18},
    {"videoMaintenance1", 18},
    {"videoSession", 13},
    {"videoSessionParameters", 23},
    {"videoSessionParametersTemplate", 31},
    {"videoUsageHints", 16},
    {"view", 5},
    {"viewFormatCount", 16},
    {"viewMask", 9},
    {"viewOffset", 11},
    {"viewType", 9},
    {"viewportBoundsRange", 20},
    {"viewportCount", 14},
    {"viewportDepthCount", 19},
    {"viewportScissor2D", 18},
    {"viewportSubPixelBits", 21},
    {"viewportWScalingEnable", 23},
    {"virtualBufferSizeInMs", 22},
    {"visibleRegion", 14},
    {"visualID", 9},
    {"visual_id", 10},
    {"vulkanMemoryModel", 18},
    {"vulkanMemoryModelAvailabilityVisibilityChains", 46},
    {"vulkanMemoryModelDeviceScope", 29},
    {"w", 2},
    {"waitAll", 8},
    {"waitSemaphoreCount", 19},
    {"waitSemaphoreInfoCount", 23},
    {"waitSemaphoreValueCount", 24},
    {"waitSemaphoreValuesCount", 25},
    {"wavefrontSize", 14},
    {"wavefrontsPerSimd", 18},
    {"whitePoint", 11},
    {"wideLines", 10},
    {"width", 6},
    {"window", 7},
    {"windowCompareMode", 18},
    {"windowExtent", 13},
    {"workgroupMemoryExplicitLayout", 30},
    {"workgroupMemoryExplicitLayout16BitAccess", 41},
    {"workgroupMemoryExplicitLayout8BitAccess", 40},
    {"workgroupMemoryExplicitLayoutScalarBlockLayout", 47},
    {"writeMask", 10},
    {"writeStdPPS", 12},
    {"writeStdSPS", 12},
    {"writeStdVPS", 12},
    {"x", 2},
    {"xChromaOffset", 14},
    {"xcoeff", 7},
    {"y", 2},
    {"yChromaOffset", 14},
    {"ycbcr2plane444Formats", 22},
    {"ycbcrConversion", 16},
    {"ycbcrDegamma", 13},
    {"ycbcrImageArrays", 17},
    {"ycbcrModel", 11},
    {"ycbcrRange", 11},
    {"ycoeff", 7},
    {"z", 2},
    {"zirconHandle", 13},
    };
    return table[(int)field].data();
}

bool IsFieldPointer(Field field) {
    switch (field) {
    case Field::connection:
    case Field::context:
    case Field::dfb:
    case Field::displayName:
    case Field::dpy:
    case Field::hostAddress:
    case Field::opaqueCaptureDescriptorData:
    case Field::pAccelerationStructure:
    case Field::pAccelerationStructures:
    case Field::pAcquireInfo:
    case Field::pAcquireKeys:
    case Field::pAcquireSyncs:
    case Field::pAcquireTimeoutMilliseconds:
    case Field::pAcquireTimeouts:
    case Field::pAddress:
    case Field::pAddressInfos:
    case Field::pAllocateInfo:
    case Field::pAllocator:
    case Field::pApiVersion:
    case Field::pApplicationInfo:
    case Field::pApplicationName:
    case Field::pAspectReferences:
    case Field::pAttachmentImageInfos:
    case Field::pAttachmentInitialSampleLocations:
    case Field::pAttachments:
    case Field::pAttributes:
    case Field::pBeginInfo:
    case Field::pBindDescriptorBufferEmbeddedSamplersInfo:
    case Field::pBindDescriptorSetsInfo:
    case Field::pBindInfo:
    case Field::pBindInfos:
    case Field::pBindSessionMemoryInfos:
    case Field::pBindingFlags:
    case Field::pBindingInfos:
    case Field::pBindingReference:
    case Field::pBindings:
    case Field::pBinds:
    case Field::pBlitImageInfo:
    case Field::pBuffer:
    case Field::pBufferBinds:
    case Field::pBufferConstraintsInfo:
    case Field::pBufferIndices:
    case Field::pBufferInfo:
    case Field::pBufferMemoryBarriers:
    case Field::pBuffers:
    case Field::pBuildInfo:
    case Field::pCacheData:
    case Field::pCacheSize:
    case Field::pCallableShaderBindingTable:
    case Field::pCallback:
    case Field::pCallbackData:
    case Field::pCapabilities:
    case Field::pCheckpointData:
    case Field::pCheckpointDataCount:
    case Field::pCheckpointMarker:
    case Field::pClearValues:
    case Field::pCmdBufLabels:
    case Field::pCode:
    case Field::pCodingControlInfo:
    case Field::pCollection:
    case Field::pColor:
    case Field::pColorAttachmentFormats:
    case Field::pColorAttachmentSamples:
    case Field::pColorAttachments:
    case Field::pColorBlendAdvanced:
    case Field::pColorBlendEnables:
    case Field::pColorBlendEquations:
    case Field::pColorBlendState:
    case Field::pColorSpaces:
    case Field::pColorWriteEnables:
    case Field::pColorWriteMasks:
    case Field::pCombinationCount:
    case Field::pCombinations:
    case Field::pCombinedImageSampler:
    case Field::pCommandBufferDeviceMasks:
    case Field::pCommandBufferInfos:
    case Field::pCommandBuffers:
    case Field::pCommandPool:
    case Field::pCommittedMemoryInBytes:
    case Field::pCompatibility:
    case Field::pConditionalRenderingBegin:
    case Field::pConfiguration:
    case Field::pCopyBufferInfo:
    case Field::pCopyBufferToImageInfo:
    case Field::pCopyDstLayouts:
    case Field::pCopyImageInfo:
    case Field::pCopyImageToBufferInfo:
    case Field::pCopyImageToImageInfo:
    case Field::pCopyImageToMemoryInfo:
    case Field::pCopyMemoryToImageInfo:
    case Field::pCopySrcLayouts:
    case Field::pCorrelatedViewMasks:
    case Field::pCorrelationMasks:
    case Field::pCountInfo:
    case Field::pCounterBufferOffsets:
    case Field::pCounterBuffers:
    case Field::pCounterCount:
    case Field::pCounterDescriptions:
    case Field::pCounterIndices:
    case Field::pCounterValue:
    case Field::pCounters:
    case Field::pCoverageModulationTable:
    case Field::pCreateInfo:
    case Field::pCreateInfos:
    case Field::pCustomSampleOrders:
    case Field::pData:
    case Field::pDataSize:
    case Field::pDecodeInfo:
    case Field::pDecompressMemoryRegions:
    case Field::pDeferredOperation:
    case Field::pDependencies:
    case Field::pDependencyInfo:
    case Field::pDependencyInfos:
    case Field::pDepthAttachment:
    case Field::pDepthBiasInfo:
    case Field::pDepthStencil:
    case Field::pDepthStencilAttachment:
    case Field::pDepthStencilResolveAttachment:
    case Field::pDepthStencilState:
    case Field::pDescriptor:
    case Field::pDescriptorCopies:
    case Field::pDescriptorCounts:
    case Field::pDescriptorInfo:
    case Field::pDescriptorPool:
    case Field::pDescriptorSets:
    case Field::pDescriptorTypes:
    case Field::pDescriptorUpdateEntries:
    case Field::pDescriptorUpdateTemplate:
    case Field::pDescriptorWrites:
    case Field::pDevice:
    case Field::pDeviceEventInfo:
    case Field::pDeviceGroupPresentCapabilities:
    case Field::pDeviceIndices:
    case Field::pDeviceMasks:
    case Field::pDeviceRenderAreas:
    case Field::pDisabledValidationChecks:
    case Field::pDisabledValidationFeatures:
    case Field::pDiscardRectangles:
    case Field::pDisplay:
    case Field::pDisplayCount:
    case Field::pDisplayEventInfo:
    case Field::pDisplayPlaneInfo:
    case Field::pDisplayPowerInfo:
    case Field::pDisplayTimingProperties:
    case Field::pDisplays:
    case Field::pDrivers:
    case Field::pDrmFormatModifierProperties:
    case Field::pDrmFormatModifiers:
    case Field::pDynamicOffsets:
    case Field::pDynamicState:
    case Field::pDynamicStates:
    case Field::pEnabledFeatures:
    case Field::pEnabledValidationFeatures:
    case Field::pEncodeInfo:
    case Field::pEndCodingInfo:
    case Field::pEngineName:
    case Field::pEvent:
    case Field::pEvents:
    case Field::pExclusiveScissorEnables:
    case Field::pExclusiveScissors:
    case Field::pExecutableCount:
    case Field::pExecutableInfo:
    case Field::pExecuteInfo:
    case Field::pExternalBufferInfo:
    case Field::pExternalBufferProperties:
    case Field::pExternalFenceInfo:
    case Field::pExternalFenceProperties:
    case Field::pExternalImageFormatProperties:
    case Field::pExternalSemaphoreInfo:
    case Field::pExternalSemaphoreProperties:
    case Field::pExtras:
    case Field::pFaultCounts:
    case Field::pFaultInfo:
    case Field::pFd:
    case Field::pFeatures:
    case Field::pFeedbackInfo:
    case Field::pFence:
    case Field::pFences:
    case Field::pFixedRateFlags:
    case Field::pFormatConstraints:
    case Field::pFormatCount:
    case Field::pFormatInfo:
    case Field::pFormatProperties:
    case Field::pFragmentDensityOffsets:
    case Field::pFragmentShadingRateAttachment:
    case Field::pFragmentShadingRateCount:
    case Field::pFragmentShadingRates:
    case Field::pFragmentSize:
    case Field::pFramebuffer:
    case Field::pFunction:
    case Field::pGeneratedCommandsInfo:
    case Field::pGeometries:
    case Field::pGetFdInfo:
    case Field::pGetWin32HandleInfo:
    case Field::pGetZirconHandleInfo:
    case Field::pGranularity:
    case Field::pGroups:
    case Field::pHandle:
    case Field::pHitShaderBindingTable:
    case Field::pHostMapping:
    case Field::pHostPointer:
    case Field::pIdentifier:
    case Field::pImage:
    case Field::pImageBinds:
    case Field::pImageConstraintsInfo:
    case Field::pImageFormatInfo:
    case Field::pImageFormatProperties:
    case Field::pImageIndex:
    case Field::pImageIndices:
    case Field::pImageInfo:
    case Field::pImageMemoryBarriers:
    case Field::pImageOpaqueBinds:
    case Field::pImageSubresources:
    case Field::pImages:
    case Field::pImmutableSamplers:
    case Field::pImportFenceFdInfo:
    case Field::pImportFenceWin32HandleInfo:
    case Field::pImportSemaphoreFdInfo:
    case Field::pImportSemaphoreWin32HandleInfo:
    case Field::pImportSemaphoreZirconHandleInfo:
    case Field::pIndexInfo:
    case Field::pIndexTypeValues:
    case Field::pIndexTypes:
    case Field::pIndirectCommandsLayout:
    case Field::pIndirectDeviceAddresses:
    case Field::pIndirectStrides:
    case Field::pInfo:
    case Field::pInfoSize:
    case Field::pInfos:
    case Field::pInheritanceInfo:
    case Field::pInitialData:
    case Field::pInitializeInfo:
    case Field::pInputAssemblyState:
    case Field::pInputAttachmentImage:
    case Field::pInputAttachments:
    case Field::pInstance:
    case Field::pInternalRepresentationCount:
    case Field::pInternalRepresentations:
    case Field::pLabelInfo:
    case Field::pLabelName:
    case Field::pLatencyMarkerInfo:
    case Field::pLaunchInfo:
    case Field::pLayer:
    case Field::pLayerName:
    case Field::pLayerPrefix:
    case Field::pLayers:
    case Field::pLayout:
    case Field::pLayoutSizeInBytes:
    case Field::pLibraries:
    case Field::pLibraryInfo:
    case Field::pLibraryInterface:
    case Field::pMapEntries:
    case Field::pMarkerInfo:
    case Field::pMarkerName:
    case Field::pMaxDeviation:
    case Field::pMaxPrimitiveCounts:
    case Field::pMaxWorkgroupSize:
    case Field::pMemory:
    case Field::pMemoryBarriers:
    case Field::pMemoryFdProperties:
    case Field::pMemoryGetRemoteAddressInfo:
    case Field::pMemoryHostPointerProperties:
    case Field::pMemoryMapInfo:
    case Field::pMemoryProperties:
    case Field::pMemoryRanges:
    case Field::pMemoryRequirements:
    case Field::pMemoryRequirementsCount:
    case Field::pMemoryUnmapInfo:
    case Field::pMemoryWin32HandleProperties:
    case Field::pMemoryZirconHandleProperties:
    case Field::pMessage:
    case Field::pMessageIdName:
    case Field::pMessenger:
    case Field::pMetadata:
    case Field::pMetalObjectsInfo:
    case Field::pMicromap:
    case Field::pMicromaps:
    case Field::pMissShaderBindingTable:
    case Field::pMode:
    case Field::pModes:
    case Field::pModule:
    case Field::pMultisampleProperties:
    case Field::pMultisampleState:
    case Field::pMutableDescriptorTypeLists:
    case Field::pNaluSliceEntries:
    case Field::pNaluSliceSegmentEntries:
    case Field::pName:
    case Field::pNameInfo:
    case Field::pNext:
    case Field::pNodeIndex:
    case Field::pNodeInfo:
    case Field::pNumPasses:
    case Field::pObjectName:
    case Field::pObjects:
    case Field::pOffset:
    case Field::pOffsets:
    case Field::pOpticalFlowImageFormatInfo:
    case Field::pOverrideInfo:
    case Field::pParametersAddInfo:
    case Field::pParams:
    case Field::pPeerMemoryFeatures:
    case Field::pPerViewRenderAreas:
    case Field::pPerformanceQueryCreateInfo:
    case Field::pPhysicalDeviceCount:
    case Field::pPhysicalDeviceGroupCount:
    case Field::pPhysicalDeviceGroupProperties:
    case Field::pPhysicalDevices:
    case Field::pPictureResource:
    case Field::pPipelineCache:
    case Field::pPipelineCreationFeedback:
    case Field::pPipelineInfo:
    case Field::pPipelineLayout:
    case Field::pPipelineProperties:
    case Field::pPipelineStageCreationFeedbacks:
    case Field::pPipelines:
    case Field::pPlaneLayouts:
    case Field::pPoolSizes:
    case Field::pPostSubpassSampleLocations:
    case Field::pPresentIds:
    case Field::pPresentInfo:
    case Field::pPresentModeCount:
    case Field::pPresentModes:
    case Field::pPresentationTimingCount:
    case Field::pPresentationTimings:
    case Field::pPreserveAttachments:
    case Field::pPrivateData:
    case Field::pPrivateDataSlot:
    case Field::pProfiles:
    case Field::pProperties:
    case Field::pPropertiesCount:
    case Field::pPropertyCount:
    case Field::pPushConstantRanges:
    case Field::pPushConstantsInfo:
    case Field::pPushDescriptorSetInfo:
    case Field::pPushDescriptorSetWithTemplateInfo:
    case Field::pQualityLevelInfo:
    case Field::pQualityLevelProperties:
    case Field::pQueriedLowLatencyData:
    case Field::pQueryPool:
    case Field::pQueue:
    case Field::pQueueCreateInfos:
    case Field::pQueueFamilyIndices:
    case Field::pQueueFamilyProperties:
    case Field::pQueueFamilyPropertyCount:
    case Field::pQueueInfo:
    case Field::pQueueLabels:
    case Field::pQueuePriorities:
    case Field::pQueueTypeInfo:
    case Field::pRanges:
    case Field::pRasterizationState:
    case Field::pRaygenShaderBindingTable:
    case Field::pRectCount:
    case Field::pRectangles:
    case Field::pRects:
    case Field::pReferenceSlots:
    case Field::pRegions:
    case Field::pReleaseInfo:
    case Field::pReleaseKeys:
    case Field::pReleaseSyncs:
    case Field::pRenderPass:
    case Field::pRenderPassBegin:
    case Field::pRenderPassFeedback:
    case Field::pRenderingAreaInfo:
    case Field::pRenderingInfo:
    case Field::pResolveAttachments:
    case Field::pResolveImageInfo:
    case Field::pResult:
    case Field::pResults:
    case Field::pSampleLocations:
    case Field::pSampleLocationsInfo:
    case Field::pSampleMask:
    case Field::pSampledImage:
    case Field::pSampler:
    case Field::pScissors:
    case Field::pSemaphore:
    case Field::pSemaphores:
    case Field::pSession:
    case Field::pSetDescriptorBufferOffsetsInfo:
    case Field::pSetLayout:
    case Field::pSetLayouts:
    case Field::pSettingName:
    case Field::pSettings:
    case Field::pSetupReferenceSlot:
    case Field::pShaderGroupCaptureReplayHandle:
    case Field::pShaderModule:
    case Field::pShaders:
    case Field::pShadingRatePaletteEntries:
    case Field::pShadingRatePalettes:
    case Field::pSignalInfo:
    case Field::pSignalSemaphoreDeviceIndices:
    case Field::pSignalSemaphoreInfos:
    case Field::pSignalSemaphoreValues:
    case Field::pSignalSemaphores:
    case Field::pSizeInfo:
    case Field::pSizes:
    case Field::pSleepInfo:
    case Field::pSleepModeInfo:
    case Field::pSliceOffsets:
    case Field::pSliceSegmentOffsets:
    case Field::pSparseMemoryRequirementCount:
    case Field::pSparseMemoryRequirements:
    case Field::pSpecializationInfo:
    case Field::pSplitInstanceBindRegions:
    case Field::pSrcCaches:
    case Field::pStages:
    case Field::pStatisticCount:
    case Field::pStatistics:
    case Field::pStdHeaderVersion:
    case Field::pStdPPSs:
    case Field::pStdPictureInfo:
    case Field::pStdReferenceInfo:
    case Field::pStdSPSs:
    case Field::pStdSliceHeader:
    case Field::pStdSliceSegmentHeader:
    case Field::pStdVPSs:
    case Field::pStencilAttachment:
    case Field::pStorageBuffer:
    case Field::pStorageImage:
    case Field::pStorageTexelBuffer:
    case Field::pStreamStrides:
    case Field::pStreams:
    case Field::pStrides:
    case Field::pStripeInfos:
    case Field::pStripeSemaphoreInfos:
    case Field::pSubmits:
    case Field::pSubpassBeginInfo:
    case Field::pSubpassEndInfo:
    case Field::pSubpassFeedback:
    case Field::pSubpasses:
    case Field::pSubresource:
    case Field::pSupport:
    case Field::pSupported:
    case Field::pSurface:
    case Field::pSurfaceCapabilities:
    case Field::pSurfaceFormatCount:
    case Field::pSurfaceFormats:
    case Field::pSurfaceInfo:
    case Field::pSwapchain:
    case Field::pSwapchainImageCount:
    case Field::pSwapchainImages:
    case Field::pSwapchains:
    case Field::pTag:
    case Field::pTagInfo:
    case Field::pTessellationState:
    case Field::pTexelBufferView:
    case Field::pTimeDomainCount:
    case Field::pTimeDomains:
    case Field::pTimes:
    case Field::pTimestampInfos:
    case Field::pTimestamps:
    case Field::pTimings:
    case Field::pTokens:
    case Field::pToolCount:
    case Field::pToolProperties:
    case Field::pTransitions:
    case Field::pUniformBuffer:
    case Field::pUniformTexelBuffer:
    case Field::pUpdateInfo:
    case Field::pUsageCounts:
    case Field::pUserData:
    case Field::pValidationCache:
    case Field::pValue:
    case Field::pValues:
    case Field::pVendorBinaryData:
    case Field::pVendorInfos:
    case Field::pVersionData:
    case Field::pVersionInfo:
    case Field::pVertexAttributeDescriptions:
    case Field::pVertexBindingDescriptions:
    case Field::pVertexBindingDivisors:
    case Field::pVertexInfo:
    case Field::pVertexInputState:
    case Field::pVertexOffset:
    case Field::pVideoFormatInfo:
    case Field::pVideoFormatProperties:
    case Field::pVideoFormatPropertyCount:
    case Field::pVideoProfile:
    case Field::pVideoSession:
    case Field::pVideoSessionParameters:
    case Field::pVideoSessionParametersInfo:
    case Field::pView:
    case Field::pViewFormats:
    case Field::pViewMasks:
    case Field::pViewOffsets:
    case Field::pViewportDepths:
    case Field::pViewportState:
    case Field::pViewportSwizzles:
    case Field::pViewportWScalings:
    case Field::pViewports:
    case Field::pWaitDstStageMask:
    case Field::pWaitInfo:
    case Field::pWaitSemaphoreDeviceIndices:
    case Field::pWaitSemaphoreInfos:
    case Field::pWaitSemaphoreValues:
    case Field::pWaitSemaphores:
    case Field::pYcbcrConversion:
    case Field::pZirconHandle:
    case Field::pfnAllocation:
    case Field::pfnCallback:
    case Field::pfnFree:
    case Field::pfnGetInstanceProcAddr:
    case Field::pfnInternalAllocation:
    case Field::pfnInternalFree:
    case Field::pfnReallocation:
    case Field::pfnUserCallback:
    case Field::ppBuildRangeInfos:
    case Field::ppData:
    case Field::ppEnabledExtensionNames:
    case Field::ppEnabledLayerNames:
    case Field::ppGeometries:
    case Field::ppMaxPrimitiveCounts:
    case Field::ppUsageCounts:
    case Field::valueString:
        return true;
    default:
        return false;
    }
}
}  // namespace vvl
// clang-format on

// NOLINTEND
